/*----------------------------------------------------------------------------
 HMG - Harbour Windows GUI library source code

 Copyright 2002-2010 Roberto Lopez <mail.box.hmg@gmail.com>
 http://sites.google.com/site/hmgweb/

 This program is free software; you can redistribute it and/or modify it under 
 the terms of the GNU General Public License as published by the Free Software 
 Foundation; either version 2 of the License, or (at your option) any later 
 version. 

 This program is distributed in the hope that it will be useful, but WITHOUT 
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with 
 this software; see the file COPYING. If not, write to the Free Software 
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA (or 
 visit the web site http://www.gnu.org/).

 As a special exception, you have permission for additional uses of the text
 contained in this release of HMG.

 The exception is that, if you link the HMG library with other 
 files to produce an executable, this does not by itself cause the resulting 
 executable to be covered by the GNU General Public License.
 Your use of that executable is in no way restricted on account of linking the 
 HMG library code into it.

 Parts of this project are based upon:

	"Harbour GUI framework for Win32"
 	Copyright 2001 Alexander S.Kresin <alex@belacy.belgorod.su>
 	Copyright 2001 Antonio Linares <alinares@fivetech.com>
	www - http://www.harbour-project.org

	"Harbour Project"
	Copyright 1999-2008, http://www.harbour-project.org/

	"WHAT32"
	Copyright 2002 AJ Wos <andrwos@aust1.net>

	"HWGUI"
  	Copyright 2001-2008 Alexander S.Kresin <alex@belacy.belgorod.su>

---------------------------------------------------------------------------*/

#define BS_PUSHBUTTON		0
#define BS_DEFPUSHBUTTON	1
#define BM_SETSTYLE		244


#define BM_SETIMAGE	247
#define IMAGE_BITMAP	0

#define WM_NEXTDLGCTL	40

#define COLOR_BTNFACE	15
MEMVAR _HMG_SYSDATA
#include 'common.ch'
#define PBM_GETPOS 1032
#define BM_GETCHECK	240
#define BST_UNCHECKED	0
#define BST_CHECKED	1
#define BM_SETCHECK	241
#define EM_GETSEL	176
#define EM_SETSEL	177
#include 'hmg.ch'
#define TBM_SETPOS 1029
#define TBM_GETPOS 1024
#define PBM_SETPOS 1026
#define EM_SETBKGNDCOLOR	1091
Memvar aResult

*-----------------------------------------------------------------------------*
Function _Getvalue ( ControlName, ParentForm , Index )
*-----------------------------------------------------------------------------*
Local retval , h , t , x , c , d , bd , ix , auxval , WorkArea , BackRec , rcount , Tmp , Ts , BF

	retval := 0

	If Pcount() == 2

		If Upper (ControlName) == 'VSCROLLBAR'

			Return GetScrollPos ( GetFormHandle ( ParentForm )  , 1 )

		EndIf

		If Upper (ControlName) == 'HSCROLLBAR'

			Return GetScrollPos ( GetFormHandle ( ParentForm )  , 0 )

		EndIf

		T = GetControlType (ControlName,ParentForm)
		h = GetControlParentHandle (ControlName,ParentForm)
		c = GetControlHandle (ControlName,ParentForm)
		ix := GetControlIndex ( ControlName, ParentForm )

	Else

		T = _HMG_SYSDATA [1] [ Index ]
		h = _HMG_SYSDATA [4] [ Index ]
		c = _HMG_SYSDATA [3] [ Index ]
		ix := Index

	EndIf

	do case

	#ifdef COMPILEBROWSE

	case T == "BROWSE"

		retval := _BrowseGetValue ( '' , '' , ix )

	#endif

	case T == "PROGRESSBAR"

		retval := SendMessage( c, PBM_GETPOS, 0, 0)

	case T == "IPADDRESS"

		retval := GetIPAddress ( c )

	case T == "MONTHCAL"

		bd = Set (_SET_DATEFORMAT )

		SET DATE TO ANSI
		d = Alltrim( Str ( GetMOnthCalYear ( c ) ) ) + "." + Alltrim ( Str (GetMonthCalMonth ( c ) ) ) + "." + Alltrim (Str ( GetMonthCalDay( c ) ) )
		retval := ctod (d)
		Set (_SET_DATEFORMAT ,bd)

	case T == "TREE" 

		if _HMG_SYSDATA [  9 ] [ix] == .F.
			retval :=  aScan ( _HMG_SYSDATA [  7 ] [ ix ] , TreeView_GetSelection ( c ) )
		Else
			retval :=  TreeView_GetSelectionId ( c )
		EndIf

	case T == "MASKEDTEXT" 

		IF "E" $ _HMG_SYSDATA [  7 ] [ix] 

			Ts := GetWindowText ( c )

			If "." $ _HMG_SYSDATA [  7 ] [ix] 			
				Do Case
					Case At ( '.' , Ts ) >  At ( ',' , Ts )
						retval :=  GetNumFromText ( GetWindowText ( c )  , ix ) 
					Case At ( ',' , Ts ) > At ( '.' , Ts )
						retval :=  GetNumFromTextSp ( GetWindowText ( c )  , ix ) 
				EndCase
			Else
				Do Case
					Case At ( '.' , Ts ) !=  0
						retval :=  GetNumFromTextSp ( GetWindowText ( c )  , ix ) 
					Case At ( ',' , Ts )  != 0
						retval :=  GetNumFromText ( GetWindowText ( c )  , ix ) 
					OtherWise
						retval :=  GetNumFromText ( GetWindowText ( c )  , ix ) 
				EndCase
			EndIf
		ELSE
			retval :=  GetNumFromText ( GetWindowText ( c )  , ix ) 
		ENDIF

	case T == "TEXT" .or. T == "EDIT" .or. T == "LABEL"  .or. T == "CHARMASKTEXT" .or. T == "RICHEDIT"

		if t == "CHARMASKTEXT" 
			if valtype ( _HMG_SYSDATA [ 17 ] [ix] ) == 'L'
				if _HMG_SYSDATA [ 17 ] [ix] == .T.
					retval := CTOD ( alltrim ( GetWindowText ( c ) ) )
				Else
					retval := GetWindowText ( c )
				endif
			Else
				retval := GetWindowText ( c )
			endif
		Else
			retval := GetWindowText ( c )
		endif

	case T == "NUMTEXT" 

		retval := Int ( Val( GetWindowText(  c ) ) )

	case T == "SPINNER" 

		retval := GetSpinnerValue ( c [2] )

	case T == "CHECKBOX" 

		auxval := SendMessage( c , BM_GETCHECK , 0 , 0 )

		if auxval == BST_CHECKED
			retval	:= .t.
		ElseIf auxval == BST_UNCHECKED
			retval := .f.
		EndIf

	case T == "RADIOGROUP" 

		for x = 1 to len (c)

			auxval := SendMessage( c[x] , BM_GETCHECK , 0 , 0 )

			if auxval == BST_CHECKED
				retval	:= x
				exit
			EndIf

		next x

	case T == "COMBO" 

		If ValType ( _HMG_SYSDATA [ 22 ] [ix] ) == 'C'

			auxval := ComboGetCursel ( c )
			rcount := 0

			WorkArea := _HMG_SYSDATA [ 22 ] [ix]

			BackRec := (WorkArea)->(RecNo())
			(WorkArea)->(DBGoTop())	

			Do While ! (WorkArea)->(Eof())	 		
				rcount++
	        		if rcount == auxval

					If Empty ( _HMG_SYSDATA [ 33 ] [ix] )
						RetVal := (WorkArea)->(RecNo())
					Else
						Tmp := _HMG_SYSDATA [ 33 ] [ix]
						RetVal := &Tmp			
					EndIf

				EndIf
				(WorkArea)->(DBSkip())
			EndDo	      

			(WorkArea)->(DBGoTo(BackRec))	

		Else	
			retval := ComboGetCursel ( c )
		EndIf

	case T == "LIST" 
		retval := ListBoxGetCursel ( c )
	case T == "GRID" 

		IF _HMG_SYSDATA [32] [ix] == .T.

			retval := { _HMG_SYSDATA [ 39 ] [ix] , _HMG_SYSDATA [ 15 ] [ix] }

		ELSE

			retval := LISTVIEW_GETFIRSTITEM ( c )

		ENDIF

	case T == "TAB" 
		retval := TABCTRL_GETCURSEL ( c )
	case T == "DATEPICK" 

	     bf := set(2)
	     set(2,.f.)


		bd = Set (_SET_DATEFORMAT )

	        SET DATE TO ANSI
		d = Alltrim( Str ( GetDatePickYear ( c ) ) ) + "." + Alltrim ( Str ( GetDatePickMonth ( c ) ) ) + "." + Alltrim (Str ( GetDatePickDay ( c ) ) )
		retval := ctod (d)

		Set (_SET_DATEFORMAT ,bd)

	     set(2, bf )

	case T == "SLIDER" 

		retval := SendMessage( c, TBM_GETPOS, 0, 0)

	case T == "MULTILIST" 

		retval := ListBoxGetMultiSel (c)
	
	case T == "MULTIGRID" 

		retval := ListViewGetMultiSel (c)

	case T == "TOOLBUTTON"

		retval := IsToolButtonChecked( _HMG_SYSDATA [ 26 ] [ ix ]  , _HMG_SYSDATA [  8 ] [ix] - 1 )

	endcase


Return (retval)
*-----------------------------------------------------------------------------*
Function _Setvalue ( ControlName, ParentForm, Value , index )
*-----------------------------------------------------------------------------*
Local retval , h , t , x , c, y, r ,controlcount , backrec , workarea , rcount , aPos
Local TreeItemHandle , ix
Local z
Local aTemp
Local lEqual
Local xPreviousValue

	controlcount := len (_HMG_SYSDATA [  5 ])
	retval := 0
	r = 0

	if pcount() == 3

		ix = GetControlIndex (ControlName,ParentForm)

		t = _HMG_SYSDATA [1] [ix]
		h = _HMG_SYSDATA [4] [ix]
		c = _HMG_SYSDATA [3] [ix]

	Else

		t = _HMG_SYSDATA [1] [index]
		h = _HMG_SYSDATA [4] [index]
		c = _HMG_SYSDATA [3] [index]
		ix = index

	EndIf


	If ValType( Value ) == 'A'

		aTemp := _GetValue ( , , ix )

		If ValType ( aTemp ) == 'A'

			If Len( aTemp ) == Len( Value )

				lEqual	:= .T.

				For z := 1 To Len ( Value )
					If ValType(aTemp [z]) == ValType(Value [z])
						If aTemp [z] <> Value [z]
							lEqual := .F.
							Exit
						EndIf
					Else
						lEqual := .F.
						Exit
					EndIf
				Next z

				If lEqual == .T.
					Return Nil
				EndIf

			EndIf

		EndIf

	Else

		xPreviousValue := _GetValue ( , , ix )

		If ValType ( xPreviousValue ) == ValType ( Value )
			If xPreviousValue == value
				Return Nil
			EndIf
		EndIf

	EndIf


	do case

	#ifdef COMPILEBROWSE

	case T == "BROWSE"
	
		_BrowseSetValue ( '' , '' , value , ix )			

	#endif

	case T == "IPADDRESS"

		If Len( Value ) == 0
			ClearIpAddress( c )
		Else
			SetIPAddress( c , Value[1],Value[2],Value[3],Value[4] )
		EndIf

	case T == "MONTHCAL"

		SetMonthCal( c ,year(value), month(value), day(value) )

		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )

	case T == "TREE" 

		if _HMG_SYSDATA [  9 ] [ix] == .F.
			If Value > TreeView_GetCount ( c )
				Return Nil
			EndIf
		EndIf

		if _HMG_SYSDATA [  9 ] [ix] == .F.
			TreeItemHandle :=  _HMG_SYSDATA [  7 ] [ ix ] [ Value ]
		Else

			aPos := ascan ( _HMG_SYSDATA [ 25 ] [ix] , Value )

			If aPos == 0
				MsgHMGError ("Value Property: Invalid TreeItem Reference. Program Terminated")
			EndIf

			TreeItemHandle :=  _HMG_SYSDATA [  7 ] [ ix ] [ aPos ]

		EndIf

		TreeView_SelectItem ( c , TreeItemHandle )

	case T == "MASKEDTEXT" 

		If GetFocus() == c
			SetWindowText ( _HMG_SYSDATA [3] [ix] , Transform ( Value , _HMG_SYSDATA [  9 ] [ix] ) )
		Else
			SetWindowText ( _HMG_SYSDATA [3] [ix] , Transform ( value , _HMG_SYSDATA [  7 ][ix]) )  
		EndIf	

	CASE T == "TIMER"

		KillTimer ( _HMG_SYSDATA [4] [ix] , _HMG_SYSDATA [  5 ] [ix] )
		_HMG_SYSDATA [  8 ] [ix] := Value

		for x := 1 to ControlCount
		        if _HMG_SYSDATA [  5 ] [x] == _HMG_SYSDATA [  5 ] [ix]
				InitTimer ( GetFormHandle(ParentForm) , _HMG_SYSDATA [  5 ] [ix] , _HMG_SYSDATA [ 8 ] [ix] )
				exit	
			endif
		next x


	case T == "LABEL" 

		if _HMG_SYSDATA [ 22 ] [ix] == 1
			_SetControlWidth ( ControlName , ParentForm , GetTextWidth( NIL, Value , _HMG_SYSDATA [ 36 ] [ix] ) )
			_SetControlHeight ( ControlName , ParentForm , _HMG_SYSDATA [ 28 ] [ix] + 16 )
		EndIf

		SetWindowText ( c , value )

		if ValType ( _HMG_SYSDATA [  9 ] [ix] ) == 'L'
			If _HMG_SYSDATA [  9 ] [ix] == .T.
				RedrawWindowControlRect( h , _HMG_SYSDATA [ 18 ][ix] , _HMG_SYSDATA [ 19 ][ix] , _HMG_SYSDATA [ 18 ][ix] + _HMG_SYSDATA [ 21 ][ix] , _HMG_SYSDATA [ 19 ][ix] + _HMG_SYSDATA [ 20 ] [ix] )
			EndIf
		EndIf

	case T == "TEXT" .or. T == "EDIT" .or. T == "CHARMASKTEXT"  .or. T == "RICHEDIT"

		if t == "CHARMASKTEXT" 
			if valtype ( _HMG_SYSDATA [ 17 ] [ix] ) == 'L'
				if _HMG_SYSDATA [ 17 ] [ix] == .T.
					SetWindowText ( c , rtrim(dtoc(value)) )
				Else
					SetWindowText ( c , rtrim(value) )
				endif
			Else
				SetWindowText ( c , rtrim(value) )
			endif
		Else
			SetWindowText ( c , rtrim(value) )
		endif

		if T == "EDIT"

			_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )

		endif

	case T == "NUMTEXT" 

		SetWindowText ( c , Alltrim(Str(Int(value))) )

	case T == "SPINNER" 
		SetSpinnerValue ( c [2] , Value )

	case T == "CHECKBOX" 
		if value = .t.
	       	       	SendMessage( c , BM_SETCHECK  , BST_CHECKED , 0 )
		else
	       	       	SendMessage( c , BM_SETCHECK  , BST_UNCHECKED , 0 )
		endif

		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )

	case T == "RADIOGROUP" 

		for x = 1 to len (c)
	       	       	SendMessage( c[x] , BM_SETCHECK  , BST_UNCHECKED , 0 )
		next x

       	       	SendMessage( c[value] , BM_SETCHECK  , BST_CHECKED , 0 )

		if _HMG_SYSDATA [ 25 ] [ix] == .F. .and. IsTabStop( c[value] )
			SetTabStop( c[value] , .f. )
		endif

		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )

	case T == "COMBO" 

		If ValType ( Value ) != 'N'
			MsgHMGError('COMBOBOX: Value property wrong type (only numeric allowed). Program terminated')
		EndIf

		If ValType ( _HMG_SYSDATA [ 22 ] [ix] ) == 'C'
			_HMG_SYSDATA [  8 ] [ix] := value
			WorkArea := _HMG_SYSDATA [ 22 ] [ix]
		        rcount := 0
			BackRec := (WorkArea)->(RecNo())
			(WorkArea)->(DBGoTop())	
			Do While ! (WorkArea)->(Eof())	 		
				rcount++
	        		if value == (WorkArea)->(RecNo())
					Exit
				EndIf
				(WorkArea)->(DBSkip())
			EndDo	      
			(WorkArea)->(DBGoTo(BackRec))	
			ComboSetCurSel ( c ,rcount)
		Else
			ComboSetCursel ( c , value )
		EndIf

		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )

	case T == "LIST" 
		ListBoxSetCursel ( c , value )
		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )
	case T == "GRID" 

		IF _HMG_SYSDATA [32] [ix] == .F.

			ListView_SetCursel ( c, value )
			ListView_EnsureVisible( C , VALUE )

		ELSE

			IF VALTYPE ( VALUE ) == 'A'

				IF VALUE [1] == 0 .OR. VALUE [2] == 0

					_HMG_SYSDATA [ 39 ] [ix] := 0
					_HMG_SYSDATA [ 15 ] [ix] := 0

					REDRAWWINDOW(C)

					_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )

				ELSE

					IF	_HMG_SYSDATA [ 39 ] [ix] <> value [1]	;
						.OR.					;
						_HMG_SYSDATA [ 15 ] [ix] <> value [2]	

						ListView_SetCursel ( c, value [1] )
						ListView_EnsureVisible( C , VALUE [1] )

						_HMG_SYSDATA [ 39 ] [ix] := value [1]
						_HMG_SYSDATA [ 15 ] [ix] := value [2]

						_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )

						redrawwindow ( _HMG_SYSDATA [ 3 ] [ix] )

					ENDIF

				ENDIF

			ENDIF

		ENDIF

	case T == "TAB" 
		TABCTRL_SETCURSEL ( c , value )

		y := GetControlIndex (ControlName , ParentForm )

		UpdateTab (y)

		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [y] , y )

	case T == "DATEPICK" 
		If Empty (Value)
			SetDatePickNull(c)
		Else
			SetDatePick( c ,year(value), month(value), day(value) )
		EndIf
		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )
	case T == "PROGRESSBAR" 
		SendMessage(c, PBM_SETPOS,value,0)
	case T == "SLIDER" 
		SendMessage( c , TBM_SETPOS ,1,  value )
		_DoControlEventProcedure ( _HMG_SYSDATA [ 12 ] [ix] , ix )
	case T == "STATUS" 
        	SetStatus( C , value )
	case T == "MULTILIST" 
		LISTBOXSETMULTISEL ( c , value )
	case T == "MULTIGRID"
		LISTVIEWSETMULTISEL ( c , value )
		
		If Len (value) > 0
			ListView_EnsureVisible( C , VALUE [1] )
		EndIf

	case T == "TOOLBUTTON"

		CheckToolButton( _HMG_SYSDATA [ 26 ] [ ix ]  , _HMG_SYSDATA [  8 ] [ix] - 1 , value )

	endcase
	
Return (retval)

*-----------------------------------------------------------------------------*
Function _AddItem ( ControlName, ParentForm, Value , Parent, aImage , Id )
*-----------------------------------------------------------------------------*
Local t , c , NewHandle , TempHandle , i , ix , aPos , ChildHandle , BackHandle , ParentHandle
Local TreeItemHandle
// Tree+
Local 	ImgDef, iUnSel, iSel

	ix := GetControlIndex (ControlName , ParentForm )
	
	T = _HMG_SYSDATA [1] [ix]

	c = _HMG_SYSDATA [3] [ix]

	If ValType ( Id ) == 'U'
		Id := 0
	EndIf

	If ValType ( aImage ) == 'N'
		Id := aImage
	EndIf

	do case
	case T == "TREE" 

		if _HMG_SYSDATA [  9 ] [ix] == .F.

			If Parent > TreeView_GetCount ( c ) .or. Parent < 0
				MsgHMGError ("Additem Method:  Invalid Parent Value. Program Terminated" )
			EndIf

		EndIf

		ImgDef := iif( valtype( aImage ) == "A" , len( aImage ), 0 )  //Tree+

		if Parent != 0

			if _HMG_SYSDATA [  9 ] [ix] == .F.
				TreeItemHandle := _HMG_SYSDATA [  7 ] [ ix ] [ Parent ]
			Else
				aPos := ascan ( _HMG_SYSDATA [ 25 ] [ix] , Parent )

				If aPos == 0
					MsgHMGError ("Additem Method: Invalid Parent Value. Program Terminated" )
				EndIf

				TreeItemHandle := _HMG_SYSDATA [  7 ] [ ix ] [ aPos ]

			EndIf
			
			if ImgDef == 0
					
				iUnsel := 2	// Pointer to defalut Node Bitmaps, no Bitmap loaded
				iSel   := 3
			else	
				iUnSel := AddTreeViewBitmap( c, aImage[1] ) -1 
				iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( c, aImage[2] ) -1 )
				// If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
			endif

			NewHandle := AddTreeItem ( c , TreeItemHandle , Value, iUnsel, iSel , Id )

                        * Determine Position of New Item

			TempHandle := TreeView_GetChild ( c , TreeItemHandle )			

			i := 0

			Do While .t.

				i++

				If TempHandle == NewHandle 
					Exit
				EndIf
			
				ChildHandle := TreeView_GetChild ( c , TempHandle )

				If ChildHandle == 0
					BackHandle := TempHandle
					TempHandle := TreeView_GetNextSibling ( c , TempHandle )
				Else
					i++
					BackHandle := Childhandle
					TempHandle := TreeView_GetNextSibling ( c , ChildHandle )
				EndIf

				Do While TempHandle == 0

					ParentHandle := TreeView_GetParent ( c , BackHandle )

					TempHandle := TreeView_GetNextSibling ( c , ParentHandle )

					If TempHandle == 0 
						BackHandle := ParentHandle
					EndIf

				EndDo

			EndDo

			* Resize Array

			aSize ( _HMG_SYSDATA [  7 ] [ ix ] , TreeView_GetCount ( c ) )
			aSize ( _HMG_SYSDATA [ 25 ] [ ix ] , TreeView_GetCount ( c ) )

			* Insert New Element

			if _HMG_SYSDATA [  9 ] [ix] == .F.
				aIns ( _HMG_SYSDATA [  7 ] [ ix ] , Parent + i  )
				aIns ( _HMG_SYSDATA [ 25 ] [ ix ] , Parent + i  )
			Else
				aIns ( _HMG_SYSDATA [  7 ] [ ix ] , aPos + i )
				aIns ( _HMG_SYSDATA [ 25 ] [ ix ] , aPos + i )
			EndIf

			* Assign Handle

			if _HMG_SYSDATA [  9 ] [ix] == .F.
				_HMG_SYSDATA [  7 ] [ ix ] [ Parent + i ] := NewHandle
				_HMG_SYSDATA [ 25 ] [ ix ] [ Parent + i ] := Id
			Else

				If ascan ( _HMG_SYSDATA [ 25 ] [ ix ] , Id ) != 0
					MsgHMGError ("Additem Method:  Item Id "+alltrim(str(Id))+" Already In Use. Program Terminated" )
				EndIf

				_HMG_SYSDATA [  7 ] [ ix ] [ aPos + i ] := NewHandle
				_HMG_SYSDATA [ 25 ] [ ix ] [ aPos + i ] := Id

			EndIf

		Else
			TreeItemHandle := 0
			
			if ImgDef == 0
					
				iUnsel := 0	// Pointer to defalut Node Bitmaps, no Bitmap loaded
				iSel   := 1
			else	
				iUnSel := AddTreeViewBitmap( c, aImage[1] ) -1 
				iSel   := iif( ImgDef == 1, iUnSel, AddTreeViewBitmap( c, aImage[2] ) -1 )
				// If only one bitmap in array iSel = iUnsel, only one Bitmap loaded
			endif

			NewHandle := AddTreeItem ( c , 0 , Value, iUnsel, iSel , Id )

			aadd ( _HMG_SYSDATA [  7 ] [ ix ] , NewHandle ) 

			if _HMG_SYSDATA [  9 ] [ix] == .T.

				If ascan ( _HMG_SYSDATA [ 25 ] [ ix ] , Id ) != 0
					MsgHMGError ("Additem Method:  Item Id Already In Use. Program Terminated" )
				EndIf

			EndIf

			aadd ( _HMG_SYSDATA [ 25 ] [ ix ] , Id ) 

		EndIf

	case T == "COMBO" 

		If ValType ( Value ) == 'A'
			ImageComboAddItem ( c , value[1] , value[2] , -1 )
		Else
			ComboAddString ( c , value )
		EndIf

	case T == "LIST" .or. T == "MULTILIST"
		ListBoxAddstring ( c , value )
	case T == "GRID" .or. T == "MULTIGRID"

		IF _HMG_SYSDATA [ 40 ] [ ix ] [ 9 ] == .F.
	        	_AddGridRow ( ControlName, ParentForm, value )
		ENDIF

	endcase

Return Nil

*-----------------------------------------------------------------------------*
Function _DeleteItem ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*
Local t , c , BeforeCount , AfterCount , DeletedCount , i , ix , aPos
Local TreeItemHandle

	ix := GetControlIndex (ControlName,ParentForm)

	T = _HMG_SYSDATA [1] [ix]
	c = _HMG_SYSDATA [3] [ix]

	do case
	case T == "TREE" 

		BeforeCount := TreeView_GetCount ( c )

		if _HMG_SYSDATA [  9 ] [ix] == .F.

			If Value > BeforeCount .or. Value < 1
				MsgHMGError ("DeleteItem Method: Invalid Item Specified. Program Terminated" )
			EndIf

			TreeItemHandle := _HMG_SYSDATA [  7 ] [ ix ] [ Value ]
			TreeView_DeleteItem ( c , TreeItemHandle )

		Else

			aPos := ascan ( _HMG_SYSDATA [ 25 ] [ix] , Value )

			If aPos == 0
				MsgHMGError ("DeleteItem Method: Invalid Item Id. Program Terminated" )
			EndIf

			TreeItemHandle := _HMG_SYSDATA [  7 ] [ ix ] [ aPos ]
			TreeView_DeleteItem ( c , TreeItemHandle )

		EndIf

		AfterCount := TreeView_GetCount ( c )

		DeletedCount := BeforeCount - AfterCount

		if _HMG_SYSDATA [  9 ] [ix] == .F.

			If DeletedCount == 1

				Adel ( _HMG_SYSDATA [  7 ] [ ix ] , Value )

			Else

				For i := 1 To DeletedCount
					Adel ( _HMG_SYSDATA [  7 ] [ ix ] , Value )
				Next i

			EndIf

		Else

			If DeletedCount == 1

				Adel ( _HMG_SYSDATA [  7 ] [ ix ] , aPos )
				Adel ( _HMG_SYSDATA [ 25 ] [ ix ] , aPos )

			Else

				For i := 1 To DeletedCount
					Adel ( _HMG_SYSDATA [  7 ] [ ix ] , aPos )
					Adel ( _HMG_SYSDATA [ 25 ] [ ix ] , aPos )
				Next i

			EndIf

		EndIf

		aSize ( _HMG_SYSDATA [  7 ] [ ix ] , AfterCount )
		aSize ( _HMG_SYSDATA [ 25 ] [ ix ] , AfterCount )

	case T == "LIST" .OR. T == "MULTILIST"
		ListBoxDeleteString ( c , value )		
	case T == "COMBO" 
		ComboBoxDeleteString ( c , value )				
		RedrawWindow( c )
	case T == "GRID" .OR. T == "MULTIGRID"

		IF _HMG_SYSDATA [ 40 ] [ ix ] [ 9 ] == .F.

			IF _HMG_SYSDATA [32] [ix] == .T. .AND. T == "GRID" 

				IF _HMG_SYSDATA [ 39 ] [ix] == value

					ListViewDeleteString ( c , value )		
					_HMG_DOGRIDREFRESH(IX)

					_HMG_SYSDATA [ 39 ] [ix] := 0
					_HMG_SYSDATA [ 15 ] [ix] := 0

				ELSEIF	_HMG_SYSDATA [ 39 ] [ix] > value

					ListViewDeleteString ( c , value )		
					_HMG_DOGRIDREFRESH(IX)

					_HMG_SYSDATA [ 39 ] [ix] --

				ELSE
		
					ListViewDeleteString ( c , value )		
					_HMG_DOGRIDREFRESH(IX)

				ENDIF

			ELSE

					ListViewDeleteString ( c , value )		
					_HMG_DOGRIDREFRESH(IX)

			ENDIF

		ENDIF

	endcase

Return Nil 

*-----------------------------------------------------------------------------*
Function _DeleteAllItems ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local t , c , i 
	
	i = GetControlIndex (ControlName,ParentForm)

	T = _HMG_SYSDATA [1] [i]
	c = _HMG_SYSDATA [3] [i]

	do case

	case T == "TREE" 
		TreeView_DeleteAllItems ( c )
		aSize ( _HMG_SYSDATA [  7 ] [ i ] , 0 )
		aSize ( _HMG_SYSDATA [ 25 ] [ i ] , 0 )

	case T == "LIST" .OR. T == "MULTILIST"
		ListBoxReset ( c )		
	case T == "COMBO" 
		ComboBoxReset ( c )		
	case T == "GRID" .OR. T == "MULTIGRID"

		IF _HMG_SYSDATA [ 40 ] [ i ] [ 9 ] == .F.

			ListViewReset ( c )		

			IF _HMG_SYSDATA [32] [i] == .T. .AND. T == "GRID"
				_HMG_SYSDATA [ 15 ] [i] := 0
				_HMG_SYSDATA [ 39 ] [i] := 0
			ENDIF

			_HMG_DOGRIDREFRESH(I)

		ENDIF

	endcase

Return Nil 

*-----------------------------------------------------------------------------*
Function GetControlIndex (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar 
	mVar := '_' + ParentForm + '_' + ControlName
Return ( &mVar )
*-----------------------------------------------------------------------------*
Function GetControlName (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName
	i := &mVar
	if i == 0
		Return ''
	EndIf

Return (_HMG_SYSDATA [2] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlHandle (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

Return (_HMG_SYSDATA [3] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlContainerHandle (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

Return (_HMG_SYSDATA [ 26 ] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlParentHandle (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

Return (_HMG_SYSDATA [4] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlId (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

Return (_HMG_SYSDATA [  5 ] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlType (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return ''
	EndIf

Return (_HMG_SYSDATA [1] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlValue (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return Nil
	EndIf

Return (_HMG_SYSDATA [  8 ] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function GetControlPageMap (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return {}
	EndIf

Return (_HMG_SYSDATA [  7 ] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function _IsControlDefined ( ControlName , FormName)
*-----------------------------------------------------------------------------*
Local mVar , i , r

mVar := '_' + FormName + '_' + ControlName

if type ( mVar ) = 'U'
	Return (.F.)
EndIf
if type ( mVar ) = 'N'
	i := &mVar
	if i == 0
		Return .f.
	EndIf
	r :=  _HMG_SYSDATA [ 13 ]  [ i ]
	r := .Not. r
	Return (r)
EndIf

Return .F.

*-----------------------------------------------------------------------------*
Function _SetFocus ( ControlName , ParentForm , ix )
*-----------------------------------------------------------------------------*
Local H , T , MaskStart , X , i , j , p , L , F


	
	if pcount() == 2

		i := GetControlIndex ( ControlName,ParentForm )

		H = GetControlHandle( ControlName , ParentForm )
		T = GetControlType (ControlName,ParentForm)

	else

		i := ix

		H := _HMG_SYSDATA [ 3 ] [ ix ]

		T := _HMG_SYSDATA [ 1 ] [ ix ]

	endif


		DO CASE

		CASE T == 'TEXT' .Or. T == 'NUMTEXT' .Or. T == 'MASKEDTEXT' 
			setfocus( H )
			SendMessage ( H , 177 , 0 , -1 ) // EM_SETSEL

		CASE T == "CHARMASKTEXT"

			setfocus( H )

			For x := 1 To Len (_HMG_SYSDATA [  9 ] [i])
				If IsDigit(SubStr ( _HMG_SYSDATA [  9 ] [i] , x , 1 )) .Or. IsAlpha(SubStr ( _HMG_SYSDATA [  9 ] [i] , x , 1 )) .Or. SubStr ( _HMG_SYSDATA [  9 ] [i] , x , 1 ) == '!'
					MaskStart := x
					Exit
				EndIf   	
			Next x

			If MaskStart == 1
			      	SendMessage( H , EM_SETSEL , 0 , -1 )
			Else
		      		SendMessage( H , EM_SETSEL , MaskStart - 1 , -1 )
			EndIf

		CASE T == 'BUTTON'

			IF _HMG_SYSDATA [ 38 ] [i] == .T.

				L := LEN ( _HMG_SYSDATA [1] )

				*F := GetFormHandle( ParentForm )

				F := _HMG_SYSDATA [ 4 ] [ i ]

				FOR J := 1 TO L

					If _HMG_SYSDATA [1] [J] == 'BUTTON'

						IF _HMG_SYSDATA [4] [J] == F

							SendMessage  ( _HMG_SYSDATA [3] [J] , BM_SETSTYLE , LOWORD ( BS_PUSHBUTTON ) , 1 )
							RedrawWindow ( _HMG_SYSDATA [3] [J] )

						ENDIF

					ENDIF

				NEXT

				setfocus( H )
				SendMessage ( H , BM_SETSTYLE , LOWORD ( BS_DEFPUSHBUTTON ) , 1 )

			ENDIF

		CASE T == 'SPINNER'
			setfocus( H [1] )
		CASE T == 'RADIO'
			setfocus( H [1] )
		OTHERWISE
			setfocus( H )
		ENDCASE

		_HMG_SYSDATA [ 251 ] := .T.

Return Nil
*-----------------------------------------------------------------------------*
Function _DisableControl ( ControlName , ParentForm )
*-----------------------------------------------------------------------------*
Local H,T,i,c , y , s , z , w , Newhandle

	T := GetControlType (ControlName,ParentForm)
	i := GetControlId (ControlName,ParentForm)
	h := GetControlParentHandle (ControlName,ParentForm)
	c := GetControlHandle (ControlName,ParentForm)
	y := GetControlIndex (ControlName,ParentForm)

	DO CASE

	#ifdef COMPILEBROWSE

	CASE T == "BROWSE"
		DisableWindow ( c )
		If _HMG_SYSDATA [  5 ][y] != 0
			DisableWindow ( _HMG_SYSDATA [  5 ][y] )
		EndIf

	#endif

	CASE T == "TOOLBUTTON"
		_DisableToolBarButton ( ControlName , ParentForm )
	CASE T == "MENU" .OR. T == "POPUP"
		_DisableMenuItem ( ControlName , ParentForm )
	CASE T == "TIMER"
		KillTimer ( h , i )
	CASE T == "SPINNER"
		DisableWindow ( c [1] )
		DisableWindow ( c [2] )
	CASE T == "RADIOGROUP"
		For i := 1 To Len (c)
			DisableWindow ( c [i] )
		Next i

	CASE T == "TAB"

		DisableWindow ( c )

		s = TabCtrl_GetCurSel (_HMG_SYSDATA [3] [y] )
		for w = 1 to len (_HMG_SYSDATA [  7 ] [y] [s])
			if valtype (_HMG_SYSDATA [  7 ] [y] [s] [w]) <> "A"
				DisableWindow ( _HMG_SYSDATA [  7 ] [y] [s] [w] )
			else
				for z = 1 to len ( _HMG_SYSDATA [  7 ] [y] [s] [w] )
   	        	                DisableWindow ( _HMG_SYSDATA [  7 ] [y] [s] [w] [z] )
				next z
			endif
		Next w

	CASE T == "BUTTON"

		if _HMG_SYSDATA [ 38 ] [y] == .T.

			SendMessage  ( c , BM_SETSTYLE , LOWORD ( BS_PUSHBUTTON ) , 1 )
			RedrawWindow ( c )

			IF _HMG_SYSDATA [ 22 ] [y] == 'T'

				DisableWindow ( c )

			ELSE

				if	(_HMG_SYSDATA [ 22 ] [y] == 'M' ) ;
					.Or.;
					(_HMG_SYSDATA [ 22 ] [y] == 'I' .And. ( IsAppThemed()  ) )

					IMAGELIST_DESTROY ( _HMG_SYSDATA [ 37 ] [y] ) 
					_SetMixedBtnPictureDisabled( c , y )
					redrawwindow (c)
					DisableWindow ( c )

				else

					NewHandle := GetDisabledBitmap( c , _HMG_SYSDATA [ 37 ] [y] )

					SendMessage(c,BM_SETIMAGE,IMAGE_BITMAP,NewHandle)

					DeleteObject (_HMG_SYSDATA [ 37 ] [y])

					_HMG_SYSDATA [ 37 ] [y] := NewHandle

					DisableWindow ( c )

				endif

			ENDIF

		EndIf

	CASE T == "CHECKBOX"

		if _HMG_SYSDATA [ 38 ] [y] == .T.

			if	_HMG_SYSDATA [ 39 ] [y]	== 1

				if IsAppThemed() 

					IMAGELIST_DESTROY ( _HMG_SYSDATA [ 37 ] [y] ) 
					_SetMixedBtnPictureDisabled( c , y )
					DisableWindow ( c )

				else

					NewHandle := GetDisabledBitmap( c , _HMG_SYSDATA [ 37 ] [y] )

					SendMessage(c,BM_SETIMAGE,IMAGE_BITMAP,NewHandle)

					DeleteObject (_HMG_SYSDATA [ 37 ] [y])

					_HMG_SYSDATA [ 37 ] [y] := NewHandle

					DisableWindow ( c )

				endif

			else

				DisableWindow ( c )

			endif

		EndIf

	OTHERWISE
		DisableWindow ( c )
	ENDCASE

	_HMG_SYSDATA [ 38 ] [y] := .F.

Return Nil
*-----------------------------------------------------------------------------*
Function _EnableControl ( ControlName,ParentForm )
*-----------------------------------------------------------------------------*
Local H,t,i,c,x,controlcount , y , s , z , w , n

	controlcount := len (_HMG_SYSDATA [2])

	T = GetControlType (ControlName,ParentForm)
	i = GetControlId (ControlName,ParentForm)
	h = GetControlParentHandle (ControlName,ParentForm)
	c = GetControlHandle (ControlName,ParentForm)
	y := GetControlIndex (ControlName,ParentForm)


	DO CASE

	#ifdef COMPILEBROWSE

	CASE T == "BROWSE"
		EnableWindow ( c )
		If _HMG_SYSDATA [  5 ][y] != 0
			EnableWindow ( _HMG_SYSDATA [  5 ][y] )
		EndIf

	#endif

	CASE T == "TOOLBUTTON"
		_EnableToolBarButton ( ControlName , ParentForm )
	CASE T == "MENU" .OR. T == "POPUP"
		_EnableMenuItem ( ControlName , ParentForm )

	CASE T == "TIMER"
		for x :=1 to controlcount
		        if _HMG_SYSDATA [  5 ] [x] == i
				InitTimer ( GetFormHandle(ParentForm) , _HMG_SYSDATA [  5 ] [x] , _HMG_SYSDATA [  8 ] [x] )
				exit
			endif
		next x
	CASE T == "SPINNER"
		EnableWindow ( c [1] )
		EnableWindow ( c [2] )
	CASE T == "RADIOGROUP"
		For i := 1 To Len (c)
			EnableWindow ( c [i] )
		Next i

	CASE T == "TAB"

		EnableWindow ( c )

		s = TabCtrl_GetCurSel (_HMG_SYSDATA [3] [y] )
		for w = 1 to len (_HMG_SYSDATA [  7 ] [y] [s])
			if valtype (_HMG_SYSDATA [  7 ] [y] [s] [w]) <> "A"
				EnableWindow ( _HMG_SYSDATA [  7 ] [y] [s] [w] )
			else
				for z = 1 to len ( _HMG_SYSDATA [  7 ] [y] [s] [w] )
   	        	                EnableWindow ( _HMG_SYSDATA [  7 ] [y] [s] [w] [z] )
				next z
			endif
		Next w

	CASE T == "BUTTON"

		If _HMG_SYSDATA [ 38 ] [y] == .F.

			IF	_HMG_SYSDATA [ 22 ] [y] == 'T'

				EnableWindow( c )

			ELSE

				if	(_HMG_SYSDATA [ 22 ] [y] == 'M') ;
					.Or.;
					(_HMG_SYSDATA [ 22 ] [y] == 'I'.and. (isAppThemed()  ) )

					IMAGELIST_DESTROY ( _HMG_SYSDATA [ 37 ] [y] ) 
					_HMG_SYSDATA [ 37 ] [y] := _SetMixedBtnPicture ( _HMG_SYSDATA [3] [y] , _HMG_SYSDATA [ 25 ] [y] , _HMG_SYSDATA [26] [y] )
					ReDrawWindow (_HMG_SYSDATA [3] [y])

					EnableWindow( c )

				else

					EnableWindow( c )
					DeleteObject ( _HMG_SYSDATA [ 37 ] [y] )
					_HMG_SYSDATA [ 37 ] [y] := _SETBTNPICTURE ( c , _HMG_SYSDATA [ 25 ] [y] )

				endif

			ENDIF

		EndIf

	CASE T == "CHECKBOX"

		If _HMG_SYSDATA [ 38 ] [y] == .F.

			if	_HMG_SYSDATA [ 39 ] [y]	== 1

				if IsAppThemed() 

					IMAGELIST_DESTROY ( _HMG_SYSDATA [ 37 ] [y] ) 
					_HMG_SYSDATA [ 37 ] [y] := _SetMixedBtnPicture ( _HMG_SYSDATA [3] [y] , _HMG_SYSDATA [ 25 ] [y] , _HMG_SYSDATA [26] [y] )
					ReDrawWindow (_HMG_SYSDATA [3] [y])

					EnableWindow ( c )

				else

					EnableWindow ( c )
					DeleteObject ( _HMG_SYSDATA [ 37 ] [y] )
					_HMG_SYSDATA [ 37 ] [y] := _SETBTNPICTURE ( c , _HMG_SYSDATA [ 25 ] [y] )

				endif

			else

				EnableWindow ( c )

			endif

		EndIf

	OTHERWISE
		EnableWindow ( c )
	ENDCASE

	_HMG_SYSDATA [ 38 ] [y] := .T.
	
Return Nil
*-----------------------------------------------------------------------------*
Function _ShowControl ( ControlName,ParentForm )
*-----------------------------------------------------------------------------*
Local t,i,c,w,s,y,z,r
Local TabHide := .f.

	T = GetControlType (ControlName,ParentForm)

	c = GetControlHandle (ControlName,ParentForm)

	y := GetControlIndex (ControlName,ParentForm)

	if _HMG_SYSDATA [ 34 ] [y] == .t.
		Return Nil
	EndIf

******************************************************************************

	// If the control is inside a TAB and the page is not visible,
	// the control must not be showed

	For i := 1 To Len ( _HMG_SYSDATA [  7 ] )

		if _HMG_SYSDATA [1] [i] == "TAB"

			s = TabCtrl_GetCurSel (_HMG_SYSDATA [3] [i] )

			for r = 1 to len ( _HMG_SYSDATA [  7 ] [i] )

				for w = 1 to len (_HMG_SYSDATA [  7 ] [i] [r])

					if t == 'RADIOGROUP'

					        if ValType (_HMG_SYSDATA [  7 ] [i] [r] [w]) == 'A'

							if _HMG_SYSDATA [  7 ] [i] [r] [w] [1] == _HMG_SYSDATA [3] [y] [1]

							        if r != s
									TabHide := .T.
								EndIf

								Exit

							EndIf

						EndIf

					Elseif t == 'SPINNER'

					        if ValType (_HMG_SYSDATA [  7 ] [i] [r] [w]) == 'A'

							if _HMG_SYSDATA [  7 ] [i] [r] [w] [1] == _HMG_SYSDATA [3] [y] [1]

							        if r != s
									TabHide := .T.
								EndIf

								Exit

							EndIf

						EndIf

					#ifdef COMPILEBROWSE

					Elseif t == 'BROWSE'

					        if ValType (_HMG_SYSDATA [  7 ] [i] [r] [w]) == 'A'

							if _HMG_SYSDATA [  7 ] [i] [r] [w] [1] == _HMG_SYSDATA [3] [y]

							        if r != s
									TabHide := .T.
								EndIf

								Exit

							EndIf

					        Elseif ValType (_HMG_SYSDATA [  7 ] [i] [r] [w]) == 'N'

							if _HMG_SYSDATA [  7 ] [i] [r] [w] == _HMG_SYSDATA [3] [y]

							        if r != s
									TabHide := .T.
								EndIf

								Exit

							EndIf

						EndIf

					#endif

					Else

					        if ValType (_HMG_SYSDATA [  7 ] [i] [r] [w]) == 'N'

							if _HMG_SYSDATA [  7 ] [i] [r] [w] == _HMG_SYSDATA [3] [y]

							        if r != s
									TabHide := .T.
								EndIf

								Exit

							EndIf

						EndIf

					EndIf

				Next w

			next r

		EndIf

	Next i

	if TabHide == .T.
		_HMG_SYSDATA [ 34 ] [y] := .t.
		Return Nil
	EndIf

******************************************************************************

	if T == "SPINNER"
		CShowControl ( c [1] )
		CShowControl ( c [2] )
		_HMG_SYSDATA [ 34 ] [y] := .t.

	#ifdef COMPILEBROWSE

	ElseIf T == "BROWSE"
		CShowControl ( c )
		If _HMG_SYSDATA [  5 ][y] != 0
			CShowControl ( _HMG_SYSDATA [  5 ][y] )
		EndIf
		If _HMG_SYSDATA [ 39 ][y] [1] != 0
			CShowControl ( _HMG_SYSDATA [ 39 ][y] [1])
		EndIf
		_HMG_SYSDATA [ 34 ] [y] := .t.

	#endif

	Elseif T == "TAB"

		CShowControl ( c )

		s = TabCtrl_GetCurSel (_HMG_SYSDATA [3] [y] )
		for w = 1 to len (_HMG_SYSDATA [  7 ] [y] [s])
			if valtype (_HMG_SYSDATA [  7 ] [y] [s] [w]) <> "A"
				CShowControl ( _HMG_SYSDATA [  7 ] [y] [s] [w] ) 
			else
				for z = 1 to len ( _HMG_SYSDATA [  7 ] [y] [s] [w] )
   	        	                CShowControl ( _HMG_SYSDATA [  7 ] [y] [s] [w] [z] ) 
				next z
			endif
		Next w
		_HMG_SYSDATA [ 34 ] [y] := .t.

	Elseif T == "RADIOGROUP"

		For i:= 1 To Len(c)

			CShowControl ( c [i] )

		Next i
		_HMG_SYSDATA [ 34 ] [y] := .t.
	Else
		CShowControl ( c )
		_HMG_SYSDATA [ 34 ] [y] := .t.
	EndIf

	redrawwindow(c)

Return Nil
*-----------------------------------------------------------------------------*
Function _HideControl ( ControlName,ParentForm )
*-----------------------------------------------------------------------------*
Local t,c,i,y,r,w,z

	T = GetControlType (ControlName,ParentForm)

	c = GetControlHandle (ControlName,ParentForm)

	y := GetControlIndex (ControlName,ParentForm)

	if T == "SPINNER"
		HideWindow ( c [1] )
		HideWindow ( c [2] )
		_HMG_SYSDATA [ 34 ] [y] := .f.

	#ifdef COMPILEBROWSE

	ElseIf T == "BROWSE"
		HideWindow ( c )
		If _HMG_SYSDATA [  5 ][y] != 0
			HideWindow ( _HMG_SYSDATA [  5 ][y] )
		EndIf
		If _HMG_SYSDATA [ 39 ][y] [1] != 0
			HideWindow ( _HMG_SYSDATA [ 39 ][y] [1])
		EndIf
		_HMG_SYSDATA [ 34 ] [y] := .f.

	#endif

	Elseif T == "TAB"

		HideWindow ( c )

		for r = 1 to len ( _HMG_SYSDATA [  7 ] [y] )
			for w = 1 to len (_HMG_SYSDATA [  7 ] [y] [r])
				if valtype ( _HMG_SYSDATA [  7 ] [y] [r] [w] ) <> "A"
					HideWindow ( _HMG_SYSDATA [  7 ] [y] [r] [w] ) 
	               	        else
					for z = 1 to len ( _HMG_SYSDATA [  7 ] [y] [r] [w] )
                	               	        HideWindow ( _HMG_SYSDATA [  7 ] [y] [r] [w] [z] ) 
					Next z
				endif
			Next w
		Next r

		_HMG_SYSDATA [ 34 ] [y] := .f.

	Elseif T == "RADIOGROUP"

		For i:= 1 To Len(c)

			HideWindow ( c [i] )

		Next i

		_HMG_SYSDATA [ 34 ] [y] := .f.

	Elseif T == "COMBO"

		SendMessage ( c , 335 , 0 , 0 )
		HideWindow ( c )
		_HMG_SYSDATA [ 34 ] [y] := .f.

	Else
		HideWindow ( c )
		_HMG_SYSDATA [ 34 ] [y] := .f.
	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _SetItem ( ControlName, ParentForm, Item , Value , index )
*-----------------------------------------------------------------------------*
Local t , c , i , aPos
Local TreeHandle, ItemHandle
LOCAL AEDITCONTROLS
LOCAL CI
LOCAL XRES
LOCAL ATEMP
LOCAL AEC
LOCAL CTYPE
LOCAL CINPUTMASK
LOCAL CFORMAT
LOCAL AITEMS
LOCAL ARANGE
LOCAL DTYPE
LOCAL ALABELS
LOCAL bd
Local nCurrentValue

	if pcount() == 5
		i = index
	else
		i = GetControlIndex (ControlName,ParentForm)
	endif

	T = _HMG_SYSDATA [1] [i]
	c = _HMG_SYSDATA [3] [i]

	do case
	case t == 'TREE'

		if _HMG_SYSDATA [  9 ] [i] == .F.
			If Item > TreeView_GetCount ( c ) .or. Item < 1
				MsgHMGError ("Item Property: Invalid Item Reference. Program Terminated" )
			EndIf
		EndIf

		TreeHandle := c

		if _HMG_SYSDATA [  9 ] [i] == .F.
			ItemHandle := _HMG_SYSDATA [  7 ] [ i ] [ Item ]
		Else

			aPos := ascan ( _HMG_SYSDATA [ 25 ] [i] , Item )

			If aPos == 0
				MsgHMGError ("Item Property: Invalid Item Id. Program Terminated" )
			EndIf

			ItemHandle := _HMG_SYSDATA [  7 ] [ i ] [ aPos ]

		EndIf

		TreeView_SetItem ( TreeHandle , ItemHandle , Value )

	case T == "LIST" .Or. T == "MULTILIST"
		nCurrentValue := ListBoxGetCursel ( c )
		ListBoxDeleteString ( c , Item )		
		ListBoxInsertString ( c , value , Item )
		ListBoxSetCursel ( c , nCurrentValue )
	case T == "COMBO" 
		If ValType ( Value ) == 'C'
			ComboBoxDeleteString ( c , Item )				
			ComboInsertString ( c , value , Item ) 
		Else
			ComboBoxDeleteString ( c , Item )				
			ImageComboAddItem ( c , Value[1] , Value[2] , Item - 1 )
		EndIf
	case T == "GRID" .OR. T == "MULTIGRID" 

		IF _HMG_SYSDATA [ 40 ] [ i ] [ 9 ] == .F.

			AEDITCONTROLS := _HMG_SYSDATA [40] [I] [2]

			IF VALTYPE ( AEDITCONTROLS ) != 'A'

				ListViewSetItem ( c , value , Item )

			ELSE

				ATEMP := ARRAY ( LEN ( VALUE ) )

				FOR CI := 1 TO LEN ( VALUE )

					XRES := _HMG_PARSEGRIDCONTROLS ( AEDITCONTROLS , CI )

					AEC		:= XRES [1]	
					CTYPE		:= XRES [2]	
					CINPUTMASK	:= XRES [3]	
					CFORMAT		:= XRES [4]	
					AITEMS		:= XRES [5]	
					ARANGE		:= XRES [6]	
					DTYPE		:= XRES [7]	
					ALABELS		:= XRES [8]	

					IF	AEC == 'TEXTBOX'
						IF CTYPE == 'CHARACTER'
							IF EMPTY ( CINPUTMASK )
								aTemp [ci] := VALUE [CI]
							ELSE
								aTemp [ci] := TRANSFORM ( VALUE [CI] , CINPUTMASK )
							ENDIF
						ELSEIF CTYPE == 'NUMERIC'
							IF EMPTY ( CINPUTMASK )
								aTemp [ci] := STR ( VALUE [CI] )
							ELSE
								IF EMPTY ( CFORMAT )
									aTemp [ci] := TRANSFORM ( VALUE [CI] , CINPUTMASK )
								ELSE
									aTemp [ci] := TRANSFORM ( VALUE [CI], '@' + CFORMAT + ' ' + CINPUTMASK )
								ENDIF
							ENDIF
						ELSEIF CTYPE == 'DATE'
							aTemp [ci] := DTOC ( VALUE [CI] )
						ENDIF
					ELSEIF	AEC == 'DATEPICKER'
						bd = Set (_SET_DATEFORMAT )
						SET CENTURY ON
						aTemp [ci] := dtoc ( VALUE [CI] )
						Set (_SET_DATEFORMAT ,bd)
					ELSEIF	AEC == 'COMBOBOX'
						IF VALUE [CI] == 0
							aTemp [ci] := ''
						ELSE
							aTemp [ci] := AITEMS [ VALUE [CI] ] 
						 ENDIF
					ELSEIF	AEC == 'SPINNER'
						aTemp [ci] := str ( VALUE [CI] )
					ELSEIF	AEC == 'CHECKBOX'
						IF VALUE [CI] == .T.
							aTemp [ci] := ALABELS [1]
						ELSE
							aTemp [ci] := ALABELS [2]
						ENDIF
					ENDIF
			
			        NEXT CI

				ListViewSetItem ( c , ATEMP , Item )

			ENDIF

			if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0
			        SetImageListViewItems( c, item , value [1] )
			EndIf

			_HMG_DOGRIDREFRESH(I)

		ENDIF

	case T == "STATUSBAR"

		SetStatusItemText ( c , value , Item-1 ) 		

	endcase

Return Nil 

*-----------------------------------------------------------------------------*
Function _GetItem ( ControlName , ParentForm , Item , idx )
*-----------------------------------------------------------------------------*
Local t , c , RetVal , TreeHandle , ItemHandle , i , aPos

LOCAL AEDITCONTROLS
LOCAL CI
LOCAL XRES
LOCAL ATEMP
LOCAL AEC
LOCAL CTYPE
LOCAL CINPUTMASK
LOCAL CFORMAT
LOCAL AITEMS
LOCAL ARANGE
LOCAL DTYPE
LOCAL ALABELS
LOCAL V
LOCAL Z
LOCAL X

	if pcount() == 3

		i := GetControlIndex ( ControlName , ParentForm )

	elseif pcount() == 4

		i := idx

	endif

	T = _HMG_SYSDATA [1] [i]

	c = _HMG_SYSDATA [3] [i]

	do case
	case t == 'TREE'

		if _HMG_SYSDATA [  9 ] [i] == .F.
			If Item > TreeView_GetCount ( c ) .or. Item < 1
				MsgHMGError ("Item Property: Invalid Item Reference. Program Terminated" )
			EndIf
		EndIf

		TreeHandle := c

		if _HMG_SYSDATA [  9 ] [i] == .F.
			ItemHandle := _HMG_SYSDATA [  7 ] [ i ] [ Item ]
		Else

			aPos := ascan ( _HMG_SYSDATA [ 25 ] [i] , Item )

			If aPos == 0
				MsgHMGError ("Item Property: Invalid Item Id. Program Terminated" )
			EndIf

			ItemHandle := _HMG_SYSDATA [  7 ] [ i ] [ aPos ]

		EndIf

		RetVal	:= TreeView_GetItem ( TreeHandle , ItemHandle )

	case T == "LIST" .Or. T == "MULTILIST"
		RetVal := ListBoxGetString ( c , Item )		
	case T == "COMBO" 

		If ValType ( _HMG_SYSDATA [15] [i] ) == 'U'
			RetVal := ComboGetString ( c , Item )		
		Else
			RetVal := IMAGECOMBOGETITEM ( c , Item )
		EndIf

	case T == "GRID" .OR. T == "MULTIGRID"

		IF _HMG_SYSDATA [ 40 ] [ i ] [ 9 ] == .F.

			AEDITCONTROLS := _HMG_SYSDATA [ 40 ] [I] [2]

			IF VALTYPE ( AEDITCONTROLS ) != 'A'

				RetVal := ListViewGetItem ( c , Item , Len ( _HMG_SYSDATA [  7 ] [i] ) ) 

			ELSE

				V := ListViewGetItem ( c , Item , Len( _HMG_SYSDATA [  7 ] [i] ) )

				ATEMP := ARRAY ( Len( _HMG_SYSDATA [  7 ] [i] ) )

				FOR CI := 1 TO Len( _HMG_SYSDATA [  7 ] [i] )

					XRES := _HMG_PARSEGRIDCONTROLS ( AEDITCONTROLS , CI )

					AEC		:= XRES [1]	
					CTYPE		:= XRES [2]	
					CINPUTMASK	:= XRES [3]	
					CFORMAT		:= XRES [4]	
					AITEMS		:= XRES [5]	
					ARANGE		:= XRES [6]	
					DTYPE		:= XRES [7]	
					ALABELS		:= XRES [8]	

					IF AEC == 'TEXTBOX' 
						IF CTYPE == 'NUMERIC'
							IF CFORMAT = 'E'
								ATEMP [CI] := GetNumFromCellTextSp ( v [CI] )
							ELSE
								ATEMP [CI] := GetNumFromCellText ( v [CI] )
							ENDIF
						ELSEIF CTYPE == 'DATE'
							ATEMP [CI] := CTOD ( v [CI] )
						ELSEIF CTYPE == 'CHARACTER'
							ATEMP [CI] := v [CI]		
						ENDIF

					ELSEIF AEC == 'DATEPICKER'
						ATEMP [CI] := CTOD (V [CI] )

					ELSEIF AEC == 'COMBOBOX'
						Z := 0
						FOR X := 1 TO LEN ( AITEMS )
							IF UPPER ( ALLTRIM( V [CI] ) ) == UPPER ( ALLTRIM ( AITEMS [X] ) )
								Z := X
								EXIT
							ENDIF
						NEXT X
						ATEMP [CI] := 	Z

					ELSEIF AEC == 'SPINNER'
							ATEMP [CI] := VAL (V [CI] )
					ELSEIF AEC == 'CHECKBOX'
						IF ALLTRIM(UPPER(V[CI])) == ALLTRIM(UPPER(ALABELS [1]))
							ATEMP [CI] :=  .T.
						ELSEIF ALLTRIM(UPPER(V[CI])) == ALLTRIM(UPPER(ALABELS [2]))
							ATEMP [CI] := .F.
						ENDIF
					ENDIF
	
			        NEXT CI

				RetVal := ATEMP

			ENDIF

			if Len ( _HMG_SYSDATA [ 14 ] [i] ) > 0
				if len (RetVal) >= 1
					RetVal [1] := GetImageListViewItems( c , Item )
				EndIf
			EndIf

		ENDIF

	endcase

Return (RetVal)

*-----------------------------------------------------------------------------*
Function _SetControlSizePos ( ControlName, ParentForm, row, col, width, height )
*-----------------------------------------------------------------------------*
Local t,i,c,x , NewRow , r , w , z , p , xx , b , hws
Local DelTaRow, DelTaCol
Local tCol, tRow, tWidth, tHeight , NewCol , Spacing 


	T := GetControlType (ControlName,ParentForm)

	c := GetControlHandle (ControlName,ParentForm)

	x := GetControlIndex (ControlName,ParentForm)

	do case

	Case T == "TAB"

		

		DelTaRow := Row - _HMG_SYSDATA [ 18 ] 	[ x ]
		DelTaCol := Col - _HMG_SYSDATA [ 19 ] 	[ x ]

		_HMG_SYSDATA [ 18 ] 	[ x ] := Row
		_HMG_SYSDATA [ 19 ] 	[ x ] := Col
		_HMG_SYSDATA [ 20 ] 	[ x ] := Width
		_HMG_SYSDATA [ 21 ] [ x ] := Height

		MoveWindow ( c , col , Row , Width , Height , .t. )

		for r = 1 to len ( _HMG_SYSDATA [  7 ] [x] )
			for w = 1 to len (_HMG_SYSDATA [  7 ] [x] [r])
				if valtype ( _HMG_SYSDATA [  7 ] [x] [r] [w] ) <> "A"

					p := aScan (_HMG_SYSDATA [3] , _HMG_SYSDATA [  7 ] [x] [r] [w] )


					if p > 0
					tCol 	:= _HMG_SYSDATA [ 19 ] 	[p]
					tRow 	:= _HMG_SYSDATA [ 18 ] 	[p]
					tWidth	:= _HMG_SYSDATA [ 20 ] 	[p]
					tHeight	:= _HMG_SYSDATA [ 21 ] 	[p]
					
					MoveWindow ( _HMG_SYSDATA [  7 ] [x] [r] [w] ,  tCol + DeltaCol , tRow + DeltaRow , tWidth , tHeight , .t. )
		
					_HMG_SYSDATA [ 18 ] [ p ] :=  tRow + DeltaRow
					_HMG_SYSDATA [ 19 ] [ p ] :=  tCol + DeltaCol

					_HMG_SYSDATA [ 23 ] [ p ] :=  Row
					_HMG_SYSDATA [ 24 ] [ p ] :=  Col
					endif

	               	        else

					p := ascan ( _HMG_SYSDATA [3] , _HMG_SYSDATA [  7 ] [x] [r] [w] [1] )

					if p > 0 .and. _HMG_SYSDATA [1] [p] == 'BROWSE'

					#ifdef COMPILEBROWSE

						tCol 	:= _HMG_SYSDATA [ 19 ] 	[p]
						tRow 	:= _HMG_SYSDATA [ 18 ] 	[p]
						tWidth	:= _HMG_SYSDATA [ 20 ] 	[p]
						tHeight	:= _HMG_SYSDATA [ 21 ] 	[p]

						If _HMG_SYSDATA [  5 ][p] != 0
                                                        
							MoveWindow ( _HMG_SYSDATA [  7 ] [x] [r] [w] [1] , tCol + DeltaCol , tRow + DeltaRow , tWidth - GETVSCROLLBARWIDTH() , tHeight , .t. )

							hws := 0
							For b := 1 To Len ( _HMG_SYSDATA [  6 ] [p] )
								hws := hws + ListView_GetColumnWidth ( _HMG_SYSDATA [3] [p] , b - 1 )
							Next b

							if hws > _HMG_SYSDATA [ 20 ][p] - GETVSCROLLBARWIDTH() - 4
                                                                
								MoveWindow ( _HMG_SYSDATA [  5 ][p] , tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow , GETVSCROLLBARWIDTH()   , tHeight - GetHScrollBarHeight() , .t. )
								MoveWindow ( _HMG_SYSDATA [ 39 ][p] [1], tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow + tHeight - GetHScrollBarHeight() , GetWindowWidth(_HMG_SYSDATA [ 39 ][p] [1])   , GetWindowHeight(_HMG_SYSDATA [ 39 ][p][1]) , .t. )

							Else    	
                                                                
								MoveWindow ( _HMG_SYSDATA [  5 ][p] , tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow , GETVSCROLLBARWIDTH()   , tHeight , .t. )
								MoveWindow ( _HMG_SYSDATA [ 39 ][p] [1], tCol + DeltaCol + tWidth - GETVSCROLLBARWIDTH() , tRow + DeltaRow + tHeight - GetHScrollBarHeight() , 0  , 0 , .t. )

							EndIf


							_BrowseRefresh ( '' , '' , p )

							ReDrawWindow ( _HMG_SYSDATA [  5 ][p] )

							ReDrawWindow ( _HMG_SYSDATA [ 39 ][p] [1])

						Else
                                                        
							MoveWindow ( _HMG_SYSDATA [  7 ] [x] [r] [w] [1] ,  tCol + DeltaCol , tRow + DeltaRow , tWidth , tHeight , .t. )

						endif

						_HMG_SYSDATA [ 18 ] [ p ] :=  tRow + DeltaRow
						_HMG_SYSDATA [ 19 ] [ p ] :=  tCol + DeltaCol

						_HMG_SYSDATA [ 23 ] [ p ] :=  Row
						_HMG_SYSDATA [ 24 ] [ p ] :=  Col

					#endif

					else

					for z = 1 to len ( _HMG_SYSDATA [  7 ] [x] [r] [w] )

						for xx = 1 to len ( _HMG_SYSDATA [1] )
							if valtype ( _HMG_SYSDATA [3] [xx] ) == 'A'
								if _HMG_SYSDATA [  7 ] [x] [r] [w] == _HMG_SYSDATA [3] [xx]             
								        if _HMG_SYSDATA [1] [xx] == 'RADIOGROUP'
								                If _HMG_SYSDATA [8] [xx] == .T.
										        MoveWindow ( _HMG_SYSDATA [3] [xx] [z] ,  _HMG_SYSDATA [ 19 ] 	[xx] + DeltaCol + ( _HMG_SYSDATA [22] [XX] * (z-1) ) , _HMG_SYSDATA [ 18 ] [xx] + DeltaRow , _HMG_SYSDATA [ 22 ] [xx] , 28 , .t.  ) 
										Else		
				                		               	        
                                                                                        MoveWindow ( _HMG_SYSDATA [3] [xx] [z] ,  _HMG_SYSDATA [ 19 ] 	[xx] + DeltaCol , _HMG_SYSDATA [ 18 ] 	[xx] + DeltaRow + (_HMG_SYSDATA [ 22 ] [xx] * (z-1)), _HMG_SYSDATA [ 20 ] [xx] , 28 , .t.  ) 
										EndIf
		                		               	        endif
									if _HMG_SYSDATA [1] [xx] == 'RADIOGROUP' .and. z == len ( _HMG_SYSDATA [  7 ] [x] [r] [w] )
										If _HMG_SYSDATA [8] [xx] == .T.
										
										_HMG_SYSDATA [ 18 ] 		[ xx ]	:= _HMG_SYSDATA [ 18 ] [ xx ] + DeltaRow
										_HMG_SYSDATA [ 19 ] 		[ xx ]	:= _HMG_SYSDATA [ 19 ] [ xx ] + DeltaCol
										_HMG_SYSDATA [ 23 ] 	[ xx ]	:=  Row
										_HMG_SYSDATA [ 24 ] 	[ xx ] 	:=  Col

										Else
										_HMG_SYSDATA [ 18 ] 		[ xx ]	:= _HMG_SYSDATA [ 18 ] [ xx ] + DeltaRow
										_HMG_SYSDATA [ 19 ] 		[ xx ]	:= _HMG_SYSDATA [ 19 ] [ xx ] + DeltaCol
										_HMG_SYSDATA [ 23 ] 	[ xx ]	:=  Row
										_HMG_SYSDATA [ 24 ] 	[ xx ] 	:=  Col
										EndIf
									EndIf
								        if _HMG_SYSDATA [1] [xx] == 'SPINNER' .and. z == 1
																		
								        	MoveWIndow ( _HMG_SYSDATA [3] [xx] [1] ,  _HMG_SYSDATA [ 19 ] 	[xx] + DeltaCol 			, _HMG_SYSDATA [ 18 ] [xx] + DeltaRow , _HMG_SYSDATA [ 20 ] [xx] 	, _HMG_SYSDATA [ 21 ] [xx] , .t.  ) 
		                		               	        endif
								        if _HMG_SYSDATA [1] [xx] == 'SPINNER' .and. z == 2
                                                                                
										MoveWIndow ( _HMG_SYSDATA [3] [xx] [2] ,  _HMG_SYSDATA [ 19 ] 	[xx] + DeltaCol + _HMG_SYSDATA [ 20 ] [xx] - 15 , _HMG_SYSDATA [ 18 ] [xx] + DeltaRow , 15 			, _HMG_SYSDATA [ 21 ] [xx] , .t.  )
										_HMG_SYSDATA [ 18 ] [ xx ] := _HMG_SYSDATA [ 18 ] [ xx ] + DeltaRow
										_HMG_SYSDATA [ 19 ] [ xx ] := _HMG_SYSDATA [ 19 ] [ xx ] + DeltaCol
										_HMG_SYSDATA [ 23 ] 	[ xx ]	:=  Row
										_HMG_SYSDATA [ 24 ] 	[ xx ] 	:=  Col

		                		               	        endif

								EndIf
							EnDif
						next xx 

					Next z
					endif
				endif
			Next w
		Next r

	Case T == "SPINNER"

		if _HMG_SYSDATA [ 23 ] [x] == -1

			_HMG_SYSDATA [ 18 ] 	[ x ] := Row
			_HMG_SYSDATA [ 19 ] 	[ x ] := Col
			_HMG_SYSDATA [ 20 ] 	[ x ] := Width
			_HMG_SYSDATA [ 21 ]	[ x ] := Height

			MoveWindow ( c [1] , Col , Row  , Width - 15 , Height , .t. )
			MoveWindow ( c [2] , Col + Width - 15 , Row , 15  , Height , .t. )

		Else

			_HMG_SYSDATA [ 18 ] 	[ x ] := Row + _HMG_SYSDATA [ 23 ] [x]
			_HMG_SYSDATA [ 19 ] 	[ x ] := Col + _HMG_SYSDATA [ 24 ] [x]
			_HMG_SYSDATA [ 20 ] 	[ x ] := Width
			_HMG_SYSDATA [ 21 ] [ x ] := Height

			MoveWindow ( c [1] , Col + _HMG_SYSDATA [ 24 ] [x] , Row + _HMG_SYSDATA [ 23 ] [x] , Width - 15 , Height , .t. )
			MoveWindow ( c [2] , Col + _HMG_SYSDATA [ 24 ] [x] + Width - 15 , Row + _HMG_SYSDATA [ 23 ] [x] , 15  , Height , .t. )


		EndIf

	#ifdef COMPILEBROWSE

	Case T == "BROWSE"

		if _HMG_SYSDATA [ 23 ] [x] == -1

			_HMG_SYSDATA [ 18 ] 	[ x ] := Row
			_HMG_SYSDATA [ 19 ] 	[ x ] := Col
			_HMG_SYSDATA [ 20 ] 	[ x ] := Width
			_HMG_SYSDATA [ 21 ]	[ x ] := Height

			If _HMG_SYSDATA [  5 ][x] != 0
				MoveWindow ( c , col , Row , Width - GETVSCROLLBARWIDTH() , Height , .t. )

				hws := 0
				For b := 1 To Len ( _HMG_SYSDATA [  6 ] [x] )
					hws := hws + ListView_GetColumnWidth ( _HMG_SYSDATA [3] [x] , b - 1 )
				Next b

				if hws > _HMG_SYSDATA [ 20 ][x] - GETVSCROLLBARWIDTH() - 4

					MoveWindow ( _HMG_SYSDATA [  5 ][x] , col + Width - GETVSCROLLBARWIDTH() , Row , GETVSCROLLBARWIDTH()   , Height - GetHScrollBarHeight() , .t. )
					MoveWindow ( _HMG_SYSDATA [ 39 ][x] [1], col + Width - GETVSCROLLBARWIDTH() , Row + Height - GetHScrollBarHeight() , GetWindowWidth(_HMG_SYSDATA [ 39 ][x] [1])   , GetWindowHeight(_HMG_SYSDATA [ 39 ][x][1]) , .t. )

				else

					MoveWindow ( _HMG_SYSDATA [  5 ][x] , col + Width - GETVSCROLLBARWIDTH() , Row , GETVSCROLLBARWIDTH()   , Height , .t. )
					MoveWindow ( _HMG_SYSDATA [ 39 ][x] [1], col + Width - GETVSCROLLBARWIDTH() , Row + Height - GetHScrollBarHeight() , 0  , 0 , .t. )

				endif

				_BrowseRefresh ( '' , '' , x )
				ReDrawWindow ( _HMG_SYSDATA [  5 ][x] )
				ReDrawWindow ( _HMG_SYSDATA [ 39 ][x] [1])
			Else
				MoveWindow ( c , col , Row , Width , Height , .t. )
			EndIf

		Else

			_HMG_SYSDATA [ 18 ] 	[ x ] := Row + _HMG_SYSDATA [ 23 ] [x]
			_HMG_SYSDATA [ 19 ] 	[ x ] := Col + _HMG_SYSDATA [ 24 ] [x]
			_HMG_SYSDATA [ 20 ] 	[ x ] := Width
			_HMG_SYSDATA [ 21 ]	[ x ] := Height

			If _HMG_SYSDATA [  5 ][x] != 0

				MoveWindow ( c , col + _HMG_SYSDATA [ 24 ] [x], Row + _HMG_SYSDATA [ 23 ] [x] , Width - GETVSCROLLBARWIDTH() , Height , .t. )

				hws := 0
				For b := 1 To Len ( _HMG_SYSDATA [  6 ] [x] )
					hws := hws + ListView_GetColumnWidth ( _HMG_SYSDATA [3] [x] , b - 1 )
				Next b

				if hws > _HMG_SYSDATA [ 20 ][x] - GETVSCROLLBARWIDTH() - 4

					MoveWindow ( _HMG_SYSDATA [  5 ][x] , col + _HMG_SYSDATA [ 24 ] [x]+ Width - GETVSCROLLBARWIDTH() , Row + _HMG_SYSDATA [ 23 ] [x], GETVSCROLLBARWIDTH()   , Height - GetHScrollBarHeight() , .t. )
					MoveWindow ( _HMG_SYSDATA [ 39 ][x] [1], col + _HMG_SYSDATA [ 24 ] [x]+ Width - GETVSCROLLBARWIDTH() , Row + _HMG_SYSDATA [ 23 ] [x]+ Height - GetHScrollBarHeight() , GetWindowWidth(_HMG_SYSDATA [ 39 ][x] [1])   , GetWindowHeight(_HMG_SYSDATA [ 39 ][x][1]) , .t. )
				
				else

					MoveWindow ( _HMG_SYSDATA [  5 ][x] , col + _HMG_SYSDATA [ 24 ] [x]+ Width - GETVSCROLLBARWIDTH() , Row + _HMG_SYSDATA [ 23 ] [x], GETVSCROLLBARWIDTH()   , Height , .t. )
					MoveWindow ( _HMG_SYSDATA [ 39 ][x] [1], col + _HMG_SYSDATA [ 24 ] [x]+ Width - GETVSCROLLBARWIDTH() , Row + _HMG_SYSDATA [ 23 ] [x]+ Height - GetHScrollBarHeight() , 0  , 0 , .t. )

				endif

				_BrowseRefresh ( '' , '' , x )

				ReDrawWindow ( _HMG_SYSDATA [  5 ][x] )

				ReDrawWindow ( _HMG_SYSDATA [ 39 ][x] [1])

			Else
				MoveWindow ( c , col + _HMG_SYSDATA [ 24 ] [x], Row + _HMG_SYSDATA [ 23 ] [x] , Width , Height , .t. )
			EndIf

		EndIf

		ReDrawWindow ( c )

	#endif

	Case T == "RADIOGROUP" 

		if _HMG_SYSDATA [ 23 ] [x] == -1

			_HMG_SYSDATA [ 18 ] 	[ x ] 	:= Row
			_HMG_SYSDATA [ 19 ] 	[ x ] 	:= Col
			_HMG_SYSDATA [ 20 ] 	[ x ] 	:= Width
			Spacing 			:= _HMG_SYSDATA [ 22 ] [ x ] 

			if _HMG_SYSDATA [ 8 ] [x] 

				For i := 1 To Len ( c )
					NewCol := Col + ( ( i - 1 ) * _HMG_SYSDATA [ 22 ] [ x ] )
					MoveWindow ( c [i] , Newcol , Row , spacing , 28 , .t. )
				Next i

			else

				

				For i := 1 To Len ( c )
					NewRow := Row + ( ( i - 1 ) * _HMG_SYSDATA [ 22 ] [ x ] )
					MoveWindow ( c [i] , col , NewRow , Width , 28 , .t. )
				Next i

			endif

		Else

			_HMG_SYSDATA [ 18 ] 	[ x ] := Row + _HMG_SYSDATA [ 23 ] [x]
			_HMG_SYSDATA [ 19 ] 	[ x ] := Col + _HMG_SYSDATA [ 24 ] [x]
			_HMG_SYSDATA [ 20 ] 	[ x ] := Width

			Spacing 			:= _HMG_SYSDATA [ 22 ] [ x ] 

			if _HMG_SYSDATA [ 8 ] [x] 

				
				
				For i := 1 To Len ( c )
					*NewCol := Col + _HMG_SYSDATA [ 24 ] [x] + ( ( i - 1 ) * _HMG_SYSDATA [ 22 ] [ x ] )
					*MoveWindow ( c [i] , NewCol , Row , Spacing , 28 , .t. )
				Next i

			else

				

				For i := 1 To Len ( c )
					NewRow := Row + _HMG_SYSDATA [ 23 ] [x] + ( ( i - 1 ) * _HMG_SYSDATA [ 22 ] [ x ] )
					MoveWindow ( c [i] , col + _HMG_SYSDATA [ 24 ] [x] , NewRow , Width , 28 , .t. )
				Next i

			endif

		EndIf

	OtherWise

		if _HMG_SYSDATA [ 23 ] [x] == -1

			_HMG_SYSDATA [ 18 ] 	[ x ] := Row
			_HMG_SYSDATA [ 19 ] 	[ x ] := Col
			_HMG_SYSDATA [ 20 ] 	[ x ] := Width
			_HMG_SYSDATA [ 21 ] [ x ] := Height
			MoveWindow ( c , col , row , width , height , .t. )

		Else

			_HMG_SYSDATA [ 18 ] 	[ x ] := Row + _HMG_SYSDATA [ 23 ] [x]
			_HMG_SYSDATA [ 19 ] 	[ x ] := Col + _HMG_SYSDATA [ 24 ] [x]
			_HMG_SYSDATA [ 20 ] 	[ x ] := Width
			_HMG_SYSDATA [ 21 ] [ x ] := Height
			MoveWindow ( c , col + _HMG_SYSDATA [ 24 ] [x] , row + _HMG_SYSDATA [ 23 ] [x] , width , height , .t. )

		EndIf

	EndCase

Return Nil

*-----------------------------------------------------------------------------*
Function _GetItemCount ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local t , c , RetVal
	
	T = GetControlType (ControlName,ParentForm)

	c = GetControlHandle (ControlName,ParentForm)

	do case
	case T == "TREE" 
		RetVal := TreeView_GetCount  ( c )
	case T == "LIST" .Or. T == "MULTILIST"
		RetVal := ListBoxGetItemCount ( c )		
	case T == "COMBO" 
		RetVal := ComboBoxGetItemCount ( c )		
	case T == "GRID" .OR. T == "MULTIGRID" 
		RetVal := ListViewGetItemCount ( c ) 		
	endcase

Return (RetVal)
*-----------------------------------------------------------------------------*
Function _GetControlRow (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

	If _HMG_SYSDATA [ 23 ] [ &mVar ] == - 1
		Return (_HMG_SYSDATA [ 18 ] [ &mVar ] )
	Else
		Return ( _HMG_SYSDATA [ 18 ] [ &mVar ] - _HMG_SYSDATA [ 23 ] [ &mVar ] )
	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _GetControlCol (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

	If _HMG_SYSDATA [ 24 ] [ &mVar ] == - 1
		Return (_HMG_SYSDATA [ 19 ] [ &mVar ] )
	Else
		Return ( _HMG_SYSDATA [ 19 ] [ &mVar ] - _HMG_SYSDATA [ 24 ] [ &mVar ] )
	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _GetControlWidth (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

Return (_HMG_SYSDATA [ 20 ] [ &mVar ] )
*-----------------------------------------------------------------------------*
Function _GetControlHeight (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName

	i := &mVar
	if i == 0
		Return 0
	EndIf

Return (_HMG_SYSDATA [ 21 ] [ &mVar ] )

*-----------------------------------------------------------------------------*
Function _SetControlCol ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

	_SetControlSizePos ( ControlName, ParentForm , _GetControlRow ( ControlName,ParentForm) , Value , _GetControlWidth ( ControlName,ParentForm) , _GetControlHeight ( ControlName,ParentForm) )

Return Nil
*-----------------------------------------------------------------------------*
Function _SetControlRow ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

	_SetControlSizePos ( ControlName, ParentForm , Value , _GetControlCol ( ControlName,ParentForm) , _GetControlWidth ( ControlName,ParentForm) , _GetControlHeight ( ControlName,ParentForm) )

Return Nil
*-----------------------------------------------------------------------------*
Function _SetControlWidth ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

	_SetControlSizePos ( ControlName, ParentForm , _GetControlRow ( ControlName,ParentForm) , _GetControlCol ( ControlName,ParentForm) , Value , _GetControlHeight ( ControlName,ParentForm) )

Return Nil
*-----------------------------------------------------------------------------*
Function _SetControlHeight ( ControlName, ParentForm, Value )
*-----------------------------------------------------------------------------*

	_SetControlSizePos ( ControlName, ParentForm , _GetControlRow ( ControlName,ParentForm) , _GetControlCol ( ControlName,ParentForm) , _GetControlWidth ( ControlName,ParentForm) , Value )

Return Nil

*-----------------------------------------------------------------------------*
Function _SetPicture ( ControlName, ParentForm, FileName )
*-----------------------------------------------------------------------------*
Local w,h,t,i,n,c

	i := GetControlIndex ( ControlName, ParentForm )
	t := GetControlType ( ControlName, ParentForm )
	c := GetControlHandle (ControlName,ParentForm)

	if t == 'IMAGE'

		w := _GetControlWidth ( ControlName, ParentForm )
		h := _GetControlHeight ( ControlName, ParentForm )

		DeleteObject ( _HMG_SYSDATA [ 37 ] [i] )

		_HMG_SYSDATA [ 37 ]  [i] := C_SetPicture ( GetControlHandle (ControlName, ParentForm) , FileName , w , h , _HMG_SYSDATA [  8 ] [i] , _HMG_SYSDATA [ 39 ] [i] ) 

		_HMG_SYSDATA [ 25 ] [i] := FileName


	elseif T == 'BUTTON'

		if	.Not. Empty (_HMG_SYSDATA [ 25 ] [i] ) ;
			.And. ;
			.Not. Empty (_HMG_SYSDATA [ 33 ] [i] ) ;
			.Or.;
			(_HMG_SYSDATA [ 22 ] [i] == 'I' .And. IsAppThemed())

			if _HMG_SYSDATA [ 38 ] [i] == .T.
				IMAGELIST_DESTROY ( _HMG_SYSDATA [ 37 ] [i] ) 
				n := _SetMixedBtnPicture ( _HMG_SYSDATA [3] [i] , FileName , _HMG_SYSDATA [26] [i] )
				ReDrawWindow (_HMG_SYSDATA [3] [i])
				_HMG_SYSDATA [ 25 ] [i] := FileName
				_HMG_SYSDATA [ 37 ] [i] := n
			endif

		else

			if _HMG_SYSDATA [ 38 ] [i] == .T.
				DeleteObject ( _HMG_SYSDATA [ 37 ] [i] )
				n := _SetBtnPicture ( _HMG_SYSDATA [3] [i] , FileName )
				_HMG_SYSDATA [ 25 ] [i] := FileName
				_HMG_SYSDATA [ 37 ] [i] := n
			endif

		endif

	elseif T == "CHECKBOX" 

		If _HMG_SYSDATA [ 38 ] [i] == .T. 

			if	_HMG_SYSDATA [ 16 ] [i]	== 'I'

				if IsAppThemed()

					IMAGELIST_DESTROY ( _HMG_SYSDATA [ 37 ] [i] ) 
					_HMG_SYSDATA [ 37 ] [i] := _SetMixedBtnPicture ( _HMG_SYSDATA [3] [i] , FileName , _HMG_SYSDATA [26] [i] )
					ReDrawWindow (_HMG_SYSDATA [3] [i])
					_HMG_SYSDATA [ 25 ] [i] := FileName

				else

					DeleteObject( _HMG_SYSDATA [ 37 ] [i] )
					_HMG_SYSDATA [37] [i] := _SetBtnPicture(c, FileName )
					_HMG_SYSDATA [ 25 ] [i] := FileName

				endif

			else

				DeleteObject ( _HMG_SYSDATA [ 37 ] [i] )
				n := _SetBtnPicture ( _HMG_SYSDATA [3] [i] , FileName )
				_HMG_SYSDATA [ 25 ] [i] := FileName
				_HMG_SYSDATA [ 37 ] [i] := n

			endif

		EndIf

	else

		DeleteObject ( _HMG_SYSDATA [ 37 ] [i] )
		n := _SetBtnPicture ( _HMG_SYSDATA [3] [i] , FileName )
		_HMG_SYSDATA [ 25 ] [i] := FileName
		_HMG_SYSDATA [ 37 ] [i] := n

	Endif

Return Nil

*-----------------------------------------------------------------------------*
Function _GetPicture ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, ParentForm )

	if i == 0
		Return ''
	EndIf

Return	( _HMG_SYSDATA [ 25 ] [i] )

*-----------------------------------------------------------------------------*
Function GetData()
*-----------------------------------------------------------------------------*
Local PacketNames [ aDir ( _HMG_SYSDATA [ 291 ] + _HMG_SYSDATA [ 292 ] + '.*'  ) ] , i , Rows , Cols , RetVal := Nil , bd , aItem , aTemp := {} , r , c
Local DataValue, DataType, DataLenght, Packet

	bd = Set (_SET_DATEFORMAT )

	SET DATE TO ANSI

	aDir ( _HMG_SYSDATA [ 291 ] + _HMG_SYSDATA [ 292 ] + '.*' , PacketNames )

	If Len ( PacketNames ) > 0

		Packet := MemoRead ( _HMG_SYSDATA [ 291 ] + PacketNames [1] )

		Rows := Val ( SubStr ( Memoline ( Packet , , 1 ) , 11 , 99 ) )
		Cols := Val ( SubStr ( Memoline ( Packet , , 2 ) , 11 , 99 )	)

		Do Case

			// Single Data

			Case Rows == 0 .And. Cols == 0

				DataType := SubStr ( Memoline ( Packet ,  , 3 ) , 12 , 1 )
				DataLenght := Val ( SubStr ( Memoline ( Packet , , 3 ) , 14 , 99 ) )

				DataValue := Memoline ( Packet , 254 , 4 )
				
				Do Case
					Case DataType == 'C'				
						RetVal := Left ( DataValue , DataLenght )
					Case DataType == 'N'				
						RetVal := Val ( DataValue )
					Case DataType == 'D'				
						RetVal := CTOD ( DataValue )
					Case DataType == 'L'				
						RetVal := iif ( Alltrim(DataValue) == 'T' , .t. , .f. )
			        End Case

			// One Dimension Array Data

			Case Rows != 0 .And. Cols == 0

				i := 3

				Do While i < MlCount ( Packet )

					DataType   := SubStr ( Memoline ( Packet , , i ) , 12 , 1 )				
					DataLenght := Val ( SubStr ( Memoline ( Packet , , i ) , 14 , 99 ) )

					i++

					DataValue  := Memoline ( Packet , 254 , i )
				
					Do Case
						Case DataType == 'C'
							aItem := Left ( DataValue , DataLenght )
						Case DataType == 'N'				
							aItem := Val ( DataValue )
						Case DataType == 'D'				
							aItem := CTOD ( DataValue )
						Case DataType == 'L'				
							aItem := iif ( Alltrim(DataValue) == 'T' , .t. , .f. )
				        End Case

					aAdd ( aTemp , aItem )

					i++

				EndDo

				RetVal := aTemp

			// Two Dimension Array Data

			Case Rows != 0 .And. Cols != 0

				i := 3

				aTemp := Array ( Rows , Cols )

				r := 1
	                        c := 1

				Do While i < MlCount ( Packet )

					DataType   := SubStr ( Memoline ( Packet , , i ) , 12 , 1 )
					DataLenght := Val ( SubStr ( Memoline ( Packet , , i ) , 14 , 99 ) )

					i++

					DataValue  := Memoline ( Packet , 254 , i )
				
					Do Case
						Case DataType == 'C'				
							aItem := Left ( DataValue , DataLenght )
						Case DataType == 'N'				
							aItem := Val ( DataValue )
						Case DataType == 'D'				
							aItem := CTOD ( DataValue )
						Case DataType == 'L'
							aItem := iif ( Alltrim(DataValue) == 'T' , .t. , .f. )
				        End Case

					aTemp [r] [c] := aItem

					c++
					if c > Cols
						r++
						c := 1
					EndIf

					i++

				EndDo

				RetVal := aTemp

		End Case

	Else
		Set (_SET_DATEFORMAT ,bd)
		Return Nil
	EndIf

	Delete File ( _HMG_SYSDATA [ 291 ] + PacketNames [1] )

	Set (_SET_DATEFORMAT ,bd)

Return ( RetVal )
*-----------------------------------------------------------------------------*
Function SendData ( cDest , Data )
*-----------------------------------------------------------------------------*
Local cData := '' , i , j
LOCAL pData, cLen, cType, FileName, Rows, Cols

	_HMG_SYSDATA [ 290 ]++

	FileName := _HMG_SYSDATA [ 291 ] + cDest + '.' + _HMG_SYSDATA [ 292 ] + '.' + Alltrim ( Str ( _HMG_SYSDATA [ 290 ] ) )

	If ValType ( Data ) == 'A'

		If ValType ( Data [1] ) != 'A'

			cData := '#DataRows=' +	Alltrim(Str(Len(Data)))	+ chr(13) + chr(10)
			cData := cData + '#DataCols=0'	+ chr(13) + chr(10)

			For i := 1 To Len ( Data )
		
				cType := ValType ( Data [i] )

				If cType == 'D'
					pData := alltrim(str(year(data[i]))) + '.' + alltrim(str(month(data[i]))) + '.' + alltrim(str(day(data[i])))
					cLen := Alltrim(Str(Len(pData)))
				ElseIf cType == 'L'
					If Data [i] == .t.
						pData := 'T'
					Else
						pData := 'F'
					EndIf
					cLen := Alltrim(Str(Len(pData)))
				ElseIf cType == 'N'
					pData := str ( Data [i] )
					cLen := Alltrim(Str(Len(pData)))
				ElseIf cType == 'C'
					pData := Data [i]
					cLen := Alltrim(Str(Len(pData)))
				Else
					MsgHMGError('SendData: Type Not Suported. Program terminated')
				EndIf

				cData := cData + '#DataBlock='	+ cType	+ ',' + cLen + chr(13) + chr(10)
				cData := cData + pData		+ chr(13) + chr(10)	

			Next i

			MemoWrit ( FileName , cData )

		Else

			Rows := Len ( Data )
			Cols := Len ( Data [1] )

			cData := '#DataRows=' +	Alltrim(Str(Rows))	+ chr(13) + chr(10)
			cData := cData + '#DataCols=' +	Alltrim(Str(Cols)) + chr(13) + chr(10)

			For i := 1 To Rows

				For j := 1 To Cols

				cType := ValType ( Data [i] [j] )

				If cType == 'D'
					pData := alltrim(str(year(data[i][j]))) + '.' + alltrim(str(month(data[i][j]))) + '.' + alltrim(str(day(data[i][j])))
					cLen := Alltrim(Str(Len(pData)))
				ElseIf cType == 'L'
					If Data [i] [j] == .t.
						pData := 'T'
					Else
						pData := 'F'
					EndIf
					cLen := Alltrim(Str(Len(pData)))
				ElseIf cType == 'N'
					pData := str ( Data [i] [j] )
					cLen := Alltrim(Str(Len(pData)))
				ElseIf cType == 'C'
					pData := Data [i] [j]
					cLen := Alltrim(Str(Len(pData)))
				Else
					MsgHMGError('SendData: Type Not Suported. Program terminated')
				EndIf

				cData := cData + '#DataBlock='	+ cType	+ ',' + cLen+ chr(13) + chr(10)
				cData := cData + pData		+ chr(13) + chr(10)

				Next j
			Next i

			MemoWrit ( FileName , cData )

		EndIf

	Else

		cType := ValType ( Data )

		If cType == 'D'
			pData := alltrim(str(year(data))) + '.' + alltrim(str(month(data))) + '.' + alltrim(str(day(data))) 
			cLen := Alltrim(Str(Len(pData)))
		ElseIf cType == 'L'
			If Data == .t.
				pData := 'T'
			Else
				pData := 'F'
			EndIf
			cLen := Alltrim(Str(Len(pData)))
		ElseIf cType == 'N'
			pData := str ( Data )
			cLen := Alltrim(Str(Len(pData)))
		ElseIf cType == 'C'
			pData := Data
			cLen := Alltrim(Str(Len(pData)))
		Else
				MsgHMGError('SendData: Type Not Suported. Program terminated')
		EndIf

		cData := '#DataRows=0'		+ chr(13) + chr(10)
		cData := cData + '#DataCols=0'	+ chr(13) + chr(10)

		cData := cData + '#DataBlock='	+ cType + ',' + cLen+ chr(13) + chr(10)
		cData := cData + pData		+ chr(13) + chr(10)

		MemoWrit ( FileName , cData )

	EndIf


Return Nil
*-----------------------------------------------------------------------------*
Function _EnableToolbarButton ( ButtonName , FormName )
*------------------------------------------------------------------------------*
Local i
Local cCaption
Local x
Local c
Local bAction

	i := GetControlIndex ( ButtonName, FormName )

	if i > 0

		EnableToolButton( _HMG_SYSDATA [ 26 ] [ i ]  , GetControlId(ButtonName,FormName) )

		bAction	:= _HMG_SYSDATA [  6 ] [i] 

		cCaption := _HMG_SYSDATA [ 33 ] [i] 

		If ValType ( cCaption ) != 'U'

			cCaption := Upper ( cCaption )

			x := at ( '&' , cCaption )

			If x > 0
				c := Asc ( SubStr ( cCaption , x+1 , 1 ) )			

				If c >= 48 .And. c <= 90
					_DefineHotKey ( FormName , MOD_ALT , c , bAction )
				EndIf
			EndIf

		EndIf

	EndIf

Return Nil
*------------------------------------------------------------------------------*
Function _DisableToolbarButton ( ButtonName, FormName )
*------------------------------------------------------------------------------*
Local i
Local cCaption
Local x
Local c

	i := GetControlIndex ( ButtonName, FormName )

	if i > 0

		DisableToolButton( _HMG_SYSDATA [ 26 ] [ i ]  , GetControlId(ButtonName,FormName) )

		cCaption := _HMG_SYSDATA [ 33 ] [i] 

		If ValType ( cCaption ) != 'U'

			cCaption := Upper ( cCaption )

			x := at ( '&' , cCaption )

			If x > 0

				c := Asc ( SubStr ( cCaption , x+1 , 1 ) )			

				If c >= 48 .And. c <= 90
					_ReleaseHotKey ( FormName , MOD_ALT , c )
				EndIf

			EndIf

		EndIf

	EndIf

Return NIL

*-----------------------------------------------------------------------------*
Function _GetControlAction( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, ParentForm )

	if i == 0
		Return ''
	EndIf

Return	( _HMG_SYSDATA [  6 ] [i] )
*-----------------------------------------------------------------------------*
Function _GetToolTip ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, ParentForm )

	if i == 0
		Return ''
	EndIf

Return	( _HMG_SYSDATA [ 30 ] [i] )
*-----------------------------------------------------------------------------*
Function _SetToolTip ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
Local i , h

	i := GetControlIndex ( ControlName, ParentForm )

	if i == 0
		Return Nil
	EndIf

	h := _HMG_SYSDATA [3] [i]

	_HMG_SYSDATA [ 30 ] [i] := Value

        SetToolTip ( h , Value , GetFormToolTipHandle (ParentForm) )

Return Nil

*-----------------------------------------------------------------------------*
Function _SetRangeMin ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
Local i , h , t , m

	i := GetControlIndex ( ControlName, ParentForm )
	h := _HMG_SYSDATA [3] [i]
	t := GetControlType ( ControlName, ParentForm )
	m := _HMG_SYSDATA [ 32 ] [i]

	DO CASE

	CASE T == 'SLIDER'

		SetSliderRange ( h , Value , m )

	CASE T == 'SPINNER'

		SetSpinnerRange ( h [2] , Value , m )

	CASE T == 'PROGRESSBAR'

		SetProgressBarRange ( h , Value , m )

	END CASE

	_HMG_SYSDATA [ 31 ] [i] := Value

Return Nil
*-----------------------------------------------------------------------------*
Function _SetRangeMax ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
Local i , h , t , m

	i := GetControlIndex ( ControlName, ParentForm )
	h := _HMG_SYSDATA [3] [i]
	t := GetControlType ( ControlName, ParentForm )
	m := _HMG_SYSDATA [ 31 ] [i]

	DO CASE

	CASE T == 'SLIDER'

		SetSliderRange ( h , m, Value  )

	CASE T == 'SPINNER'

		SetSpinnerRange ( h [2] , m , Value )

	CASE T == 'PROGRESSBAR'

		SetProgressBarRange ( h , m , Value )

	END CASE

	_HMG_SYSDATA [ 32 ] [i] := Value

Return Nil

*-----------------------------------------------------------------------------*
Function _GetRangeMin ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, ParentForm )

	if i == 0
		Return 0
	EndIf

Return	( _HMG_SYSDATA [ 31 ] [i] )

*-----------------------------------------------------------------------------*
Function _GetRangeMax ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, ParentForm )

	if i == 0
		Return 0
	EndIf

Return	( _HMG_SYSDATA [ 32 ] [i] )

*-----------------------------------------------------------------------------*
Function _SetMultiCaption ( ControlName, ParentForm , Column , Value  )
*-----------------------------------------------------------------------------*
Local i , h , t

	i := GetControlIndex ( ControlName, ParentForm )

	h := _HMG_SYSDATA [3] [i]

	t := GetControlType ( ControlName, ParentForm )

	_HMG_SYSDATA [ 33 ] [i] [Column] := Value 

	Do Case
	Case t == 'GRID' .Or. t == 'MULTIGRID' .Or. t == 'BROWSE'
		SETGRIDCOLOMNHEADER ( h , Column , Value )
	Case t == 'RADIOGROUP' 
		SetWindowText ( h [Column] , Value ) 
	Case t == 'TAB' 
		_HMG_SYSDATA [ 33 ] [i] [Column] := Value
		SETTABCAPTION ( h , Column , Value )
	EndCase

Return Nil

*-----------------------------------------------------------------------------*
Function _GetMultiCaption ( ControlName, ParentForm , Item )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, ParentForm )

	if i == 0
		Return ''
	EndIf

Return	( _HMG_SYSDATA [ 33 ] [i] [item] )

*-----------------------------------------------------------------------------*
Function InputWindow ( Title , aLabels , aValues , aFormats , row , col )
*-----------------------------------------------------------------------------*
Local i , l , ControlRow , e := 0 ,LN , CN ,r , c , wHeight , diff , BF

     bf := set(2)
     set(2,.f.)

	l := Len ( aLabels )

	Private aResult [l]

	For i := 1 to l

		if ValType ( aValues[i] ) == 'C'

			if ValType ( aFormats[i] ) == 'N'

				If aFormats[i] > 32
					e++
				Endif

			EndIf

		EndIf

		if ValType ( aValues[i] ) == 'M'  
			e++
		EndIf

	Next i


	if pcount() == 4
		r := 0
		c := 0
	Else
		r := row
		c := col
		wHeight :=  (l*30) + 90 + (e*60) 

		if r + wHeight > GetDeskTopHeight()

			diff :=  r + wHeight - GetDeskTopHeight() 
			r := r - diff

		EndIf

	EndIf

	DEFINE WINDOW _InputWindow ;
		AT r,c ;
		WIDTH 280 ;
		HEIGHT (l*30) + 90 + (e*60) ;
		TITLE Title ; 
		MODAL ;
		NOSIZE

		ControlRow :=  10

		For i := 1 to l

			LN := 'Label_' + Alltrim(Str(i,2,0))
			CN := 'Control_' + Alltrim(Str(i,2,0))

			@ ControlRow , 10 LABEL &LN OF _InputWindow VALUE aLabels [i] WIDTH 90

			do case
			case ValType ( aValues [i] ) == 'L'

				@ ControlRow , 120 CHECKBOX &CN OF _InputWindow CAPTION '' VALUE aValues[i]
				ControlRow := ControlRow + 30

			case ValType ( aValues [i] ) == 'D'

				@ ControlRow , 120 DATEPICKER &CN  OF _InputWindow VALUE aValues[i] WIDTH 140 
				ControlRow := ControlRow + 30

			case ValType ( aValues [i] ) == 'N'

				If ValType ( aFormats [i] ) == 'A'

					@ ControlRow , 120 COMBOBOX &CN  OF _InputWindow ITEMS aFormats[i] VALUE aValues[i] WIDTH 140  FONT 'Arial' SIZE 10
					ControlRow := ControlRow + 30

				ElseIf  ValType ( aFormats [i] ) == 'C'

					If AT ( '.' , aFormats [i] ) > 0
						@ ControlRow , 120 TEXTBOX &CN  OF _InputWindow VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 NUMERIC INPUTMASK aFormats [i] 
					Else
						@ ControlRow , 120 TEXTBOX &CN  OF _InputWindow VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 MAXLENGTH Len(aFormats [i]) NUMERIC  
					EndIf

					ControlRow := ControlRow + 30
				Endif

			case ValType ( aValues [i] ) == 'C'

				If ValType ( aFormats [i] ) == 'N'
					If  aFormats [i] <= 32
						@ ControlRow , 120 TEXTBOX &CN  OF _InputWindow VALUE aValues[i] WIDTH 140 FONT 'Arial' SIZE 10 MAXLENGTH aFormats [i]
						ControlRow := ControlRow + 30
					Else
						@ ControlRow , 120 EDITBOX &CN  OF _InputWindow WIDTH 140 HEIGHT 90 VALUE aValues[i] FONT 'Arial' SIZE 10 MAXLENGTH aFormats[i]
						ControlRow := ControlRow + 94
					EndIf
				EndIf

			case ValType ( aValues [i] ) == 'M'

				@ ControlRow , 120 EDITBOX &CN  OF _InputWindow WIDTH 140 HEIGHT 90 VALUE aValues[i] FONT 'Arial' SIZE 10 
				ControlRow := ControlRow + 94

			endcase

		Next i

		@ ControlRow + 10 , 30 BUTTON BUTTON_1 ;
		OF _InputWindow ;
		CAPTION if( Set ( _SET_LANGUAGE ) == 'ES', 'Aceptar' , 'Ok' );
		ACTION _InputWindowOk()

		@ ControlRow + 10 , 140 BUTTON BUTTON_2 ;
		OF _InputWindow ;
		CAPTION if( Set ( _SET_LANGUAGE ) == 'ES', 'Cancelar' ,'Cancel' ) ;
		ACTION _InputWindowCancel()

		_SetFocus ('Control_1','_InputWindow')

	END WINDOW

	if pcount() == 4
		CENTER WINDOW _InputWindow
	EndIf

	ACTIVATE WINDOW _InputWindow

     set(2,bf)

Return ( aResult )
*-----------------------------------------------------------------------------*
Function _InputWindowOk 
*-----------------------------------------------------------------------------*
Local i , ControlName , l 

	l := len (aResult)

	For i := 1 to l

		ControlName := 'Control_' + Alltrim ( Str ( i ) )
		aResult [i] := _GetValue ( ControlName , '_InputWindow' )

	Next i

	RELEASE WINDOW _InputWindow

Return Nil
*-----------------------------------------------------------------------------*
Function _InputWindowCancel
*-----------------------------------------------------------------------------*
Local i , l

	l := len (aResult)

	For i := 1 to l

		aResult [i] := Nil

	Next i

	RELEASE WINDOW _InputWindow

Return Nil

*-----------------------------------------------------------------------------*
Function _ReleaseControl ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i , t , r , w , z , x , y , k

	i := GetControlIndex ( ControlName, ParentForm )
	t := GetControlType ( ControlName, ParentForm )
	k := GetFormIndex (ParentForm)

	Do Case

	Case t == "GRID"

		ReleaseControl ( _HMG_SYSDATA [3] [i] )

	Case t == "ANIMATEBOX"
		_DestroyAnimateBox ( ControlName , ParentForm ) 

	Case t == "PLAYER"
		_DestroyPlayer ( ControlName , ParentForm )  

	Case t == "SPINNER"
		ReleaseControl ( _HMG_SYSDATA [3] [i] [1] )
		ReleaseControl ( _HMG_SYSDATA [3] [i] [2] )

	Case t == "STATUSBAR"

		if _IsControlDefined ( 'StatusTimer' , ParentForm )
			ReleaseControl ( _HMG_SYSDATA [3] [ GetControlIndex ( 'StatusTimer' , ParentForm) ] )
			_EraseControl ( GetControlIndex ( 'StatusTimer' , ParentForm ) , k )
		endif

		if _IsControlDefined ( 'StatusKeyBrd' , ParentForm )
			ReleaseControl ( _HMG_SYSDATA [3] [ GetControlIndex ( 'StatusKeyBrd' , ParentForm ) ] )
			_EraseControl ( GetControlIndex ( 'StatusKeyBrd' , ParentForm ) , k )
		endif

		ReleaseControl ( _HMG_SYSDATA [3] [i] )

	#ifdef COMPILEBROWSE

	Case t == "BROWSE"

		ReleaseControl ( _HMG_SYSDATA [3] [i] )

		if _HMG_SYSDATA [  5 ] [i] != 0

			ReleaseControl ( _HMG_SYSDATA [  5 ] [i] )
			ReleaseControl ( _HMG_SYSDATA [ 39 ] [i] [1])

		endif	 

	#endif

	Case t == "RADIOGROUP"

		For x:= 1 To Len( _HMG_SYSDATA [3] [i] )
			 ReleaseControl ( _HMG_SYSDATA [3] [i] [x] )
		Next x

	Case t == "TAB"

		for r = 1 to len ( _HMG_SYSDATA [  7 ] [i] )
			for w = 1 to len (_HMG_SYSDATA [  7 ] [i] [r])
				if valtype ( _HMG_SYSDATA [  7 ] [i] [r] [w] ) <> "A"
					ReleaseControl ( _HMG_SYSDATA [  7 ] [i] [r] [w] ) 
					x := ascan ( _HMG_SYSDATA [3] , _HMG_SYSDATA [  7 ] [i] [r] [w] )
					if x > 0
						_EraseControl(x,k)
					EndIf
	               	        else
					for z = 1 to len ( _HMG_SYSDATA [  7 ] [i] [r] [w] )
                	               	        ReleaseControl ( _HMG_SYSDATA [  7 ] [i] [r] [w] [z] ) 
        				Next z

					For x := 1 To Len (_HMG_SYSDATA [3])
						If ValType( _HMG_SYSDATA [3] [x] ) == 'A'
							If _HMG_SYSDATA [3] [x] [1] == _HMG_SYSDATA [  7 ] [i] [r] [w] [1]
								_EraseControl(x,k)
								Exit
							EndIf
						EndIf
					Next x

				endif
			Next w
		Next r

		ReleaseControl ( _HMG_SYSDATA [3] [i] )

	OtherWise
		ReleaseControl ( _HMG_SYSDATA [3] [i] )
	EndCase

	// If the control is inside a TAB, PageMap must be updated

	For y := 1 To Len ( _HMG_SYSDATA [  7 ] )

		if _HMG_SYSDATA [1] [y] == "TAB"

			for r = 1 to len ( _HMG_SYSDATA [  7 ] [y] )

				for w = 1 to len (_HMG_SYSDATA [  7 ] [y] [r])

					if t == 'RADIOGROUP'

					        if ValType (_HMG_SYSDATA [  7 ] [y] [r] [w]) == 'A'

							if _HMG_SYSDATA [  7 ] [y] [r] [w] [1] == _HMG_SYSDATA [3] [i] [1]

								adel ( _HMG_SYSDATA [  7 ] [y] [r] , w )
								asize ( _HMG_SYSDATA [  7 ] [y] [r] , Len(_HMG_SYSDATA [  7 ] [y] [r])-1 )
								Exit

							EndIf

						EndIf

					Elseif t == 'SPINNER'

					        if ValType (_HMG_SYSDATA [  7 ] [y] [r] [w]) == 'A'

							if _HMG_SYSDATA [  7 ] [y] [r] [w] [1] == _HMG_SYSDATA [3] [i] [1]

								adel ( _HMG_SYSDATA [  7 ] [y] [r] , w )
								asize ( _HMG_SYSDATA [  7 ] [y] [r] , Len(_HMG_SYSDATA [  7 ] [y] [r])-1 )
								Exit

							EndIf

						EndIf

					#ifdef COMPILEBROWSE

					Elseif t == 'BROWSE'

					        if ValType (_HMG_SYSDATA [  7 ] [y] [r] [w]) == 'A'

							if _HMG_SYSDATA [  7 ] [y] [r] [w] [1] == _HMG_SYSDATA [3] [i]

								adel ( _HMG_SYSDATA [  7 ] [y] [r] , w )
								asize ( _HMG_SYSDATA [  7 ] [y] [r] , Len(_HMG_SYSDATA [  7 ] [y] [r])-1 )
								Exit

							EndIf

					        Elseif ValType (_HMG_SYSDATA [  7 ] [y] [r] [w]) == 'N'

							if _HMG_SYSDATA [  7 ] [y] [r] [w] == _HMG_SYSDATA [3] [i]

								adel ( _HMG_SYSDATA [  7 ] [y] [r] , w )
								asize ( _HMG_SYSDATA [  7 ] [y] [r] , Len(_HMG_SYSDATA [  7 ] [y] [r])-1 )
								Exit

							EndIf


						EndIf

					#endif

					Else

					        if ValType (_HMG_SYSDATA [  7 ] [y] [r] [w]) == 'N'

							if _HMG_SYSDATA [  7 ] [y] [r] [w] == _HMG_SYSDATA [3] [i]

								adel ( _HMG_SYSDATA [  7 ] [y] [r] , w )
								asize ( _HMG_SYSDATA [  7 ] [y] [r] , Len(_HMG_SYSDATA [  7 ] [y] [r])-1 )
								Exit

							EndIf

						EndIf

					EndIf

				Next w

			next r

		EndIf

	Next y

	_EraseControl(i,k)

Return Nil
*------------------------------------------------------------------------------*
Function _EraseControl (i,p)
*------------------------------------------------------------------------------*
Local mVar

	DeleteObject ( _HMG_SYSDATA [ 36 ] [i] ) 
	DeleteObject ( _HMG_SYSDATA [ 37 ] [i] )

	if _HMG_SYSDATA [1] [i] == 'GRID' .Or. _HMG_SYSDATA [1] [i] == 'MULTIGRID'
		if ValType ( _HMG_SYSDATA [26] [i] ) == 'N'
			IMAGELIST_DESTROY ( _HMG_SYSDATA [ 26 ] [i] ) 
		EndIf
	EndIf	

	#ifdef COMPILEBROWSE

	if _HMG_SYSDATA [1] [i] == 'BROWSE' 
		if ValType ( _HMG_SYSDATA [39] [i] [10] ) == 'N'
			IMAGELIST_DESTROY ( _HMG_SYSDATA [ 39 ] [i] [10] ) 
		EndIf
	EndIf	

	#endif

	if _HMG_SYSDATA [1] [i] == 'COMBO'
		if ValType ( _HMG_SYSDATA [15] [i] ) == 'N'
			IMAGELIST_DESTROY ( _HMG_SYSDATA [ 15 ] [i] ) 
		EndIf
	EndIf	

	if _HMG_SYSDATA [1] [i] == 'ACTIVEX'
		DestroyWindow ( _HMG_SYSDATA [1] [i] )
		FreeLibrary ( _HMG_SYSDATA [35] [i] )
	EndIf	

	if _HMG_SYSDATA [1] [i] == 'HOTKEY'
		ReleaseHotKey ( _HMG_SYSDATA [4] [i] , _HMG_SYSDATA [  5 ] [i] )
	EndIf

	if _HMG_SYSDATA [1] [i] == 'TAB'
		If _HMG_SYSDATA [  9 ] [i] != 0
			IMAGELIST_DESTROY ( _HMG_SYSDATA [  9 ] [i] )
		EndIf
	EndIf

	mVar := '_' + _HMG_SYSDATA [  66 ] [p] + '_' + _HMG_SYSDATA [2] [i]
	if type ( mVar ) != 'U'
		__MVPUT ( mVar , 0 )
	EndIf

 	_HMG_SYSDATA [ 13 ]	[i] := .T.
	_HMG_SYSDATA [  1 ]	[i] := ""
	_HMG_SYSDATA [  2 ]	[i] := ""
	_HMG_SYSDATA [  3 ]	[i] := 0
	_HMG_SYSDATA [  4 ]	[i] := 0
	_HMG_SYSDATA [  5 ]	[i] := 0
	_HMG_SYSDATA [  6 ]	[i] := ""
	_HMG_SYSDATA [  7 ]	[i] := {}
	_HMG_SYSDATA [  8 ]	[i] := Nil	
	_HMG_SYSDATA [  9 ]	[i] := ""
	_HMG_SYSDATA [ 10 ]	[i] := ""
	_HMG_SYSDATA [ 11 ]	[i] := ""
	_HMG_SYSDATA [ 12 ]	[i] := ""
 	_HMG_SYSDATA [ 14 ]	[i] := Nil
	_HMG_SYSDATA [ 15 ]	[i] := Nil
	_HMG_SYSDATA [ 16 ]	[i] := ""
	_HMG_SYSDATA [ 17 ]	[i] := {}
	_HMG_SYSDATA [ 18 ]	[i] := 0
	_HMG_SYSDATA [ 19 ]	[i] := 0
	_HMG_SYSDATA [ 20 ]	[i] := 0
	_HMG_SYSDATA [ 21 ]	[i] := 0
	_HMG_SYSDATA [ 22 ]	[i] := 0
	_HMG_SYSDATA [ 23 ]	[i] := 0 
	_HMG_SYSDATA [ 24 ]	[i] := 0 
	_HMG_SYSDATA [ 25 ]	[i] := ''
	_HMG_SYSDATA [ 26 ]	[i] := 0 
	_HMG_SYSDATA [ 27 ]	[i] := '' 
	_HMG_SYSDATA [ 28 ]	[i] := 0  
	_HMG_SYSDATA [ 30 ]	[i] := ''  
	_HMG_SYSDATA [ 31 ]	[i] := 0
	_HMG_SYSDATA [ 32 ]	[i] := 0
	_HMG_SYSDATA [ 33 ]	[i] := '' 
	_HMG_SYSDATA [ 34 ]	[i] := .f.
	_HMG_SYSDATA [ 35 ]	[i] := 0
	_HMG_SYSDATA [ 36 ]	[i] := 0
	_HMG_SYSDATA [ 29 ]	[i] := {}
	_HMG_SYSDATA [ 37 ]	[i] := 0
	_HMG_SYSDATA [ 38 ]	[I] := .F.
	_HMG_SYSDATA [ 39 ]	[i] := 0
	_HMG_SYSDATA [ 40 ]	[i] := NIL

Return Nil
*-----------------------------------------------------------------------------*
Function _IsControlVisibleFromHandle (Handle)
*-----------------------------------------------------------------------------*
Local x
Local lVisible := .f.

	For x := 1 To Len ( _HMG_SYSDATA [3] )

		If ValType ( _HMG_SYSDATA [3] [x] ) == 'N'

			If _HMG_SYSDATA [3] [x] == Handle
				lVisible := _HMG_SYSDATA [ 34 ] [x]
				Exit
			EndIf

		ElseIf ValType ( _HMG_SYSDATA [3] [x] ) == 'A'

			If _HMG_SYSDATA [3] [x] [1] == Handle
				lVisible := _HMG_SYSDATA [ 34 ] [x]
				Exit
			EndIf

		EndIf

	Next x

Return lVisible
*-----------------------------------------------------------------------------*
Function _IsControlVisible ( ControlName , FormName)
*-----------------------------------------------------------------------------*
Local lVisible, ix

lVisible := .f.

ix := GetControlIndex ( ControlName, FormName )

if ix > 0
   lVisible := _HMG_SYSDATA [ 34 ] [ix]
endif

Return lVisible

*-----------------------------------------------------------------------------*
Function _SetCaretPos ( ControlName , FormName , Pos )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, FormName )

	if i == 0
		Return Nil
	EndIf

      	SendMessage( _HMG_SYSDATA [3] [i] , EM_SETSEL , Pos , Pos )

Return Nil
*-----------------------------------------------------------------------------*
Function _GetCaretPos ( ControlName , FormName )
*-----------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName, FormName )

	If i == 0
		Return 0
	EndIf

Return ( HiWord ( SendMessage( _HMG_SYSDATA [3] [i] , EM_GETSEL , 0 , 0 ) ) )

*-----------------------------------------------------------------------------*
Function _GetId()
*-----------------------------------------------------------------------------*
Local RetVal , i

	do while .t.

		RetVal := random (65000)

		i := ascan ( _HMG_SYSDATA [  5 ] , retval )

		if i == 0 .and. retval != 0
			exit
		EndIf

	EndDo

Return RetVal
*------------------------------------------------------------------------------*
FUNCTION Random( nLimit )
*------------------------------------------------------------------------------*
  Static snRandom := Nil
  Local nDecimals, cLimit

  DEFAULT snRandom TO Seconds() / Exp(1)
  DEFAULT nLimit   TO 65535

  snRandom  := Log( snRandom + Sqrt(2) ) * Exp(3)
  snRandom  := Val( Str(snRandom - Int(snRandom), 17, 15 ) )
  cLimit    := Transform( nLimit, "@N" )

  nDecimals := At(".", cLimit)

  if nDecimals > 0
     nDecimals := Len(cLimit)-nDecimals
  endif

Return Round( nLimit * snRandom, nDecimals )


Function _dummy()
return nil

*------------------------------------------------------------------------------*
Function cFileNoPath( cPathMask )
*------------------------------------------------------------------------------*
    local n := RAt( "\", cPathMask )

Return If( n > 0 .and. n < Len( cPathMask ), ;
	Right( cPathMask, Len( cPathMask ) - n ), ;
	If( ( n := At( ":", cPathMask ) ) > 0, ;
	Right( cPathMask, Len( cPathMask ) - n ), cPathMask ) )

*------------------------------------------------------------------------------*
Function cFileNoExt( cPathMask )
*------------------------------------------------------------------------------*
   local cName := AllTrim( cFileNoPath( cPathMask ) )
   local n     := At( ".", cName )

Return AllTrim( If( n > 0, Left( cName, n - 1 ), cName ) )

Procedure _Refresh(i)

	If _HMG_SYSDATA [1] [i] == 'COMBO'
		_DataComboRefresh (i)

	ElseIf _HMG_SYSDATA [1] [i] == 'TEXT' .Or. _HMG_SYSDATA [1] [i] == 'NUMTEXT'  .Or. _HMG_SYSDATA [1] [i] == "CHARMASKTEXT"  .Or. _HMG_SYSDATA [1] [i] == "MASKEDTEXT"
		_DataTextBoxRefresh (i)

	ElseIf _HMG_SYSDATA [1] [i] == 'DATEPICK'
		_DataDatePickerRefresh (i)

	ELseIf _HMG_SYSDATA [1] [i] == 'EDIT'
		_DataEditBoxRefresh (i)

	ELseIf _HMG_SYSDATA [1] [i] == 'CHECKBOX'
		_DataCheckBoxRefresh (i)

	#ifdef COMPILEBROWSE

	ELseIf _HMG_SYSDATA [1] [i] == 'BROWSE'
		_BrowseRefresh ('','',i)

	#endif

	ELseIf _HMG_SYSDATA [1] [i] == 'GRID'

		IF VALTYPE ( _HMG_SYSDATA [ 40 ] [ i ] [ 10 ] ) == 'C'
			DataGridRefresh(i)
		ENDIF

		_HMG_DOGRIDREFRESH(I)		

	ELseIf _HMG_SYSDATA [1] [i] == 'MULTIGRID'
		_HMG_DOGRIDREFRESH(I)

	EndIf

return

Procedure _SaveData (ControlName,ParentForm)
LOCAL I

	i := GetControlIndex ( ControlName , ParentForm )
	If _HMG_SYSDATA [1] [i] == 'TEXT' .Or. _HMG_SYSDATA [1] [i] == 'NUMTEXT'  .Or. _HMG_SYSDATA [1] [i] == "CHARMASKTEXT"  .Or. _HMG_SYSDATA [1] [i] == "MASKEDTEXT" 
		_DataTextBoxSave ( ControlName , ParentForm )
	ELseIf _HMG_SYSDATA [1] [i] == 'DATEPICK'
		_DataDatePickerSave ( ControlName , ParentForm )
	ELseIf _HMG_SYSDATA [1] [i] == 'EDIT'
		_DataEditBoxSave ( ControlName , ParentForm )
	ELseIf _HMG_SYSDATA [1] [i] == 'CHECKBOX'
		_DataCheckBoxSave ( ControlName , ParentForm )
	ELseIf _HMG_SYSDATA [1] [i] == 'GRID'
		DataGridSave ( i )
	EndIf

Return 
*------------------------------------------------------------------------------*
Function _GetFocusedControl ( cFormName )
*------------------------------------------------------------------------------*
Local nFormHandle , i , nFocusedControlHandle , nControlCount , cRetVal , x

	nFormHandle		:= GetFormHandle ( cFormName )
	nFocusedControlHandle	:= GetFocus()
	nControlCount		:= Len ( _HMG_SYSDATA [3] )

	If nFocusedControlHandle != 0

		For i := 1 To nControlCount

			If _HMG_SYSDATA [4] [i] ==  nFormHandle 
				If ValType ( _HMG_SYSDATA [3] [i] ) == 'N'
					If _HMG_SYSDATA [3] [i] == nFocusedControlHandle
						cRetVal := _HMG_SYSDATA [2] [i]
					EndIf
				ElseIf ValType ( _HMG_SYSDATA [3] [i] ) == 'A'
					For x := 1 To Len ( _HMG_SYSDATA [3] [i] )
						If _HMG_SYSDATA [3] [i] [x] == nFocusedControlHandle
							cRetVal := _HMG_SYSDATA [2] [i]
							Exit
						EndIf
					Next x
				EndIf
			EndIf

			If ! Empty ( cRetVal )
				Exit
			EndIf

		Next i

	Else

		cRetVal := ''

	EndIf

Return ( cRetVal )

*-----------------------------------------------------------------------------*
Function _SetFontColor ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
Local i 

	if value[1] == Nil .or. value[2] == Nil .or. value[3] == Nil 
		Return Nil
	EndIf

	i := GetControlIndex ( ControlName, ParentForm )

	If  _HMG_SYSDATA [1] [i] == 'GRID' .or. _HMG_SYSDATA [1] [i] == 'MULTIGRID'  .or. _HMG_SYSDATA [1] [i] == 'BROWSE'
		ListView_SetTextColor ( _HMG_SYSDATA [3] [i], value[1] , value[2] , value[3] )
		RedrawWindow ( _HMG_SYSDATA [3] [i] )

	ElseIf _HMG_SYSDATA [1] [i] == 'PROGRESSBAR'
		_HMG_SYSDATA [ 15 ] [i] := Value
		SetProgressBarBarColor(_HMG_SYSDATA [3] [i],value[1],value[2],value[3])

	Else
		_HMG_SYSDATA [ 15 ] [i] := Value
		RedrawWindow ( _HMG_SYSDATA [3] [i] )
	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _SetBackColor ( ControlName, ParentForm , Value  )
*-----------------------------------------------------------------------------*
Local i , f

	if value[1] == Nil .or. value[2] == Nil .or. value[3] == Nil 
		Return Nil
	EndIf

	i := GetControlIndex ( ControlName, ParentForm )

	If _HMG_SYSDATA [1] [i] == 'SLIDER'

		_HMG_SYSDATA [ 14 ] [i] := Value
		RedrawWindow ( _HMG_SYSDATA [3] [i] )
		f := GetFocus()
		setfocus(_HMG_SYSDATA [3][i])
		setfocus(f)

	ElseIf  _HMG_SYSDATA [1] [i] == 'GRID' .or. _HMG_SYSDATA [1] [i] == 'MULTIGRID' .or. _HMG_SYSDATA [1] [i] == 'BROWSE'

		ListView_SetBkColor ( _HMG_SYSDATA [3] [i], value[1] , value[2] , value[3] )
		ListView_SetTextBkColor ( _HMG_SYSDATA [3] [i], value[1] , value[2] , value[3] )
		RedrawWindow ( _HMG_SYSDATA [3] [i] )

	ElseIf  _HMG_SYSDATA [1] [i] == 'RICHEDIT' 

		SendMessage ( _HMG_SYSDATA [3] [i] , EM_SETBKGNDCOLOR  , 0 , RGB ( value[1] , value[2] , value[3] ) )

		RedrawWindow ( _HMG_SYSDATA [3] [i] )

	ElseIf _HMG_SYSDATA [1] [i] == 'PROGRESSBAR'
		_HMG_SYSDATA [ 14 ] [i] := Value
		SetProgressBarBkColor(_HMG_SYSDATA [3] [i],value[1],value[2],value[3])

	Else

		_HMG_SYSDATA [ 14 ] [i] := Value
		RedrawWindow ( _HMG_SYSDATA [3] [i] )

	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _GetFontColor ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i , RetVal := { Nil , Nil , Nil } , Tmp 

	i := GetControlIndex ( ControlName, ParentForm )

	If  _HMG_SYSDATA [1] [i] == 'GRID' .or. _HMG_SYSDATA [1] [i] == 'MULTIGRID'  .or. _HMG_SYSDATA [1] [i] == 'BROWSE'
		Tmp := ListView_GetTextColor ( _HMG_SYSDATA [3] [i] )
		RetVal [1] := GetRed (Tmp)
		RetVal [2] := GetGreen (Tmp)
		RetVal [3] := GetBlue (Tmp)
	Else
		RetVal := _HMG_SYSDATA [ 15 ] [i] 
	EndIf

Return RetVal

*-----------------------------------------------------------------------------*
Function _GetBackColor ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i , RetVal := { Nil , Nil , Nil } , Tmp 

	i := GetControlIndex ( ControlName, ParentForm )

	If  _HMG_SYSDATA [1] [i] == 'GRID' .or. _HMG_SYSDATA [1] [i] == 'MULTIGRID'  .or. _HMG_SYSDATA [1] [i] == 'BROWSE'
		Tmp := ListView_GetBkColor ( _HMG_SYSDATA [3] [i] )
		RetVal [1] := GetRed (Tmp)
		RetVal [2] := GetGreen (Tmp)
		RetVal [3] := GetBlue (Tmp)
	Else
		RetVal := _HMG_SYSDATA [ 14 ] [i] 
	EndIf

Return RetVal

*-----------------------------------------------------------------------------*
Function _IsControlEnabled ( ControlName, ParentForm )
*-----------------------------------------------------------------------------*
Local i , t , RetVal 

	i := GetControlIndex ( ControlName, ParentForm )
	t := GetControlType  ( ControlName, ParentForm )

	if t == 'MENU'
		RetVal := _IsMenuItemEnabled ( ControlName, ParentForm )
	Else
		RetVal := _HMG_SYSDATA [ 38 ] [i]
	EndIf

Return (RetVal)
*-----------------------------------------------------------------------------*
Function _SetStatusIcon( ControlName , ParentForm , Item , Icon )
*-----------------------------------------------------------------------------*
Local i 

	i := GetControlIndex ( ControlName , ParentForm )

	SetStatusItemIcon( _HMG_SYSDATA [3][i] , Item , Icon )

Return Nil

*-----------------------------------------------------------------------------*
Function _GetCaption( ControlName , ParentForm )
*-----------------------------------------------------------------------------*
Local i 
Local cRetVal := ''

	i := GetControlIndex ( ControlName , ParentForm )

	If _HMG_SYSDATA [1] [i] == 'TOOLBUTTON'
		cRetVal := _HMG_SYSDATA [33] [i]
	Else
		cRetVal := GetWindowText ( _HMG_SYSDATA [3] [i] )
	EndIf

Return cRetVal

*-----------------------------------------------------------------------------*
Function _GetControlFree()
*-----------------------------------------------------------------------------*
Local k

	k := ascan ( _HMG_SYSDATA [ 13 ] , .T. )

	if k == 0

		k := Len(_HMG_SYSDATA [2]) + 1

		aAdd ( _HMG_SYSDATA [1]		, Nil )
		aAdd ( _HMG_SYSDATA [2]		, Nil )
		aAdd ( _HMG_SYSDATA [3]		, Nil )
		aAdd ( _HMG_SYSDATA [4]		, Nil )
		aAdd ( _HMG_SYSDATA [  5 ]	, Nil )
		aAdd ( _HMG_SYSDATA [  6 ]	, Nil )
		aAdd ( _HMG_SYSDATA [  7 ]	, Nil )
		aAdd ( _HMG_SYSDATA [  8 ]	, Nil )	
		aAdd ( _HMG_SYSDATA [  9 ]	, Nil )	
		aAdd ( _HMG_SYSDATA [ 10 ]	, Nil )	
		aAdd ( _HMG_SYSDATA [ 11 ]	, Nil )	
		aAdd ( _HMG_SYSDATA [ 12 ]	, Nil )	
		aAdd ( _HMG_SYSDATA [ 13 ]	, Nil )	
		aAdd ( _HMG_SYSDATA [ 14 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 15 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 16 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 17 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 18 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 19 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 20 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 21 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 22 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 23 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 24 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 25 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 26 ]	, Nil ) 
		aAdd ( _HMG_SYSDATA [ 27 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 28 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 29 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 30 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 31 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 32 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 33 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 34 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 35 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 36 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 37 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 38 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 39 ]	, Nil )
		aAdd ( _HMG_SYSDATA [ 40 ]	, Nil )

	EndIf

Return k

*-----------------------------------------------------------------------------*
Function httpconnect( Connection , Server , Port )
*-----------------------------------------------------------------------------*

Return Nil

*------------------------------------------------------------------------------*
Procedure _SetAddress ( ControlName , ParentForm , url )
*------------------------------------------------------------------------------*
Local i

	i := GetControlIndex ( ControlName , ParentForm )

	if i > 0

		if at("@",url)>0        

			_HMG_SYSDATA [  6 ] [i] := {||ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler mailto:"+url, ,1)}
			_HMG_SYSDATA [  8 ] [i] := url

		elseif at("http",url)>0

			_HMG_SYSDATA [  6 ] [i] := {||ShellExecute(0, "open", "rundll32.exe", "url.dll,FileProtocolHandler " + url, ,1)}
			_HMG_SYSDATA [  8 ] [i] := url

		else

			MsgHMGError ("Control: " + ControlName + " must have valid email or url defined. Program Terminated")

		EndIf

	EndIf

Return

*------------------------------------------------------------------------------*
Function _GetAddress ( ControlName , ParentForm )
*------------------------------------------------------------------------------*
Local i , RetVal := ''

	i := GetControlIndex ( ControlName , ParentForm )

	if i > 0

		RetVal := _HMG_SYSDATA [  8 ] [i]

	EndIf

Return RetVal

Function GetStartUpFolder()

Local StartUpFolder := GetProgramFileName()

Return Left ( StartUpFolder , Rat ( '\' , StartUpFolder ) - 1 )

///////////////////////////////////////////////////////////////////////////////
// HARBOUR LEVEL PRINT ROUTINES
///////////////////////////////////////////////////////////////////////////////

#define WM_CLOSE        0x0010
#define SB_HORZ	0
#define SB_VERT	1

#define WM_VSCROLL                      0x0115

DECLARE WINDOW _HMG_PRINTER_PPNAV

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_SHOWPREVIEW
*------------------------------------------------------------------------------*
Local ModalHandle := 0
Local Tmp
Local i
Local cMacroTemp
Local tWidth
Local tHeight
Local tFactor
Local tvHeight
Local tvWidth
Local cAction
Local ttHandle
Local icb := 0
local ppnavtitle


_HMG_SYSDATA [ 360 ] := GetTempFolder() + 	_HMG_SYSDATA [ 379 ] + "_hmg_print_preview_"
_HMG_SYSDATA [ 361 ] := 1
_HMG_SYSDATA [ 362 ] := NIL
_HMG_SYSDATA [ 363 ] := 0
_HMG_SYSDATA [ 364 ] := 0
_HMG_SYSDATA [ 365 ] := 0
_HMG_SYSDATA [ 366 ] := 10
_HMG_SYSDATA [ 367 ] := 0
_HMG_SYSDATA [ 368 ] := .T.
_HMG_SYSDATA [ 369 ] := NIL
_HMG_SYSDATA [ 370 ] := 0

	if _HMG_SYSDATA [ 271 ] == .T.

		ModalHandle := _HMG_SYSDATA [ 167 ]

		_HMG_SYSDATA [ 271 ] := .F.
		_HMG_SYSDATA [ 167 ] := 0

		DisableWindow ( ModalHandle )

	Else

		ModalHandle := 0

	EndIf

	if _HMG_SYSDATA [ 372 ] == 0
		Return
	EndIf

	if _IsWindowDefined ( "_HMG_PRINTER_SHOWPREVIEW" )
		Return
	endif

	icb := _HMG_SYSDATA [ 339 ]

	set interactiveclose on

	_HMG_SYSDATA [ 362 ] := GetDesktopHeight() / _HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) * 0.63

	IF _HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ] ) > 370
		_HMG_SYSDATA [ 359 ] := - 250
	ELSE
		_HMG_SYSDATA [ 359 ] := 0
	ENDIF

	define window _HMG_PRINTER_Wait at 0,0 width 310 height 85 title '' child noshow nocaption
		define label label_1
			row 30
			col 5
			width 300
			height 30
			value _HMG_SYSDATA [ 371 ] [29]
			centeralign .t.
		end label
	end window

	_HMG_PRINTER_Wait.Center

	ppnavtitle := _HMG_SYSDATA [ 371 ] [01] + ' [' + alltrim(str(_HMG_SYSDATA [ 361 ])) + '/'+alltrim(str(_HMG_SYSDATA [ 380 ])) + ']'

	DEFINE WINDOW _HMG_PRINTER_SHOWPREVIEW ;
			AT 0,0 ;
			WIDTH GetDesktopWidth() - 103 - IF ( ISVISTA() .And. IsAppThemed() , 25 , 0);
			HEIGHT GetDesktopHeight() - 103  - IF ( ISVISTA() .And. IsAppThemed() , 25 , 0);
			VIRTUAL WIDTH ( GetDesktopWidth() - 103 ) * 2 ;
			VIRTUAL HEIGHT ( GetDesktopHeight() - 103 ) * 2 ;
			TITLE ppnavtitle ;
			CHILD ;
			NOSIZE ;
			NOMINIMIZE ;
			NOMAXIMIZE ;
			NOSYSMENU ;
			CURSOR "HP_GLASS" ;
			ON PAINT _HMG_PRINTER_PREVIEWRefresh() ;
			BACKCOLOR GRAY ;
			ON MOUSECLICK	( If ( _HMG_PRINTER_PPNAV.b5.value == .T. , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_UNCHECKED , 0 ) , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_CHECKED , 0 ) ) , _HMG_PRINTER_MouseZoom() ) ;
			ON SCROLLUP	_HMG_PRINTER_ScrolluP() ;
			ON SCROLLDOWN	_HMG_PRINTER_ScrollDown() ;
			ON SCROLLLEFT	_HMG_PRINTER_ScrollLeft() ;
			ON SCROLLRIGHT	_HMG_PRINTER_ScrollRight() ;
			ON HSCROLLBOX	_HMG_PRINTER_hScrollBoxProcess() ;
			ON VSCROLLBOX	_HMG_PRINTER_vScrollBoxProcess()

			ON KEY HOME		ACTION ( _HMG_SYSDATA [ 361 ]:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY PRIOR		ACTION ( _HMG_SYSDATA [ 361 ]-- , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY NEXT		ACTION ( _HMG_SYSDATA [ 361 ]++ , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY END		ACTION ( _HMG_SYSDATA [ 361 ]:= _HMG_SYSDATA [ 380 ], _HMG_PRINTER_PREVIEWRefresh() )
			ON KEY CONTROL+P	ACTION _HMG_PRINTER_PrintPages()
			ON KEY CONTROL+G	ACTION _HMG_PRINTER_GO_TO_PAGE()
			ON KEY ESCAPE		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY MULTIPLY 	ACTION ( If ( _HMG_PRINTER_PPNAV.b5.value == .T. , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_UNCHECKED , 0 ) , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_CHECKED , 0 ) ) , _HMG_PRINTER_MouseZoom() )
			ON KEY CONTROL+C	ACTION _HMG_PRINTER_PreviewClose()
			ON KEY ALT+F4		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY CONTROL+S	ACTION _hmg_printer_savepages()
			ON KEY CONTROL+T	ACTION _hmg_printer_ThumbnailToggle()

	END WINDOW

	Define Window _HMG_PRINTER_PRINTPAGES		;
		At 0,0					;
		Width 420				;
		Height 168 + GetTitleHeight()		;
		Title _HMG_SYSDATA [ 371 ] [9]	;
		CHILD NOSHOW 				;
		NOSIZE NOSYSMENU

		ON KEY ESCAPE	ACTION ( HideWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus )
		ON KEY RETURN	ACTION _HMG_PRINTER_PrintPagesDo()

		Define Frame Frame_1
			Row 5
			Col 10
			Width 275
			Height 147
			FontName 'Arial'
			FontSize 9
			Caption _HMG_SYSDATA [ 371 ] [15]
		End Frame

		Define RadioGroup Radio_1
			Row 25
			Col 20
			FontName 'Arial'
			FontSize 9
			Value 1
			Options { _HMG_SYSDATA [ 371 ] [16] , _HMG_SYSDATA [ 371 ] [17] }
			OnChange if ( This.value == 1 , ( _HMG_PRINTER_PRINTPAGES.Label_1.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Label_2.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Spinner_1.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Spinner_2.Enabled := .F. , _HMG_PRINTER_PRINTPAGES.Combo_1.Enabled := .F.  , _HMG_PRINTER_PRINTPAGES.Label_4.Enabled := .F. ) , ( _HMG_PRINTER_PRINTPAGES.Label_1.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Label_2.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Spinner_1.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Spinner_2.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Combo_1.Enabled := .T.  , _HMG_PRINTER_PRINTPAGES.Label_4.Enabled := .T. , _HMG_PRINTER_PRINTPAGES.Spinner_1.SetFocus ) )
		End RadioGroup

		Define Label Label_1
			Row 84
			Col 55
			Width 50
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 371 ] [18] + ':'
		End Label

		Define Spinner Spinner_1
			Row 81
			Col 110
			Width 50
			FontName 'Arial'
			FontSize 9
			Value 1
			RangeMin 1
			RangeMax _HMG_SYSDATA [ 380 ]
		End Spinner

		Define Label Label_2
			Row 84
			Col 165
			Width 35
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 371 ] [19] + ':'
		End Label

		Define Spinner Spinner_2
			Row 81
			Col 205
			Width 50
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 380 ]
			RangeMin 1
			RangeMax _HMG_SYSDATA [ 380 ]
		End Spinner

		Define Label Label_4
			Row 115
			Col 55
			Width 50
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 371 ] [09] + ':'
		End Label

		Define ComboBox Combo_1
			Row 113
			Col 110
			Width 145
			FontName 'Arial'
			FontSize 9
			Value 1
			Items {_HMG_SYSDATA [ 371 ] [21] , _HMG_SYSDATA [ 371 ] [22] , _HMG_SYSDATA [ 371 ] [23] }
		End ComboBox

		Define Button Ok
			Row 10
			Col 300
			Width 105
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _HMG_SYSDATA [ 371 ] [11]
			Action _HMG_PRINTER_PrintPagesDo()
		End Button

		Define Button Cancel
			Row 40
			Col 300
			Width 105
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _HMG_SYSDATA [ 371 ] [12]
			Action ( EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , HideWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus )
		End Button

		Define Label Label_3
			Row 103
			Col 300
			Width 45
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 371 ] [20] + ':'
		End Label

		Define Spinner Spinner_3
			Row 100
			Col 355
			Width 50
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 376 ]
			RangeMin 1
			RangeMax 999
			OnChange ( if ( IsControlDefined (CheckBox_1,_HMG_PRINTER_PRINTPAGES) , If ( This.Value > 1 , SetProperty( '_HMG_PRINTER_PRINTPAGES' , 'CheckBox_1','Enabled',.T.) , SetProperty( '_HMG_PRINTER_PRINTPAGES','CheckBox_1','Enabled', .F. ) ) , Nil ) )
		End Spinner

		Define CheckBox CheckBox_1
			Row 132
			Col 300
			Width 110
			FontName 'Arial'
			FontSize 9
			Value if ( _HMG_SYSDATA [ 377 ] == 1 , .T. , .F. )
			Caption _HMG_SYSDATA [ 371 ] [14]
		End CheckBox

	End Window

	Center Window _HMG_PRINTER_PRINTPAGES

	Define Window _HMG_PRINTER_GO_TO_PAGE		;
		At 0,0					;
		Width 195				;
		Height 90 + GetTitleHeight()		;
		Title _HMG_SYSDATA [ 371 ] [07] 	;
		CHILD NOSHOW				;
		NOSIZE NOSYSMENU

		ON KEY ESCAPE	ACTION ( HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )  , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus  )
		ON KEY RETURN	ACTION ( _HMG_SYSDATA [ 361 ] := _HMG_PRINTER_GO_TO_PAGE.Spinner_1.Value , HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )  , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_PREVIEWRefresh() , _HMG_PRINTER_SHOWPREVIEW.setfocus  )

		Define Label Label_1
			Row 13
			Col 10
			Width 94
			Height 25
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 371 ] [10] + ':'
		End Label

		Define Spinner Spinner_1
			Row 10
			Col 105
			Width 75
			FontName 'Arial'
			FontSize 9
			Value _HMG_SYSDATA [ 361 ]
			RangeMin 1
			RangeMax _HMG_SYSDATA [ 380 ]
		End Spinner

		Define Button Ok
			Row 48
			Col 10
			Width 80
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _HMG_SYSDATA [ 371 ] [11]
			Action ( _HMG_SYSDATA [ 361 ] := _HMG_PRINTER_GO_TO_PAGE.Spinner_1.Value , HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_PREVIEWRefresh() , _HMG_PRINTER_SHOWPREVIEW.setfocus  )
		End Button

		Define Button Cancel
			Row 48
			Col 100
			Width 80
			Height 25
			FontName 'Arial'
			FontSize 9
			Caption _HMG_SYSDATA [ 371 ] [12]
			Action ( HideWindow( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )  , EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) , EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) , _HMG_PRINTER_SHOWPREVIEW.setfocus  )
		End Button

	End Window

	Center Window _HMG_PRINTER_GO_TO_PAGE

	if _HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) > _HMG_PRINTER_GETPAGEWIDTH(_HMG_SYSDATA [ 372 ])
		tFactor := 0.44
	else
		tFactor := 0.26
	endif

	tWidth	:=_HMG_PRINTER_GETPAGEWIDTH(_HMG_SYSDATA [ 372 ]) * tFactor
	tHeight :=_HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) * tFactor

	tHeight := Int (tHeight)	

	tvHeight := ( _HMG_SYSDATA [ 380 ] * (tHeight + 10) ) + GetHScrollbarHeight() + GetTitleHeight() + ( GetBorderHeight() * 2 ) + 7 

	if tvHeight <= GetDesktopHeight() - 103
		_HMG_SYSDATA [ 369 ] := .f.
		tvHeight := GetDesktopHeight() - 102
	else
		_HMG_SYSDATA [ 369 ] := .t.
	EndIf

	DEFINE WINDOW _HMG_PRINTER_SHOWTHUMBNAILS ;
		AT 0,5 ;
		WIDTH 130 ;
		HEIGHT GetDesktopHeight() - 103 - IF ( ISVISTA() .And. IsAppThemed() , 25 , 0) ;
		VIRTUAL WIDTH 131 ;
		VIRTUAL HEIGHT tvHeight ;
		TITLE _HMG_SYSDATA [ 371 ] [28] ;
		CHILD ;
		NOSIZE ;
		NOMINIMIZE ;
		NOMAXIMIZE ;
		NOSYSMENU ;
		NOSHOW ;
		BACKCOLOR GRAY

		ON KEY HOME		ACTION ( _HMG_SYSDATA [ 361 ]:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
		ON KEY PRIOR		ACTION ( _HMG_SYSDATA [ 361 ]-- , _HMG_PRINTER_PREVIEWRefresh()  )
		ON KEY NEXT		ACTION ( _HMG_SYSDATA [ 361 ]++ , _HMG_PRINTER_PREVIEWRefresh()  )
		ON KEY END		ACTION ( _HMG_SYSDATA [ 361 ]:= _HMG_SYSDATA [ 380 ], _HMG_PRINTER_PREVIEWRefresh() )
		ON KEY CONTROL+P	ACTION _HMG_PRINTER_PrintPages()
		ON KEY CONTROL+G	ACTION _HMG_PRINTER_GO_TO_PAGE()
		ON KEY ESCAPE		ACTION _HMG_PRINTER_PreviewClose()
		ON KEY MULTIPLY 	ACTION ( If ( _HMG_PRINTER_PPNAV.b5.value == .T. , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_UNCHECKED , 0 ) , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_CHECKED , 0 ) ) , _HMG_PRINTER_MouseZoom() )
		ON KEY CONTROL+C	ACTION _HMG_PRINTER_PreviewClose()
		ON KEY ALT+F4		ACTION _HMG_PRINTER_PreviewClose()
		ON KEY CONTROL+S	ACTION _hmg_printer_savepages()
		ON KEY CONTROL+T	ACTION _hmg_printer_ThumbnailToggle()

	END WINDOW

	if _HMG_SYSDATA [ 369 ] == .f.
		_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWTHUMBNAILS'))
	endif

	DEFINE WINDOW _HMG_PRINTER_PPNAV ;
			AT 1 + IF( ISVISTA()  .And. IsAppThemed() , 3 , 0 ) , GetDesktopWidth() - 320 - IF ( ISVISTA() .And. IsAppThemed() , 5 , 0) ;
			WIDTH 312 + GetBorderWidth() ;
			HEIGHT 35 + GetTitleHeight() + GetBorderHeight() - IF ( ISVISTA() .And. IsAppThemed() , 3 , 0);
			TITLE _HMG_SYSDATA [ 371 ] [02] ;
			CHILD  ;
			NOMAXIMIZE ;
			NOMINIMIZE ;
			NOSIZE ;
			NOSYSMENU

			DEFINE BUTTON b1
				ROW 2
				COL 2
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_TOP"
				TOOLTIP _HMG_SYSDATA [ 371 ] [03]
				ACTION ( _HMG_SYSDATA [ 361 ]:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE BUTTON b2
				ROW 2
				COL 32
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_BACK"
				TOOLTIP _HMG_SYSDATA [ 371 ] [04]
				ACTION ( _HMG_SYSDATA [ 361 ]-- , _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE BUTTON b3
				ROW 2
				COL 62
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_NEXT"
				TOOLTIP _HMG_SYSDATA [ 371 ] [05]
				ACTION ( _HMG_SYSDATA [ 361 ]++ , _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE BUTTON b4
				ROW 2
				COL 92
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_END"
				TOOLTIP _HMG_SYSDATA [ 371 ] [06]
				ACTION ( _HMG_SYSDATA [ 361 ]:= _HMG_SYSDATA [ 380 ], _HMG_PRINTER_PREVIEWRefresh()  )
			END BUTTON

			DEFINE CHECKBUTTON thumbswitch
				ROW 2
				COL 126
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_THUMBNAIL"
				TOOLTIP _HMG_SYSDATA [ 371 ] [28] + ' [Ctrl+T]'
				OnChange _HMG_PRINTER_ProcessTHUMBNAILS()
			END CHECKBUTTON

			DEFINE BUTTON GoToPage
				ROW 2
				COL 156
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_GOPAGE"
				TOOLTIP _HMG_SYSDATA [ 371 ] [07] + ' [Ctrl+G]'
				ACTION _HMG_PRINTER_GO_TO_PAGE()
			END BUTTON

			DEFINE CHECKBUTTON b5
				ROW 2
				COL 186
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_ZOOM"
				TOOLTIP _HMG_SYSDATA [ 371 ] [08] + ' [*]'
				ON CHANGE _HMG_PRINTER_Zoom()
			END CHECKBUTTON

			DEFINE BUTTON b12
				ROW 2
				COL 216
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_PRINT"
				TOOLTIP _HMG_SYSDATA [ 371 ] [09] + ' [Ctrl+P]'
				ACTION _HMG_PRINTER_PrintPages()
			END BUTTON

			DEFINE BUTTON b7
				ROW 2
				COL 246
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_SAVE"
				TOOLTIP _HMG_SYSDATA [ 371 ] [27] + ' [Ctrl+S]'
				ACTION _hmg_printer_savepages()
			END BUTTON

			DEFINE BUTTON b6
				ROW 2
				COL 280
				WIDTH 30
				HEIGHT 30
				PICTURE "HP_CLOSE"
				TOOLTIP _HMG_SYSDATA [ 371 ] [26] + ' [Ctrl+C]'
				ACTION _HMG_PRINTER_PreviewClose()
			END BUTTON

			ON KEY HOME		ACTION ( _HMG_SYSDATA [ 361 ]:=1 , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY PRIOR		ACTION ( _HMG_SYSDATA [ 361 ]-- , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY NEXT		ACTION ( _HMG_SYSDATA [ 361 ]++ , _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY END		ACTION ( _HMG_SYSDATA [ 361 ]:= _HMG_SYSDATA [ 380 ], _HMG_PRINTER_PREVIEWRefresh()  )
			ON KEY CONTROL+P	ACTION _HMG_PRINTER_Printpages()
			ON KEY CONTROL+G	ACTION _HMG_PRINTER_GO_TO_PAGE()
			ON KEY ESCAPE		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY MULTIPLY 	ACTION ( If ( _HMG_PRINTER_PPNAV.b5.value == .T. , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_UNCHECKED , 0 ) , SendMessage( GetControlHandle ('b5','_HMG_PRINTER_PPNAV') , BM_SETCHECK  , BST_CHECKED , 0 ) ) , _HMG_PRINTER_MouseZoom() )
			ON KEY CONTROL+C	ACTION _HMG_PRINTER_PreviewClose()
			ON KEY ALT+F4		ACTION _HMG_PRINTER_PreviewClose()
			ON KEY CONTROL+S	ACTION _hmg_printer_savepages()
			ON KEY CONTROL+T	ACTION _hmg_printer_ThumbnailToggle()

	END WINDOW

	SetScrollRange ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 0 , 100 , .T. )
	SetScrollRange ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 0 , 100 , .T. )

	SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 50 , .T. )
	SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 50 , .T. )

	_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	_HMG_PRINTER_PREVIEW_DISABLEHSCROLLBAR (GetFormHandle('_HMG_PRINTER_SHOWTHUMBNAILS'))

	CENTER WINDOW _HMG_PRINTER_SHOWPREVIEW

	Tmp := _HMG_PRINTER_SHOWPREVIEW.ROW  

	Tmp := Tmp + GetTitleHeight() - 10

	_HMG_PRINTER_SHOWPREVIEW.ROW := Tmp

	_HMG_PRINTER_SHOWTHUMBNAILS.ROW := Tmp

	ACTIVATE WINDOW _HMG_PRINTER_PRINTPAGES , _HMG_PRINTER_GO_TO_PAGE , _HMG_PRINTER_SHOWTHUMBNAILS , _HMG_PRINTER_SHOWPREVIEW , _HMG_PRINTER_Wait , _HMG_PRINTER_PPNAV 

	_HMG_SYSDATA [ 374 ] := _HMG_SYSDATA [ 372 ] 

	If ModalHandle != 0

		For i := 1 To Len ( _HMG_SYSDATA [ 67  ] )
			If _HMG_SYSDATA [  65 ] [i] == .F.
				If _HMG_SYSDATA [ 69  ] [i] != 'X'
					If _HMG_SYSDATA [ 67  ] [i] != ModalHandle
						DisableWindow (_HMG_SYSDATA [ 67  ] [i] )
					EndIf
				EndIf
			EndIf
		Next i

		EnableWIndow ( ModalHandle )
		SetFocus ( ModalHandle )

		_HMG_SYSDATA [ 271 ] := .T.
		_HMG_SYSDATA [ 167 ] := ModalHandle

	Endif

	_HMG_SYSDATA [ 339 ] := icb

Return
*------------------------------------------------------------------------------*
Procedure CreateThumbNails
*------------------------------------------------------------------------------*
Local tFactor
Local tWidth
Local tHeight
Local ttHandle
Local i
Local cMacroTemp
Local cAction

	If _IsControlDefined ( 'Image1' , '_HMG_PRINTER_SHOWTHUMBNAILS' )
		Return
	EndIf

	ShowWindow ( GetFormHandle ( "_HMG_PRINTER_Wait" ) )

	if _HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) > _HMG_PRINTER_GETPAGEWIDTH(_HMG_SYSDATA [ 372 ])
		tFactor := 0.44
	else
		tFactor := 0.26
	endif

	tWidth	:=_HMG_PRINTER_GETPAGEWIDTH(_HMG_SYSDATA [ 372 ]) * tFactor
	tHeight :=_HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) * tFactor

	tHeight := Int (tHeight)	

	ttHandle := GetFormToolTipHandle ('_HMG_PRINTER_SHOWTHUMBNAILS')

	For i := 1 To _HMG_SYSDATA [ 380 ]

		cMacroTemp := 'Image' + alltrim(str(i))

		cAction := "( _HMG_SYSDATA [ 361 ]:="+ alltrim(str(i)) +", _HMG_SYSDATA [ 368 ] := .F. , _HMG_PRINTER_PREVIEWRefresh() , _HMG_SYSDATA [ 368 ] := .T. )"

		_DefineImage(;
			cMacroTemp,;
			'_HMG_PRINTER_SHOWTHUMBNAILS',;
			10,;
			( i * (tHeight + 10) ) - tHeight,;
			_HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf",;
			tWidth,;
			tHeight,;
			{ || &cAction },;
			Nil,;
			.F.,;
			.F.,;
			.T.;
			)

		SetToolTip ( GetControlHandle ( cMacroTemp ,'_HMG_PRINTER_SHOWTHUMBNAILS'), _HMG_SYSDATA [ 371 ] [01] + ' ' + AllTrim(Str(i)) + ' [Click]' , ttHandle )
			
	Next i

	HideWindow ( GetFormHandle ( "_HMG_PRINTER_Wait" ) )

Return
*------------------------------------------------------------------------------*
Function _hmg_printer_ThumbnailToggle()
*------------------------------------------------------------------------------*

	if _HMG_PRINTER_PPNAV.thumbswitch.Value == .t. 

		_HMG_PRINTER_PPNAV.thumbswitch.Value := .f. 

	Else

		_HMG_PRINTER_PPNAV.thumbswitch.Value := .t. 
	
	EndIf

	_HMG_PRINTER_ProcessTHUMBNAILS()

Return .F.
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ProcessTHUMBNAILS()
*------------------------------------------------------------------------------*
Local Tmp

	If _HMG_PRINTER_PPNAV.thumbswitch.Value == .T.

		CreateThumbNails()

		_HMG_SYSDATA [ 367 ] := 90

		_HMG_SYSDATA [ 362 ] := GetDesktopHeight() / _HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) * 0.58

		_HMG_PRINTER_SHOWPREVIEW.Width := GetDesktopWidth() - 148 - IF ( ISVISTA() .And. IsAppThemed() , 30 , 0 )

		_HMG_PRINTER_SHOWPREVIEW.Col := 138 + IF ( ISVISTA() .And. IsAppThemed() , 20 , 0 )

		ShowWindow ( GetFormHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) )

	else

		_HMG_SYSDATA [ 367 ] := 0

		_HMG_SYSDATA [ 362 ] := GetDesktopHeight() / _HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) * 0.63

		_HMG_PRINTER_SHOWPREVIEW.Width := GetDesktopWidth() - 103
		_HMG_PRINTER_SHOWPREVIEW.Col := 51

		HideWindow ( GetFormHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) )

		_HMG_PRINTER_PPNAV.SetFocus

	EndIf

Return
*------------------------------------------------------------------------------*
Procedure _hmg_printer_savepages
*------------------------------------------------------------------------------*
Local c , i , f , t , d , x
local a := {}

	x := GetFolder()

	if empty(x)
		return
	endif

	If right(x,1) != '\'
		x := x + '\'
	endif

	t := gettempfolder() 

	c := adir ( t + _HMG_SYSDATA [ 379 ]  + "_hmg_print_preview_*.Emf")

	asize ( a , c )

	adir ( t + _HMG_SYSDATA [ 379 ]  + "_hmg_print_preview_*.Emf" , a )

	For i := 1 To c
		f := t + a [i]
		d := x + 'Harbour_MiniPrint_' + StrZero ( i , 4 ) + '.Emf'
		COPY FILE (F) TO (D)
	Next i

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_GO_TO_PAGE
*------------------------------------------------------------------------------*

	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) 

	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) )

	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )

	ShowWindow ( GetFormHandle ( "_HMG_PRINTER_GO_TO_PAGE" ) )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_hScrollBoxProcess()
*------------------------------------------------------------------------------*
Local Sp

	Sp := GetScrollPos (  GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ )

	_HMG_SYSDATA [ 363 ]	:= - ( Sp - 50 ) * 10

	_HMG_PRINTER_PREVIEWRefresh()

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_vScrollBoxProcess()
*------------------------------------------------------------------------------*
Local Sp

	Sp := GetScrollPos (  GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT )

	_HMG_SYSDATA [ 364 ]	:= - ( Sp - 50 ) * 10

	_HMG_PRINTER_PREVIEWRefresh()

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PreviewClose()
*------------------------------------------------------------------------------*

	_HMG_PRINTER_CleanPreview()

	_HMG_PRINTER_WAIT.Release
	_HMG_PRINTER_SHOWTHUMBNAILS.Release
	_HMG_PRINTER_SHOWPREVIEW.Release
	_HMG_PRINTER_GO_TO_PAGE.Release
	_HMG_PRINTER_PRINTPAGES.Release
	_HMG_PRINTER_PPNAV.Release

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_CleanPreview
*------------------------------------------------------------------------------*
Local c , i , f , t
Local a := {}

	t := gettempfolder() 

	c := adir ( t + _HMG_SYSDATA [ 379 ]  + "_hmg_print_preview_*.Emf")

	asize ( a , c )

	adir ( t + _HMG_SYSDATA [ 379 ]  + "_hmg_print_preview_*.Emf" , a )

	For i := 1 To c
		f := t + a [i]
		DELETE FILE (f)
	Next i

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PREVIEWRefresh 
*------------------------------------------------------------------------------*
Local hwnd
Local nRow
Local nScrollMax

	If _IsControlDefined ( 'Image' + AllTrim(Str(_HMG_SYSDATA [ 361 ])) , '_HMG_PRINTER_SHOWTHUMBNAILS' ) .and. _HMG_SYSDATA [ 368 ] == .T. .and. _HMG_SYSDATA [ 369 ] == .T.

		if _HMG_SYSDATA [ 370 ] != _HMG_SYSDATA [ 361 ]

			_HMG_SYSDATA [ 370 ] := _HMG_SYSDATA [ 361 ]
			hwnd := GetFormHandle('_HMG_PRINTER_SHOWTHUMBNAILS')
			nRow := GetProperty ( '_HMG_PRINTER_SHOWTHUMBNAILS' , 'Image' + AllTrim(Str(_HMG_SYSDATA [ 361 ])) , 'Row' )
			nScrollMax := GetScrollRangeMax ( hwnd , SB_VERT )

		if _HMG_SYSDATA [ 380 ] == _HMG_SYSDATA [ 361 ]

			if GetScrollPos(hwnd,SB_VERT) != nScrollMax
				_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , nScrollMax )
			EndIf

		ElseIf _HMG_SYSDATA [ 361 ] == 1 

			if GetScrollPos(hwnd,SB_VERT) != 0
				_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , 0 )
			EndIf

		Else

			if ( nRow - 9 ) < nScrollMax 
				_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , nRow - 9 )
			Else
				if GetScrollPos(hwnd,SB_VERT) != nScrollMax
					_HMG_PRINTER_SETVSCROLLVALUE ( hwnd , nScrollMax )
				EndIf
			EndIf

		EndIf

		EndIf

	EndIf

	if _HMG_SYSDATA [ 361 ] < 1 
		_HMG_SYSDATA [ 361 ] := 1
		PlayBeep()
		Return
	EndIf

	if _HMG_SYSDATA [ 361 ] > _HMG_SYSDATA [ 380 ]
		_HMG_SYSDATA [ 361 ] := _HMG_SYSDATA [ 380 ]
		PlayBeep()
		Return
	EndIf

	_HMG_PRINTER_SHOWPAGE ( _HMG_SYSDATA [ 360 ] + strzero(_HMG_SYSDATA [ 361 ],4) + ".emf" , GetFormhandle ('_HMG_PRINTER_SHOWPREVIEW') , _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 362 ] * 10000 , _HMG_SYSDATA [ 365 ] , _HMG_SYSDATA [ 363 ] , _HMG_SYSDATA [ 364 ] ) 

	_HMG_PRINTER_SHOWPREVIEW.TITLE := _HMG_SYSDATA [ 371 ] [01] + ' [' + alltrim(str(_HMG_SYSDATA [ 361 ])) + '/'+alltrim(str(_HMG_SYSDATA [ 380 ])) + ']'

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PrintPages
*------------------------------------------------------------------------------*
Local i
Local aProp := {}

	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) 
	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) )
	DIsableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )

	_HMG_PRINTER_PRINTPAGES.Radio_1.Value := 1

	_HMG_PRINTER_PRINTPAGES.Label_1.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Label_2.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Label_4.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Spinner_1.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Spinner_2.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.Combo_1.Enabled := .F.
	_HMG_PRINTER_PRINTPAGES.CheckBox_1.Enabled := .F.

	if	_HMG_SYSDATA [ 286 ] ;
		.or. ;
		_HMG_SYSDATA [ 287 ] 

		_HMG_PRINTER_PRINTPAGES.Spinner_3.Enabled := .F.

	endif

	ShowWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_PrintPagesDo
*------------------------------------------------------------------------------*
Local i
Local PageFrom
Local PageTo
Local p
Local OddOnly := .F.
Local EvenOnly := .F.

	If _HMG_PRINTER_PrintPages.Radio_1.Value == 1

		PageFrom := 1 
		PageTo	 := _HMG_SYSDATA [ 380 ]

	ElseIf _HMG_PRINTER_PrintPages.Radio_1.Value == 2

		PageFrom := _HMG_PRINTER_PrintPages.Spinner_1.Value
		PageTo	 := _HMG_PRINTER_PrintPages.Spinner_2.Value

		If _HMG_PRINTER_PrintPages.Combo_1.Value == 2
			OddOnly := .T. 
		ElseIf _HMG_PRINTER_PrintPages.Combo_1.Value == 3
			EvenOnly := .T.
		EndIf

	EndIf

	_HMG_PRINTER_StartDoc ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 358 ] )


	If _HMG_PRINTER_PrintPages.Spinner_3.Value == 1 // Copies 

		For i := PageFrom To PageTo

			If OddOnly == .T.
				If i / 2 != int (i / 2)
					_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
				EndIf
			ElseIf EvenOnly == .T.
				If i / 2 == int (i / 2)
					_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
				EndIf
			Else
				_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
			EndIf

		Next i

	Else

		If _HMG_PRINTER_PrintPages.CheckBox_1.Value == .F.

			For p := 1 To _HMG_PRINTER_PrintPages.Spinner_3.Value

				For i := PageFrom To PageTo

					If OddOnly == .T.
						If i / 2 != int (i / 2)
							_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
						EndIf
					ElseIf EvenOnly == .T.
						If i / 2 == int (i / 2)
							_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
						EndIf
					Else
						_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
					EndIf

				Next i

			Next p

		Else

			For i := PageFrom To PageTo

				For p := 1 To _HMG_PRINTER_PrintPages.Spinner_3.Value

					If OddOnly == .T.
						If i / 2 != int (i / 2)
							_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
						EndIf
					ElseIf EvenOnly == .T.
						If i / 2 == int (i / 2)
							_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
						EndIf
					Else
						_HMG_PRINTER_PRINTPAGE ( _HMG_SYSDATA [ 372 ] , _HMG_SYSDATA [ 360 ] + strzero(i,4) + ".emf" )
					EndIf

				Next p

			Next i

		EndIf

	EndIf

	_HMG_PRINTER_ENDDOC ( _HMG_SYSDATA [ 372 ] )

	EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWPREVIEW" ) )
	EnableWindow ( GetformHandle ( "_HMG_PRINTER_SHOWTHUMBNAILS" ) ) 
	EnableWindow ( GetformHandle ( "_HMG_PRINTER_PPNAV" ) ) 

	HideWindow ( GetFormHandle ( "_HMG_PRINTER_PRINTPAGES" ) ) 

	_HMG_PRINTER_SHOWPREVIEW.setfocus 

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollLeft
*------------------------------------------------------------------------------*
	_HMG_SYSDATA [ 363 ] := _HMG_SYSDATA [ 363 ] + _HMG_SYSDATA [ 366 ]
	if _HMG_SYSDATA [ 363 ] >= 500
		_HMG_SYSDATA [ 363 ] := 500
		PlayBeep()
	EndIf
	_HMG_PRINTER_PREVIEWRefresh()
Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollRight
*------------------------------------------------------------------------------*
	_HMG_SYSDATA [ 363 ] := _HMG_SYSDATA [ 363 ] - _HMG_SYSDATA [ 366 ]
	if _HMG_SYSDATA [ 363 ] <= -500
		_HMG_SYSDATA [ 363 ] := -500
		PlayBeep()
	EndIf
	_HMG_PRINTER_PREVIEWRefresh()
Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollUp
*------------------------------------------------------------------------------*
	_HMG_SYSDATA [ 364 ] := _HMG_SYSDATA [ 364 ] + _HMG_SYSDATA [ 366 ]
	if _HMG_SYSDATA [ 364 ] >= 500
		_HMG_SYSDATA [ 364 ] := 500
		PlayBeep()
	EndIf

	_HMG_PRINTER_PREVIEWRefresh()

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_ScrollDown
*------------------------------------------------------------------------------*

	_HMG_SYSDATA [ 364 ] := _HMG_SYSDATA [ 364 ] - _HMG_SYSDATA [ 366 ]
	if _HMG_SYSDATA [ 364 ] <= -500
		_HMG_SYSDATA [ 364 ] := -500
		PlayBeep()
	EndIf

	_HMG_PRINTER_PREVIEWRefresh()

Return
*------------------------------------------------------------------------------*
Function GetPrinter()
*------------------------------------------------------------------------------*
Local RetVal		:= ''
Local Printers		:= asort (aPrinters())
Local cDefaultPrinter	:= GetDefaultPrinter()
Local i
Local nInitPosition	:= 0

	For i := 1 to Len ( Printers )

		If Printers [i] == cDefaultPrinter
			nInitPosition := i
			Exit
		Endif

	Next i

	DEFINE WINDOW _HMG_PRINTER_GETPRINTER	;
		AT 0,0			; 
		WIDTH 345		;
		HEIGHT GetTitleHeight() + 100 ;
		TITLE _HMG_SYSDATA [ 371 ] [13] ;
		MODAL			;
		NOSIZE

		@ 15,10 COMBOBOX Combo_1 ITEMS Printers VALUE nInitPosition WIDTH 320

		@ 53 , 65  BUTTON Ok CAPTION _HMG_SYSDATA [ 371 ] [11] ACTION ( RetVal := Printers [ GetProperty ( '_HMG_PRINTER_GETPRINTER','Combo_1','Value') ] , DoMethod('_HMG_PRINTER_GETPRINTER','Release' ) )

		@ 53 , 175 BUTTON Cancel CAPTION _HMG_SYSDATA [ 371 ] [12] ACTION ( RetVal := '' ,DoMethod('_HMG_PRINTER_GETPRINTER','Release' ) )

	END WINDOW

	CENTER WINDOW _HMG_PRINTER_GETPRINTER

	ACTIVATE WINDOW _HMG_PRINTER_GETPRINTER

Return (RetVal)

#define TA_CENTER	6
#define TA_LEFT		0
#define TA_RIGHT	2

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_PRINT ( nHdc , nRow , nCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize , cAlign )
*------------------------------------------------------------------------------*
Local lAlignChanged := .F.

	if ValType (cText) == "N"
		cText := AllTrim(Str(cText))
	Elseif ValType (cText) == "D"
		cText := dtoc (cText)
	Elseif ValType (cText) == "L"
		cText := if ( cText == .T. , _HMG_SYSDATA [ 371 ] [24] , _HMG_SYSDATA [ 371 ] [25] )
	Elseif ValType (cText) == "A"
		Return
	Elseif ValType (cText) == "B"
		Return
	Elseif ValType (cText) == "O"
		Return
	Elseif ValType (cText) == "U"
		Return
	EndIf

	nRow := Int ( nRow * 10000 / 254 )
	nCol := Int ( nCol * 10000 / 254 )

	if valtype ( cAlign ) = 'C'
		if upper ( cAlign ) = 'CENTER'
			SetTextAlign ( nHdc , TA_CENTER )
			lAlignChanged := .T.
		elseif upper ( cAlign ) = 'RIGHT'
			SetTextAlign ( nHdc , TA_RIGHT )
			lAlignChanged := .T.
		endif			
	endif

	_HMG_PRINTER_C_PRINT ( nHdc , nRow , nCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize )

	if lAlignChanged
		SetTextAlign ( nHdc , TA_LEFT )
	endif

Return

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_MULTILINE_PRINT ( nHdc , nRow , nCol , nToRow , nToCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize , cAlign )
*------------------------------------------------------------------------------*
Local nAlign := TA_LEFT

//	cText := hb_oemtoansi(cText)

	if ValType (cText) == "N"
		cText := AllTrim(Str(cText))
	Elseif ValType (cText) == "D"
		cText := dtoc (cText)
	Elseif ValType (cText) == "L"
		cText := if ( cText == .T. , _HMG_SYSDATA [ 371 ] [24] , _HMG_SYSDATA [ 371 ] [25] )
	Elseif ValType (cText) == "A"
		Return
	Elseif ValType (cText) == "B"
		Return
	Elseif ValType (cText) == "O"
		Return
	Elseif ValType (cText) == "U"
		Return
	EndIf

	nRow := Int ( nRow * 10000 / 254 )
	nCol := Int ( nCol * 10000 / 254 )
	nToRow := Int ( nToRow * 10000 / 254 )
	nToCol := Int ( nToCol * 10000 / 254 )

	if valtype ( cAlign ) = 'C'
		if upper ( cAlign ) = 'CENTER'
			nAlign := TA_CENTER
		elseif upper ( cAlign ) = 'RIGHT'
			nAlign := TA_RIGHT
		endif			
	endif

	_HMG_PRINTER_C_MULTILINE_PRINT ( nHdc , nRow , nCol , cFontName , nFontSize , nColor1 , nColor2 , nColor3 , cText , lbold , litalic , lunderline , lstrikeout , lcolor , lfont , lsize , nToRow , nToCol , nAlign )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_IMAGE ( nHdc , cImage , nRow , nCol , nHeight , nWidth , lStretch )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nWidth	:= Int ( nWidth * 10000 / 254 )
	nHeight	:= Int ( nHeight * 10000 / 254 )

	_HMG_PRINTER_C_IMAGE ( nHdc , cImage , nRow , nCol , nHeight , nWidth , lStretch )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_LINE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nToRow	:= Int ( nToRow * 10000 / 254 )
	nToCol	:= Int ( nToCol * 10000 / 254 )

	If ValType ( nWidth ) != 'U'
		nWidth	:= Int ( nWidth * 10000 / 254 )
	EndIf

	_HMG_PRINTER_C_LINE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_RECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol ,nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor, lfilled )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nToRow	:= Int ( nToRow * 10000 / 254 )
	nToCol	:= Int ( nToCol * 10000 / 254 )

	If ValType ( nWidth ) != 'U'
		nWidth	:= Int ( nWidth * 10000 / 254 )
	EndIf

	_HMG_PRINTER_C_RECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor, lfilled )

Return
*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_H_ROUNDRECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol ,nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor, lfilled )
*------------------------------------------------------------------------------*

	nRow	:= Int ( nRow * 10000 / 254 )
	nCol	:= Int ( nCol * 10000 / 254 )
	nToRow	:= Int ( nToRow * 10000 / 254 )
	nToCol	:= Int ( nToCol * 10000 / 254 )

	If ValType ( nWidth ) != 'U'
		nWidth	:= Int ( nWidth * 10000 / 254 )
	EndIf

	_HMG_PRINTER_C_ROUNDRECTANGLE ( nHdc , nRow , nCol , nToRow , nToCol , nWidth , nColor1 , nColor2 , nColor3 , lwidth , lcolor, lfilled )

Return
*------------------------------------------------------------------------------*
Procedure _hmg_printer_InitUserMessages
*------------------------------------------------------------------------------*
Local	cLang	:= ""   

	cLang := Set ( _SET_LANGUAGE )

	// LANGUAGES NOT SUPPORTED BY hb_langSelect() FUNCTION.

	IF _HMG_SYSDATA [ 211 ] == 'FI'		// FINNISH
		cLang := 'FI'		
	ELSEIF _HMG_SYSDATA [ 211 ] == 'NL'	// DUTCH
		cLang := 'NL'		
	ENDIF

	do case

        case cLang == "TRWIN" .OR. cLang == "TR"

    /////////////////////////////////////////////////////////////
    // TRKE
    ////////////////////////////////////////////////////////////
    
        _HMG_SYSDATA [ 371 ] [01] := 'Sayfa'
        _HMG_SYSDATA [ 371 ] [02] := 'Print n-izleme'
        _HMG_SYSDATA [ 371 ] [03] := 'lk Sayfa [HOME]'
        _HMG_SYSDATA [ 371 ] [04] := 'nceki Sayfa [PGUP]'
        _HMG_SYSDATA [ 371 ] [05] := 'Sonraki Sayfa [PGDN]'
        _HMG_SYSDATA [ 371 ] [06] := 'Son sayfa [END]'
        _HMG_SYSDATA [ 371 ] [07] := 'Sayfa no'
        _HMG_SYSDATA [ 371 ] [08] := 'Byt/Klt'
        _HMG_SYSDATA [ 371 ] [09] := 'Yazdr'
        _HMG_SYSDATA [ 371 ] [10] := 'Sayfa No'
        _HMG_SYSDATA [ 371 ] [11] := 'Tamam'
        _HMG_SYSDATA [ 371 ] [12] := 'ptal'
        _HMG_SYSDATA [ 371 ] [13] := 'Printer Se'
        _HMG_SYSDATA [ 371 ] [14] := 'Kopyalar birletir'
        _HMG_SYSDATA [ 371 ] [15] := 'Snrl Print'
        _HMG_SYSDATA [ 371 ] [16] := 'Hepsi'
        _HMG_SYSDATA [ 371 ] [17] := 'Sayfalar'
        _HMG_SYSDATA [ 371 ] [18] := 'lk'
        _HMG_SYSDATA [ 371 ] [19] := 'Son'
        _HMG_SYSDATA [ 371 ] [20] := 'Kopya says'
        _HMG_SYSDATA [ 371 ] [21] := 'Btn snrlar'
        _HMG_SYSDATA [ 371 ] [22] := 'Yalnz tek sayfalar'
        _HMG_SYSDATA [ 371 ] [23] := 'Yalnz ift sayfalar'
        _HMG_SYSDATA [ 371 ] [24] := 'Evet'
        _HMG_SYSDATA [ 371 ] [25] := 'Hayr'
        _HMG_SYSDATA [ 371 ] [26] := 'Kapat'
        _HMG_SYSDATA [ 371 ] [27] := 'Kaydet'
        _HMG_SYSDATA [ 371 ] [28] := 'Sayfa ikonlar'
        _HMG_SYSDATA [ 371 ] [29] := 'Sayfa ikonlar oluturuluyor... Ltfen bekleyin...'
    

        case cLang ==  "CS" .OR. cLang == "CSWIN"
	/////////////////////////////////////////////////////////////
	// CZECH
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Strana'
		_HMG_SYSDATA [ 371 ] [02] := 'Nhled'
		_HMG_SYSDATA [ 371 ] [03] := 'Prvn strana [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Pedchoz strana [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Dal strana [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Posledn strana [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Jdi na stranu'
		_HMG_SYSDATA [ 371 ] [08] := 'Lupa'
		_HMG_SYSDATA [ 371 ] [09] := 'Tisk'
		_HMG_SYSDATA [ 371 ] [10] := 'slo strany'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Storno'
		_HMG_SYSDATA [ 371 ] [13] := 'Vyber tiskrnu'
		_HMG_SYSDATA [ 371 ] [14] := 'Tdn'
		_HMG_SYSDATA [ 371 ] [15] := 'Rozsah tisku'
		_HMG_SYSDATA [ 371 ] [16] := 've'
		_HMG_SYSDATA [ 371 ] [17] := 'strany'
		_HMG_SYSDATA [ 371 ] [18] := 'od'
		_HMG_SYSDATA [ 371 ] [19] := 'do'
		_HMG_SYSDATA [ 371 ] [20] := 'kopi'
		_HMG_SYSDATA [ 371 ] [21] := 'vechny strany'
		_HMG_SYSDATA [ 371 ] [22] := 'lich strany'
		_HMG_SYSDATA [ 371 ] [23] := 'sud strany'
		_HMG_SYSDATA [ 371 ] [24] := 'Ano'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Zavi'
		_HMG_SYSDATA [ 371 ] [27] := 'Ulo'
		_HMG_SYSDATA [ 371 ] [28] := 'Miniatury'
		_HMG_SYSDATA [ 371 ] [29] := 'Generuji miniatury... ekejte, prosm...'

	/////////////////////////////////////////////////////////////
	// CROATIAN
	////////////////////////////////////////////////////////////
        case cLang == "HR852" // Croatian

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'

        case cLang == "EU"        // Basque.
	/////////////////////////////////////////////////////////////
	// BASQUE
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'

        case cLang == "EN"        // English
	/////////////////////////////////////////////////////////////
	// ENGLISH
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'

        case cLang == "FR"        // French
	/////////////////////////////////////////////////////////////
	// FRENCH
	////////////////////////////////////////////////////////////

	_HMG_SYSDATA [ 371 ] [01] := 'Page'
	_HMG_SYSDATA [ 371 ] [02] := "Aperu avant impression"
	_HMG_SYSDATA [ 371 ] [03] := 'Premire page [HOME]'
	_HMG_SYSDATA [ 371 ] [04] := 'Page prcdente [PGUP]'
	_HMG_SYSDATA [ 371 ] [05] := 'Page suivante [PGDN]'
	_HMG_SYSDATA [ 371 ] [06] := 'Dernire page [END]'
	_HMG_SYSDATA [ 371 ] [07] := 'Allez page'
	_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
	_HMG_SYSDATA [ 371 ] [09] := 'Imprimer'
	_HMG_SYSDATA [ 371 ] [10] := 'Page'
	_HMG_SYSDATA [ 371 ] [11] := 'Ok'
	_HMG_SYSDATA [ 371 ] [12] := 'Annulation'
	_HMG_SYSDATA [ 371 ] [13] := "Slection de l'imprimante"
	_HMG_SYSDATA [ 371 ] [14] := "Assemblez"
	_HMG_SYSDATA [ 371 ] [15] := "Paramtres d'impression"
	_HMG_SYSDATA [ 371 ] [16] := 'Tous'
	_HMG_SYSDATA [ 371 ] [17] := 'Pages'
	_HMG_SYSDATA [ 371 ] [18] := 'De'
	_HMG_SYSDATA [ 371 ] [19] := ''
	_HMG_SYSDATA [ 371 ] [20] := 'Copies'
	_HMG_SYSDATA [ 371 ] [21] := 'Toutes les pages'
	_HMG_SYSDATA [ 371 ] [22] := 'Pages Impaires'
	_HMG_SYSDATA [ 371 ] [23] := 'Pages Paires'
	_HMG_SYSDATA [ 371 ] [24] := 'Oui'
	_HMG_SYSDATA [ 371 ] [25] := 'Non'
	_HMG_SYSDATA [ 371 ] [26] := 'Fermer'
	_HMG_SYSDATA [ 371 ] [27] := 'Sauver'
	_HMG_SYSDATA [ 371 ] [28] := 'Affichettes'
	_HMG_SYSDATA [ 371 ] [29] := "Cration des affichettes... Merci d'attendre..."

        case cLang == "DEWIN" .OR. cLang == "DE"       // German
	/////////////////////////////////////////////////////////////
	// GERMAN
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Seite'
		_HMG_SYSDATA [ 371 ] [02] := 'DruckcVorbetrachtung'
		_HMG_SYSDATA [ 371 ] [03] := 'Erste Seite [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Vorige Seite [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Folgende Seite [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Letzte Seite [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Gehen Sie Zu paginieren'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Druck'
		_HMG_SYSDATA [ 371 ] [10] := 'Seitenzahl'
		_HMG_SYSDATA [ 371 ] [11] := 'O.K.'
		_HMG_SYSDATA [ 371 ] [12] := 'Lschen'
		_HMG_SYSDATA [ 371 ] [13] := 'Whlen Sie Drucker Vor'
		_HMG_SYSDATA [ 371 ] [14] := 'Sortieren'
		_HMG_SYSDATA [ 371 ] [15] := 'DruckcStrecke'
		_HMG_SYSDATA [ 371 ] [16] := 'Alle'
		_HMG_SYSDATA [ 371 ] [17] := 'Seiten'
		_HMG_SYSDATA [ 371 ] [18] := 'Von'
		_HMG_SYSDATA [ 371 ] [19] := 'Zu'
		_HMG_SYSDATA [ 371 ] [20] := 'Kopien'
		_HMG_SYSDATA [ 371 ] [21] := 'Alle Strecke'
		_HMG_SYSDATA [ 371 ] [22] := 'Nur Ungerade Seiten'
		_HMG_SYSDATA [ 371 ] [23] := 'Nur Gleichmige Seiten'
		_HMG_SYSDATA [ 371 ] [24] := 'Ja'
		_HMG_SYSDATA [ 371 ] [25] := 'Nein'
		_HMG_SYSDATA [ 371 ] [26] := 'Fenster'
		_HMG_SYSDATA [ 371 ] [27] := 'Speichern'
		_HMG_SYSDATA [ 371 ] [28] := 'berblick'
		_HMG_SYSDATA [ 371 ] [29] := 'berblick Erzeugen...  Bitte Wartezeit...'

	case cLang == "IT"        // Italian
	/////////////////////////////////////////////////////////////
	// ITALIAN
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Pagina'
		_HMG_SYSDATA [ 371 ] [02] := 'Anteprima di stampa'
		_HMG_SYSDATA [ 371 ] [03] := 'Prima Pagina [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Pagina Precedente [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Pagina Seguente [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Ultima Pagina [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Vai Alla Pagina'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Stampa'
		_HMG_SYSDATA [ 371 ] [10] := 'Pagina'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Annulla'
		_HMG_SYSDATA [ 371 ] [13] := 'Selezioni Lo Stampatore'
		_HMG_SYSDATA [ 371 ] [14] := 'Fascicoli'
		_HMG_SYSDATA [ 371 ] [15] := 'Intervallo di stampa'
		_HMG_SYSDATA [ 371 ] [16] := 'Tutti'
		_HMG_SYSDATA [ 371 ] [17] := 'Pagine'
		_HMG_SYSDATA [ 371 ] [18] := 'Da'
		_HMG_SYSDATA [ 371 ] [19] := 'A'
		_HMG_SYSDATA [ 371 ] [20] := 'Copie'
		_HMG_SYSDATA [ 371 ] [21] := 'Tutte le pagine'
		_HMG_SYSDATA [ 371 ] [22] := 'Le Pagine Pari'
		_HMG_SYSDATA [ 371 ] [23] := 'Le Pagine Dispari'
		_HMG_SYSDATA [ 371 ] [24] := 'Si'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Chiudi'
		_HMG_SYSDATA [ 371 ] [27] := 'Salva'
		_HMG_SYSDATA [ 371 ] [28] := 'Miniatura'
		_HMG_SYSDATA [ 371 ] [29] := 'Generando Miniatura...  Prego Attesa...'

        case cLang == "PLWIN"  .OR. cLang == "PL852"  .OR. cLang == "PLISO"  .OR. cLang == ""  .OR. cLang == "PLMAZ"   // Polish 

	/////////////////////////////////////////////////////////////
	// POLISH
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Strona'
		_HMG_SYSDATA [ 371 ] [02] := 'Podgld wydruku'
		_HMG_SYSDATA [ 371 ] [03] := 'Pierwsza strona [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Poprzednia strona [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Nastpna strona [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Ostatnia strona [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Skocz do strony'
		_HMG_SYSDATA [ 371 ] [08] := 'Powiksz'
		_HMG_SYSDATA [ 371 ] [09] := 'Drukuj'
		_HMG_SYSDATA [ 371 ] [10] := 'Numer strony'
		_HMG_SYSDATA [ 371 ] [11] := 'Tak'
		_HMG_SYSDATA [ 371 ] [12] := 'Przerwij'
		_HMG_SYSDATA [ 371 ] [13] := 'Wybierz drukark'
		_HMG_SYSDATA [ 371 ] [14] := 'Sortuj kopie'
		_HMG_SYSDATA [ 371 ] [15] := 'Zakres wydruku'
		_HMG_SYSDATA [ 371 ] [16] := 'Wszystkie'
		_HMG_SYSDATA [ 371 ] [17] := 'Strony'
		_HMG_SYSDATA [ 371 ] [18] := 'Od'
		_HMG_SYSDATA [ 371 ] [19] := 'Do'
		_HMG_SYSDATA [ 371 ] [20] := 'Kopie'
		_HMG_SYSDATA [ 371 ] [21] := 'Wszystkie'
		_HMG_SYSDATA [ 371 ] [22] := 'Nieparzyste'
		_HMG_SYSDATA [ 371 ] [23] := 'Parzyste'
		_HMG_SYSDATA [ 371 ] [24] := 'Tak'
		_HMG_SYSDATA [ 371 ] [25] := 'Nie'
		_HMG_SYSDATA [ 371 ] [26] := 'Zamknij'
		_HMG_SYSDATA [ 371 ] [27] := 'Zapisz'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generuj Thumbnails... Prosz czeka...'

        case cLang == "PT"        // Portuguese

/////////////////////////////////////////////////////////////
// PORTUGUESE
////////////////////////////////////////////////////////////

_HMG_SYSDATA [ 371 ] [01] := 'Pgina'
_HMG_SYSDATA [ 371 ] [02] := 'Visualizao prvia da Impresso'
_HMG_SYSDATA [ 371 ] [03] := 'Primeira Pgina [HOME]'
_HMG_SYSDATA [ 371 ] [04] := 'Pgina Anterior [PGUP]'
_HMG_SYSDATA [ 371 ] [05] := 'Prxima Pgina [PGDN]'
_HMG_SYSDATA [ 371 ] [06] := 'ltima Pgina [END]'
_HMG_SYSDATA [ 371 ] [07] := 'Ir para Pgina N...'
_HMG_SYSDATA [ 371 ] [08] := 'Ampliar'
_HMG_SYSDATA [ 371 ] [09] := 'Imprimir'
_HMG_SYSDATA [ 371 ] [10] := 'Pgina'
_HMG_SYSDATA [ 371 ] [11] := 'Ok'
_HMG_SYSDATA [ 371 ] [12] := 'Cancelar'
_HMG_SYSDATA [ 371 ] [13] := 'Selecionar Impressora'
_HMG_SYSDATA [ 371 ] [14] := 'Ordenar Cpias'
_HMG_SYSDATA [ 371 ] [15] := 'Faixa De Impresso'
_HMG_SYSDATA [ 371 ] [16] := 'Tudo'
_HMG_SYSDATA [ 371 ] [17] := 'Pginas'
_HMG_SYSDATA [ 371 ] [18] := 'De'
_HMG_SYSDATA [ 371 ] [19] := 'At'
_HMG_SYSDATA [ 371 ] [20] := 'Cpias'
_HMG_SYSDATA [ 371 ] [21] := 'Todas as Pginas'
_HMG_SYSDATA [ 371 ] [22] := 'S Pginas mpares'
_HMG_SYSDATA [ 371 ] [23] := 'S Pginas Pares'
_HMG_SYSDATA [ 371 ] [24] := 'Sim'
_HMG_SYSDATA [ 371 ] [25] := 'No'
_HMG_SYSDATA [ 371 ] [26] := 'Fechar e Sair'
_HMG_SYSDATA [ 371 ] [27] := 'Salvar em Arquivo'
_HMG_SYSDATA [ 371 ] [28] := 'Gerar Miniaturas'
_HMG_SYSDATA [ 371 ] [29] := 'Aguarde por favor, gerando Miniaturas...'

        case cLang == "RUWIN"  .OR. cLang == "RU866" .OR. cLang == "RUKOI8" // Russian 
	/////////////////////////////////////////////////////////////
	// RUSSIAN
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'

        case cLang == "ES"  .OR. cLang == "ESWIN"       // Spanish
	/////////////////////////////////////////////////////////////
	// SPANISH
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Pgina'
		_HMG_SYSDATA [ 371 ] [02] := 'Vista Previa'
		_HMG_SYSDATA [ 371 ] [03] := 'Inicio [INICIO]'
		_HMG_SYSDATA [ 371 ] [04] := 'Anterior [REPAG]'
		_HMG_SYSDATA [ 371 ] [05] := 'Siguiente [AVPAG]'
		_HMG_SYSDATA [ 371 ] [06] := 'Fin [FIN]'
		_HMG_SYSDATA [ 371 ] [07] := 'Ir a'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Imprimir'
		_HMG_SYSDATA [ 371 ] [10] := 'Pgina Nro.'
		_HMG_SYSDATA [ 371 ] [11] := 'Aceptar'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancelar'
		_HMG_SYSDATA [ 371 ] [13] := 'Seleccionar Impresora'
		_HMG_SYSDATA [ 371 ] [14] := 'Ordenar Copias'
		_HMG_SYSDATA [ 371 ] [15] := 'Rango de Impresin'
		_HMG_SYSDATA [ 371 ] [16] := 'Todo'
		_HMG_SYSDATA [ 371 ] [17] := 'Pginas'
		_HMG_SYSDATA [ 371 ] [18] := 'Desde'
		_HMG_SYSDATA [ 371 ] [19] := 'Hasta'
		_HMG_SYSDATA [ 371 ] [20] := 'Copias'
		_HMG_SYSDATA [ 371 ] [21] := 'Todo El Rango'
		_HMG_SYSDATA [ 371 ] [22] := 'Solo Pginas Impares'
		_HMG_SYSDATA [ 371 ] [23] := 'Solo Pginas Pares'
		_HMG_SYSDATA [ 371 ] [24] := 'Si'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Cerrar'
		_HMG_SYSDATA [ 371 ] [27] := 'Guardar'
		_HMG_SYSDATA [ 371 ] [28] := 'Miniaturas'
		_HMG_SYSDATA [ 371 ] [29] := 'Generando Miniaturas... Espere Por Favor...'

        case cLang == "FI"        // Finnish
	///////////////////////////////////////////////////////////////////////
	// FINNISH
	///////////////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'
	
        case cLang == "NL"        // Dutch
	/////////////////////////////////////////////////////////////
	// DUTCH
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'

        case cLang == "SLWIN" .OR. cLang == "SLISO" .OR. cLang == "SL852" .OR. cLang == "" .OR. cLang == "SL437" // Slovenian
  	/////////////////////////////////////////////////////////////
	// SLOVENIAN
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'

	OtherWise
	/////////////////////////////////////////////////////////////
	// DEFAULT ENGLISH
	////////////////////////////////////////////////////////////

		_HMG_SYSDATA [ 371 ] [01] := 'Page'
		_HMG_SYSDATA [ 371 ] [02] := 'Print Preview'
		_HMG_SYSDATA [ 371 ] [03] := 'First Page [HOME]'
		_HMG_SYSDATA [ 371 ] [04] := 'Previous Page [PGUP]'
		_HMG_SYSDATA [ 371 ] [05] := 'Next Page [PGDN]'
		_HMG_SYSDATA [ 371 ] [06] := 'Last Page [END]'
		_HMG_SYSDATA [ 371 ] [07] := 'Go To Page'
		_HMG_SYSDATA [ 371 ] [08] := 'Zoom'
		_HMG_SYSDATA [ 371 ] [09] := 'Print'
		_HMG_SYSDATA [ 371 ] [10] := 'Page Number'
		_HMG_SYSDATA [ 371 ] [11] := 'Ok'
		_HMG_SYSDATA [ 371 ] [12] := 'Cancel'
		_HMG_SYSDATA [ 371 ] [13] := 'Select Printer'
		_HMG_SYSDATA [ 371 ] [14] := 'Collate Copies'
		_HMG_SYSDATA [ 371 ] [15] := 'Print Range'
		_HMG_SYSDATA [ 371 ] [16] := 'All'
		_HMG_SYSDATA [ 371 ] [17] := 'Pages'
		_HMG_SYSDATA [ 371 ] [18] := 'From'
		_HMG_SYSDATA [ 371 ] [19] := 'To'
		_HMG_SYSDATA [ 371 ] [20] := 'Copies'
		_HMG_SYSDATA [ 371 ] [21] := 'All Range'
		_HMG_SYSDATA [ 371 ] [22] := 'Odd Pages Only'
		_HMG_SYSDATA [ 371 ] [23] := 'Even Pages Only'
		_HMG_SYSDATA [ 371 ] [24] := 'Yes'
		_HMG_SYSDATA [ 371 ] [25] := 'No'
		_HMG_SYSDATA [ 371 ] [26] := 'Close'
		_HMG_SYSDATA [ 371 ] [27] := 'Save'
		_HMG_SYSDATA [ 371 ] [28] := 'Thumbnails'
		_HMG_SYSDATA [ 371 ] [29] := 'Generating Thumbnails... Please Wait...'

	endcase

Return

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAWIDTH()
*------------------------------------------------------------------------------*

RETURN _HMG_PRINTER_GETPRINTERWIDTH ( _HMG_SYSDATA [ 374 ] )

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAHEIGHT()
*------------------------------------------------------------------------------*

RETURN _HMG_PRINTER_GETPRINTERHEIGHT ( _HMG_SYSDATA [ 374 ] )

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAHORIZONTALOFFSET()
*------------------------------------------------------------------------------*

	IF ! __MVEXIST ( '_HMG_SYSDATA [ 374 ]' )
		RETURN 0
	ENDIF

RETURN ( _HMG_PRINTER_GETPRINTABLEAREAPHYSICALOFFSETX ( _HMG_SYSDATA [ 374 ] ) / _HMG_PRINTER_GETPRINTABLEAREALOGPIXELSX ( _HMG_SYSDATA [ 374 ] ) * 25.4 )

*------------------------------------------------------------------------------*
FUNCTION GETPRINTABLEAREAVERTICALOFFSET()
*------------------------------------------------------------------------------*

	IF ! __MVEXIST ( '_HMG_SYSDATA [ 374 ]' )
		RETURN 0
	ENDIF

RETURN ( _HMG_PRINTER_GETPRINTABLEAREAPHYSICALOFFSETY ( _HMG_SYSDATA [ 374 ] ) / _HMG_PRINTER_GETPRINTABLEAREALOGPIXELSY ( _HMG_SYSDATA [ 374 ] ) * 25.4 )


*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_MouseZoom
*------------------------------------------------------------------------------*
Local Width := GetDesktopWidth()
Local Height := GetDesktopHeight()
Local Q := 0
Local DeltaHeight := 35 + GetTitleHeight() + GetBorderHeight() + 10

	If _HMG_SYSDATA [ 365 ] == 1000 + _HMG_SYSDATA [ 359 ]

		_HMG_SYSDATA [ 365 ] := 0
		_HMG_SYSDATA [ 363 ] := 0
		_HMG_SYSDATA [ 364 ] := 0

		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 50 , .T. )
		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 50 , .T. )

		_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	Else

		* Calculate Quadrant

		if	_HMG_SYSDATA [ 192 ] <= ( Width / 2 ) - _HMG_SYSDATA [ 367 ] ;
			.And. ;
			_HMG_SYSDATA [ 191 ] <= ( Height / 2 )	- DeltaHeight
		
			Q := 1

		Elseif	_HMG_SYSDATA [ 192 ] > ( Width / 2 ) - _HMG_SYSDATA [ 367 ] ;
			.And. ;
			_HMG_SYSDATA [ 191 ] <= ( Height / 2 )	- DeltaHeight
	
			Q := 2

		Elseif	_HMG_SYSDATA [ 192 ] <= ( Width / 2 ) - _HMG_SYSDATA [ 367 ] ;
			.And. ;
			_HMG_SYSDATA [ 191 ] > ( Height / 2 ) - DeltaHeight		
	
			Q := 3

		Elseif	_HMG_SYSDATA [ 192 ] > ( Width / 2 ) - _HMG_SYSDATA [ 367 ] ;
			.And. ;
			_HMG_SYSDATA [ 191 ] > ( Height / 2 ) - DeltaHeight		
	
			Q := 4

		EndIf

		if	_HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) ;
			> ;
			_HMG_PRINTER_GETPAGEWIDTH(_HMG_SYSDATA [ 372 ]) 

			* Portrait

			If Q == 1 
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := 100
				_HMG_SYSDATA [ 364 ] := 400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 10 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 40 , .T. )
			ElseIf Q == 2
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := -100
				_HMG_SYSDATA [ 364 ] := 400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 10 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 60 , .T. )
			ElseIf Q == 3
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := 100
				_HMG_SYSDATA [ 364 ] := -400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 90 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 40 , .T. )
			ElseIf Q == 4
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := -100
				_HMG_SYSDATA [ 364 ] := -400
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 90 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 60 , .T. )
			EndIf				

		Else

			* Landscape

			If Q == 1 
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := 500
				_HMG_SYSDATA [ 364 ] := 300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 20 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 1 , .T. )
			ElseIf Q == 2
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := -500
				_HMG_SYSDATA [ 364 ] := 300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 20 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 99 , .T. )
			ElseIf Q == 3
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := 500
				_HMG_SYSDATA [ 364 ] := -300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 80 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 1 , .T. )
			ElseIf Q == 4
				_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
				_HMG_SYSDATA [ 363 ] := -500
				_HMG_SYSDATA [ 364 ] := -300
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 80 , .T. )
				SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 99 , .T. )
			EndIf				

		EndIf

		_HMG_PRINTER_PREVIEW_ENABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	EndIf

	_HMG_PRINTER_PREVIEWRefresh()

Return

*------------------------------------------------------------------------------*
Procedure _HMG_PRINTER_Zoom
*------------------------------------------------------------------------------*

	If _HMG_SYSDATA [ 365 ] == 1000 + _HMG_SYSDATA [ 359 ]

		_HMG_SYSDATA [ 365 ] := 0
		_HMG_SYSDATA [ 363 ] := 0
		_HMG_SYSDATA [ 364 ] := 0

		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 50 , .T. )
		SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 50 , .T. )

		_HMG_PRINTER_PREVIEW_DISABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	Else

		if	_HMG_PRINTER_GETPAGEHEIGHT(_HMG_SYSDATA [ 372 ]) ;
			> ;
			_HMG_PRINTER_GETPAGEWIDTH(_HMG_SYSDATA [ 372 ]) 

			_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
			_HMG_SYSDATA [ 363 ] := 100
			_HMG_SYSDATA [ 364 ] := 400
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 10 , .T. )
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 40 , .T. )

		Else

			_HMG_SYSDATA [ 365 ] := 1000 + _HMG_SYSDATA [ 359 ]
			_HMG_SYSDATA [ 363 ] := 500
			_HMG_SYSDATA [ 364 ] := 300
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_VERT , 20 , .T. )
			SetScrollPos ( GetFormHandle('_HMG_PRINTER_SHOWPREVIEW') , SB_HORZ , 1 , .T. )

		EndIf

		_HMG_PRINTER_PREVIEW_ENABLESCROLLBARS (GetFormHandle('_HMG_PRINTER_SHOWPREVIEW'))

	EndIf

	_HMG_PRINTER_PREVIEWRefresh()

Return

procedure _hmg_printer_setjobname( cName )

	if valtype ( cName ) = 'U'
		_HMG_SYSDATA [358] := 'HMG Print System'
	else
		_HMG_SYSDATA [358] := cName
	endif

return
*------------------------------------------------------------------------------*
PROCEDURE COMPRESSFILES ( cFileName , aDir , bBlock , lOvr )
*------------------------------------------------------------------------------*
* Based on HBMZIP Harbour contribution library samples.
LOCAL hZip , i , cPassword

	if valtype (lOvr) == 'L'
		if lOvr == .t.
			if file (cFileName)
				delete file (cFileName)
			endif
		endif
	endif

	hZip := HB_ZIPOPEN( cFileName )
	IF ! EMPTY( hZip )
		FOR i := 1 To Len (aDir)
			if valtype (bBlock) == 'B'
				Eval ( bBlock , aDir [i] , i )     
			endif
			HB_ZipStoreFile( hZip, aDir [ i ], aDir [ i ] , cPassword )
		NEXT
	ENDIF

	HB_ZIPCLOSE( hZip )

RETURN

*------------------------------------------------------------------------------*
PROCEDURE UNCOMPRESSFILES ( cFileName , bBlock )
*------------------------------------------------------------------------------*
* Based on HBMZIP Harbour contribution library samples.
Local i := 0 , hUnzip , nErr, cFile, dDate, cTime, nSize, nCompSize , f

	hUnzip := HB_UNZIPOPEN( cFileName )

	nErr := HB_UNZIPFILEFIRST( hUnzip )

	DO WHILE nErr == 0

		HB_UnzipFileInfo( hUnzip, @cFile, @dDate, @cTime,,,, @nSize, @nCompSize )

		i++
		if valtype (bBlock) = 'B'
			Eval ( bBlock , cFile , i )     
		endif

		HB_UnzipExtractCurrentFile( hUnzip, NIL, NIL )

		nErr := HB_UNZIPFILENEXT( hUnzip )

	ENDDO

	HB_UNZIPCLOSE( hUnzip )

RETURN

*-----------------------------------------------------------------------------*
Function _GetControlObject (ControlName,ParentForm)
*-----------------------------------------------------------------------------*
Local mVar , i

	mVar := '_' + ParentForm + '_' + ControlName
	i := &mVar
	if i == 0
		Return ''
	EndIf

Return (_HMG_SYSDATA [39] [ &mVar ] )

*-----------------------------------------------------------------------------*
Function _DefineActivex ( cControlName, cParentForm, nRow, nCol , nWidth , nHeight , cProgId )
*-----------------------------------------------------------------------------*
Local mVar , nControlHandle , k := 0 , nParentFormHandle , oOle
Local nAtlDllHandle , cParentTabName

	* If defined inside DEFINE WINDOW structure, determine cParentForm

	if _HMG_SYSDATA [ 264 ] = .T.
		cParentForm := _HMG_SYSDATA [ 223 ]
	endif

	* If defined inside a Tab structure, adjust position and determine
	* cParentForm

	if _HMG_SYSDATA [ 183 ] > 0
		nCol 		:= nCol + _HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]]
		nRow 		:= nRow + _HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]]
		cParentForm 	:= _HMG_SYSDATA [ 332 ] [_HMG_SYSDATA [ 183 ]]
		cParentTabName	:= _HMG_SYSDATA [ 225 ] 
	EndIf

	* Check for errors

	* Check Parent Window

	If .Not. _IsWindowDefined (cParentForm)
		MsgHMGError("Window: "+ cParentForm + " is not defined. Program terminated" )
	Endif

	* Check Control

	If _IsControlDefined (cControlName,cParentForm)
		MsgHMGError ("Control: " + cControlName + " Of " + cParentForm + " Already defined. Program Terminated" )
	Endif

	* Check cProgId

	If valType (cProgId) <> 'C'
		MsgHMGError ("Control: " + cControlName + " Of " + cParentForm + " PROGID Property Invalid Type. Program Terminated" )
	EndIf

	If Empty (cProgId)
		MsgHMGError ("Control: " + cControlName + " Of " + cParentForm + " PROGID Can't be empty. Program Terminated" )
	EndIf

	* Define public variable associated with control

	mVar := '_' + cParentForm + '_' + cControlName

	nParentFormHandle := GetFormHandle (cParentForm)

	* Init Activex

	aResult := InitActivex( nParentFormHandle , cProgId , nCol , nRow , nWidth , nHeight )

	nControlHandle		:= aResult [1]
	nInterfacePointer	:= aResult [2]
	nAtlDllHandle		:= aResult [3]

	If _HMG_SYSDATA [ 265 ] = .T.
		aAdd ( _HMG_SYSDATA [ 142 ] , nControlhandle )
	EndIf

	* Create OLE control

	oOle := ToleAuto():New( nInterfacePointer )

	k := _GetControlFree()

	Public &mVar. := k

	_HMG_SYSDATA [1] [k] := "ACTIVEX" 
	_HMG_SYSDATA [2] [k] := cControlName 
	_HMG_SYSDATA [3] [k] := nControlHandle 
	_HMG_SYSDATA [4] [k] := nParentFormHandle
	_HMG_SYSDATA [  5 ] [k] := 0 
	_HMG_SYSDATA [  6 ] [k] := "" 
	_HMG_SYSDATA [  7 ] [k] := {} 
	_HMG_SYSDATA [  8 ] [k] := Nil 
	_HMG_SYSDATA [  9 ] [k] := "" 
	_HMG_SYSDATA [ 10 ] [k] := Nil 
	_HMG_SYSDATA [ 11 ] [k] := Nil 
	_HMG_SYSDATA [ 12 ] [k] := "" 
	_HMG_SYSDATA [ 13 ] [k] := .F.
	_HMG_SYSDATA [ 14 ] [k] := Nil 
	_HMG_SYSDATA [ 15 ] [k] := Nil 
	_HMG_SYSDATA [ 16 ] [k] := "" 
	_HMG_SYSDATA [ 17 ] [k] := {} 
	_HMG_SYSDATA [ 18 ] [k] := nRow 
	_HMG_SYSDATA [ 19 ] [k] := nCol 
	_HMG_SYSDATA [ 20 ] [k] := nWidth 
	_HMG_SYSDATA [ 21 ] [k] := nHeight 
	_HMG_SYSDATA [ 22 ] [k] := 'T'
	_HMG_SYSDATA [ 23 ] [k] := iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 333 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 24 ] [k] := iif ( _HMG_SYSDATA [ 183 ] > 0 ,_HMG_SYSDATA [ 334 ] [_HMG_SYSDATA [ 183 ]] , -1 ) 
	_HMG_SYSDATA [ 25 ] [k] := "" 
	_HMG_SYSDATA [ 26 ] [k] := 0
	_HMG_SYSDATA [ 27 ] [k] := ""
	_HMG_SYSDATA [ 28 ] [k] := 0 
	_HMG_SYSDATA [ 29 ] [k] := {.f.,.f.,.f.,.f.} 
	_HMG_SYSDATA [ 30 ] [k] := ""  
	_HMG_SYSDATA [ 31 ] [k] := ""  
	_HMG_SYSDATA [ 32 ] [k] := 0  
	_HMG_SYSDATA [ 33 ] [k] := ""  
	_HMG_SYSDATA [ 34 ] [k] := .t. 
	_HMG_SYSDATA [ 35 ] [k] := nAtlDllHandle
	_HMG_SYSDATA [ 36 ] [k] := 0 
	_HMG_SYSDATA [ 37 ] [k] := 0 
	_HMG_SYSDATA [ 38 ] [k] := .T. 
	_HMG_SYSDATA [ 39 ] [k] := oOle
	_HMG_SYSDATA [ 40 ] [k] := { NIL , NIL , NIL , NIL , NIL , NIL , NIL , NIL }

Return oOle

*-----------------------------------------------------------------------------*
Function _HMG_SetHeaderImages ( cControlName, cParentForm , nColumn , cImage  )
*-----------------------------------------------------------------------------*
Local i , nControlHandle , nHeaderImageListHandle , aHeaderImages
Local cControlType
Local aHeadersJustify

	* Get Control Type 

	cControlType := GetControlType (cControlName,cParentForm)

	* Get Control Index 

	i := GetControlIndex ( cControlName, cParentForm )

	* Get Control handle 

	nControlHandle := _HMG_SYSDATA [3] [i]


	* Process According Control Type

	If cControlType == 'GRID' .Or. cControlType == 'MULTIGRID' 

		* Get Header Justify Array

		aHeadersJustify := _HMG_SYSDATA [ 37 ] [i] 

	        * Get Header Images Array *
	
		aHeaderImages := _HMG_SYSDATA [ 22 ] [i] 

		* Get Header ImageList Handle *

		nHeaderImageListHandle := _HMG_SYSDATA [ 26 ] [i] 

		* Destroy Current ImageList *

		IMAGELIST_DESTROY ( nHeaderImageListHandle ) 

		* Updete aHeaderImages Specified Column With The New Image *

		aHeaderImages [ nColumn ] := cImage 

		_HMG_SYSDATA [ 22 ] [i] := aHeaderImages

		* Set New Image *

		nHeaderImageListHandle := SetListViewHeaderImages ( nControlHandle , aHeaderImages , aHeadersJustify )

		* Update ImageList Handle in Control Data Array *

		_HMG_SYSDATA [ 26 ] [i] := nHeaderImageListHandle

	#ifdef COMPILEBROWSE

	ElseIf cControlType == 'BROWSE'

		* Get Header Justify Array

		aHeadersJustify := _HMG_SYSDATA [ 39 ] [i] [11]

	        * Get Header Images Array *
	
		aHeaderImages := _HMG_SYSDATA [ 39 ] [i] [9]

		* Get Header ImageList Handle *

		nHeaderImageListHandle := _HMG_SYSDATA [ 39 ] [i] [10]

		* Destroy Current ImageList *

		IMAGELIST_DESTROY ( nHeaderImageListHandle ) 

		* Updete aHeaderImages Specified Column With The New Image *

		aHeaderImages [ nColumn ] := cImage 

		_HMG_SYSDATA [ 39 ] [i] [9] := aHeaderImages

		* Set New Image *

		nHeaderImageListHandle := SetListViewHeaderImages ( nControlHandle , aHeaderImages , aHeadersJustify )

		* Update ImageList Handle in Control Data Array *

		_HMG_SYSDATA [ 39 ] [i] [10] := nHeaderImageListHandle

	#endif

	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _HMG_GetHeaderImages ( cControlName, cParentForm , nColumn )
*-----------------------------------------------------------------------------*
Local i , aHeaderImages
Local cControlType
Local cRetVal


	* Get Control Type *

	cControlType := GetControlType (cControlName,cParentForm)

	* Get Control Index *

	i := GetControlIndex ( cControlName, cParentForm )


	* Process According Control Type

	If cControlType == 'GRID' .Or. cControlType == 'MULTIGRID' 

	        * Get Header Images Array *
	
		aHeaderImages := _HMG_SYSDATA [ 22 ] [i] 

		cRetVal := aHeaderImages [ nColumn ]

	#ifdef COMPILEBROWSE

	ElseIf cControlType == 'BROWSE'

	        * Get Header Images Array *
	
		aHeaderImages := _HMG_SYSDATA [ 39 ] [i] [9]

		cRetVal := aHeaderImages [ nColumn ]

	#endif

	EndIf


Return cRetVal

*------------------------------------------------------------------------------*
Function SetProperty ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )
*------------------------------------------------------------------------------*
Local i
Local cMacro
Local k

	if Pcount() == 3 // Window

		Arg2 := Upper (Arg2)

		For i := 1 To Len ( _HMG_SYSDATA [61] )
			If Arg2 == _HMG_SYSDATA [61] [i] [1]
				cMacro := _HMG_SYSDATA [61] [i] [2]
				&cMacro ( Arg1 , Arg2 , Arg3 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If .Not. _IsWindowDefined ( Arg1 )
			MsgHMGError("Window: "+ Arg1 + " is not defined. Program terminated" )
		Endif

		if Arg2 == 'TITLE'

			SetWindowText ( GetFormHandle( Arg1 ) , Arg3 ) 

		ELseIf Arg2 == 'HEIGHT'

			_SetWindowSizePos ( Arg1 , , , , Arg3 )      

		ElseIf Arg2 == 'WIDTH'

			_SetWindowSizePos ( Arg1 , , , Arg3 , )      

		ElseIf Arg2 == 'COL'

			_SetWindowSizePos ( Arg1 , , Arg3 , , )      

		ElseIf Arg2 == 'ROW'

			_SetWindowSizePos ( Arg1 , Arg3 , , , )      

		ElseIf Arg2 == 'NOTIFYICON'

			_SetNotifyIconName ( Arg1 , Arg3 )           

		ElseIf Arg2 == 'NOTIFYTOOLTIP'

			_SetNotifyIconTooltip ( Arg1 , Arg3 ) 	  

		ElseIf Arg2 == 'CURSOR'

			SetWindowCursor ( GetFormHandle( Arg1 ) , Arg3 ) 

		EndIf

	ElseIf Pcount() == 4 // CONTROL

		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [61] )
			If Arg3 == _HMG_SYSDATA [61] [i] [1]
				cMacro := _HMG_SYSDATA [61] [i] [2]
				&cMacro ( Arg1 , Arg2 , Arg3 , Arg4 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				
			Endif
		Next i

		If .Not. _IsControlDefined ( Arg2 , Arg1  )
			MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
		endif

		If     Arg3 == 'VALUE'

			_SetValue ( Arg2 , Arg1 , Arg4 )



		ElseIf Arg3 == 'ALLOWEDIT'

		#ifdef COMPILEBROWSE

			_SetBrowseAllowEdit ( Arg2 , Arg1 , Arg4 )	

		#endif

		ElseIf Arg3 == 'RECNO'

			SetDataGridRecNo ( GetControlIndex ( Arg2 , Arg1 ) , Arg4 )

		ElseIf Arg3 == 'ALLOWAPPEND'

			#ifdef COMPILEBROWSE

			_SetBrowseAllowAppend ( Arg2 , Arg1 , Arg4 )	

			#endif

		ElseIf Arg3 == 'ALLOWDELETE'

			#ifdef COMPILEBROWSE

			_SetBrowseAllowDelete ( Arg2 , Arg1 , Arg4 )	

			#endif

		ElseIf Arg3 == 'PICTURE'

			_SetPicture ( Arg2 , Arg1 , Arg4 )	

		ElseIf Arg3 == 'TOOLTIP'

			_SetTooltip ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'FONTNAME'

			_SetFontName ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'FONTSIZE'

			_SetFontSize ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'FONTBOLD'

			_SetFontBold ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'FONTITALIC'

			_SetFontItalic ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'FONTUNDERLINE'

			_SetFontUnderline ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'FONTSTRIKEOUT'

			_SetFontStrikeout ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'CAPTION'

			IF GetControlType ( Arg2 , Arg1 ) == 'TOOLBUTTON'

				k := GetControlIndex ( Arg2 , Arg1 )

				SetToolButtonCaption ( _HMG_SYSDATA [26] [k] , _HMG_SYSDATA [5] [k] , Arg4 )

				_HMG_SYSDATA [33] [k] := Arg4

			Else

				SetWindowText ( GetControlHandle( Arg2 , Arg1 ) , Arg4 )

			EndIf

		ElseIf Arg3 == 'DISPLAYVALUE'

			SetWindowText ( GetControlHandle( Arg2 , Arg1 ) , Arg4 )

		ElseIf Arg3 == 'ROW'

			_SetControlRow ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'COL'

			_SetControlCol ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'WIDTH'

			_SetControlWidth ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'HEIGHT'

			_SetControlHeight ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'VISIBLE'

			iif ( Arg4 == .t. , _ShowControl ( Arg2 , Arg1 ) , _HideControl ( Arg2 , Arg1 ) ) 

		ElseIf Arg3 == 'ENABLED'

			iif ( Arg4 == .t. , _EnableControl ( Arg2 , Arg1 ) , _DisableControl ( Arg2 , Arg1 ) ) 

		ElseIf Arg3 == 'CHECKED'

			iif ( Arg4 == .t. , _CheckMenuItem ( Arg2 , Arg1 ) , _UnCheckMenuItem ( Arg2 , Arg1 ) )

		ElseIf Arg3 == 'RANGEMIN'

			_SetRangeMin ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'RANGEMAX'

			_SetRangeMax ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'REPEAT'

			If Arg4 == .t.
				_SetPlayerRepeatOn ( Arg2 , Arg1 ) 
			Else
				_SetPlayerRepeatOff ( Arg2 , Arg1 ) 
			EndIf

		ElseIf Arg3 == 'SPEED'

			_SetPlayerSpeed ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'VOLUME'

			_SetPlayerVolume ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'ZOOM'

			_SetPlayerZoom ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'POSITION'

			If Arg4 == 0
				_SetPlayerPositionHome ( Arg2 , Arg1 ) 
			ElseIf Arg4 == 1
				_SetPlayerPositionEnd ( Arg2 , Arg1 ) 
			EndIf

		ElseIf Arg3 == 'CARETPOS'

			_SetCaretPos ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'BACKCOLOR'

			_SetBackColor ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'FONTCOLOR'

			_SetFontColor ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'FORECOLOR'

			_SetFontColor ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'ADDRESS'

			_SetAddress ( Arg2 , Arg1 , Arg4 ) 

		#ifdef COMPILEBROWSE

		ElseIf Arg3 == 'INPUTITEMS'

			_SetBrowseInputItems ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'DISPLAYITEMS'

			_SetBrowseDisplayItems ( Arg2 , Arg1 , Arg4 ) 

		#endif

		ElseIf Arg3 == 'READONLY'

			IF GetControlType ( Arg2 , Arg1 ) == 'RADIOGROUP'

				_SetRadioGroupReadOnly ( Arg2 , Arg1 , Arg4 )

			Else

				SetTextEditReadOnly ( GetControlHandle( Arg2 , Arg1 ) , Arg4 )	

			EndIf

		ElseIf Arg3 == 'ITEMCOUNT'

			ListView_SetItemCount ( GetControlHandle ( Arg2 , Arg1 ) , Arg4 ) 

		EndIf

	ElseIf Pcount() == 5	// CONTROL WITH ARGUMENT, TOOLBAR BUTTON OR
				// SPLITBOX CHILD CONTROL WITHOUT ARGUMENT

		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [61] )
			If Arg3 == _HMG_SYSDATA [61] [i] [1]
				cMacro := _HMG_SYSDATA [61] [i] [2]
				&cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If     Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		EndIf

		If     Arg3 == 'CAPTION'

			If .Not. _IsControlDefined ( Arg2 , Arg1  )
				MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
			endif

			_SetMultiCaption ( Arg2 , Arg1 , Arg4 , Arg5 )


		ElseIf Arg3 == 'HEADER'

			If .Not. _IsControlDefined ( Arg2 , Arg1  )
				MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
			endif

			_SetMultiCaption ( Arg2 , Arg1 , Arg4 , Arg5 )


		ElseIf Arg3 == 'HEADERIMAGES'

			If .Not. _IsControlDefined ( Arg2 , Arg1  )
				MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
			endif

			_HMG_SetHeaderImages ( Arg2 , Arg1 , Arg4 , Arg5  )


		ElseIf Arg3 == 'ITEM'

			If .Not. _IsControlDefined ( Arg2 , Arg1  )
				MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
			endif

			_SetItem ( Arg2 , Arg1 , Arg4 , Arg5 ) 

		ElseIf Arg3 == 'ICON'

			If .Not. _IsControlDefined ( Arg2 , Arg1  )
				MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
			endif

			_SetStatusIcon ( Arg2 , Arg1 , Arg4 , Arg5 ) 

		Else 
			// If Property Not Matched Look For ToolBar Button

			If GetControlType ( Arg2 , Arg1 ) == 'TOOLBAR' 

				If GetControlHandle ( Arg2 , Arg1 ) != GetControlContainerHandle ( Arg3 , Arg1 )
					MsgHMGError('Control Does Not Belong To Container')
				EndIf

				SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )
			EndIf

		EndIf

	ElseIf Pcount() == 6	// TAB CHILD CONTROL, 
				// SPLITBOX CHILD WITH 1 ARGUMENT
				// OR SPLITCHILD TOOLBAR BUTTON

		If     Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )
				Return Nil
			Else
				If _IsControlDefined ( Arg4 , Arg1 )

					If _IsControlSplitBoxed ( Arg4 , Arg1 )

						SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )
						Return Nil

					Else
						MsgHMGError('Control Does Not Belong To Container')
					EndIf
				Else
					MsgHMGError('Control Does Not Belong To Container')
				EndIf

			EndIf

		EndIf

		If ValType (Arg3) = 'C'

			Arg3 := Upper (Arg3)

			If     Arg3 == 'CELL'

				If .Not. _IsControlDefined ( Arg2 , Arg1  )
					MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
				endif
		
				_HMG_SETGRIDCELLVALUE ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 )

				Return Nil

			EndIf

		EndIf

		If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
			MsgHMGError('Control Does Not Belong To Container')
		EndIf

		SetProperty ( Arg1 , Arg4 , Arg5 , Arg6 ) 		

	ElseIf Pcount() == 7	// TAB CHILD CONTROL WITH 1 ARGUMENT OR
				// SPLITBOX WITH 2 ARGUMENTS

		If     Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		EndIf

		If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
			MsgHMGError('Control Does Not Belong To Container')
		EndIf

		SetProperty ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 ) 

	ElseIf Pcount() == 8 // TAB CHILD CONTROL WITH 2 ARGUMENTS

		If     Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				SetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		EndIf

		If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
			MsgHMGError('Control Does Not Belong To Container')
		EndIf

		SetProperty ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 ) 

	EndIf

Return Nil
*------------------------------------------------------------------------------*
Function GetProperty ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
*------------------------------------------------------------------------------*
Local RetVal
Local i
Local cMacro
Local tRetVal

	if Pcount() == 2 // WINDOW

		If .Not. _IsWindowDefined ( Arg1 )
			MsgHMGError("Window: "+ Arg1 + " is not defined. Program terminated" )
		Endif

		Arg2 := Upper (Arg2)

		For i := 1 To Len ( _HMG_SYSDATA [61] )
			If Arg2 == _HMG_SYSDATA [61] [i] [1]
				cMacro := _HMG_SYSDATA [61] [i] [3]
				tRetVal := &cMacro ( Arg1 , Arg2 )

				If _HMG_SYSDATA [63] == .T.
					Return tRetVal
				EndIf				

			Endif
		Next i

		if Arg2 == 'TITLE'

			RetVal := GetWindowText ( GetFormHandle( Arg1 ) ) 	  

		ELseIf Arg2 == 'FOCUSEDCONTROL'

			RetVal := _GetFocusedControl ( Arg1 )

		ELseIf Arg2 == 'NAME'

			RetVal := GetFormName ( Arg1 )    

		ELseIf Arg2 == 'HEIGHT'

			RetVal := GetWindowHeight ( GetFormHandle ( Arg1 ) )    

		ElseIf Arg2 == 'WIDTH'

			RetVal := GetWindowWidth ( GetFormHandle ( Arg1 ) )     

		ElseIf Arg2 == 'COL'

			RetVal := GetWindowCol ( GetFormHandle ( Arg1 ) )       

		ElseIf Arg2 == 'ROW'

			RetVal := GetWindowRow ( GetFormHandle ( Arg1 ) )

		ElseIf Arg2 == 'NOTIFYICON'

			RetVal := _GetNotifyIconName ( Arg1 )	                  

		ElseIf Arg2 == 'NOTIFYTOOLTIP'

			RetVal := _GetNotifyIconTooltip ( Arg1 )                

		EndIf

	ElseIf Pcount() == 3 // CONTROL

		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [61] )
			If Arg3 == _HMG_SYSDATA [61] [i] [1]
				cMacro := _HMG_SYSDATA [61] [i] [3]
				tRetVal := &cMacro ( Arg1 , Arg2 , Arg3 )

				If _HMG_SYSDATA [63] == .T.
					Return tRetVal
				EndIf				

			Endif

		Next i

		If ( Upper(Arg2) == 'VSCROLLBAR' .Or. Upper(Arg2) == 'HSCROLLBAR' ) 

			If .Not. _IsWindowDefined ( Arg1 )
				MsgHMGError("Window: "+ Arg1 + " is not defined. Program terminated" )
			Endif

		Else

			If .Not. _IsControlDefined ( Arg2 , Arg1  )
				MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
			endif

		EndIf


		If     Arg3 == 'VALUE'

			RetVal := _GetValue ( Arg2 , Arg1 )

		ElseIf Arg3 == 'RECNO'

			RetVal := GetDataGridRecno ( GetControlIndex ( Arg2 , Arg1 ) )

		ElseIf Arg3 == 'NAME'

			RetVal := GetControlName ( Arg2 , Arg1 )

		ElseIf Arg3 == 'ALLOWEDIT'

			#ifdef COMPILEBROWSE

			RetVal := _GetBrowseAllowEdit ( Arg2 , Arg1 )

			#endif

		ElseIf Arg3 == 'INPUTITEMS'

			#ifdef COMPILEBROWSE

			RetVal := _GetBrowseInputItems ( Arg2 , Arg1 )

			#endif

		ElseIf Arg3 == 'DISPLAYITEMS'

			#ifdef COMPILEBROWSE

			RetVal := _GetBrowseDisplayItems ( Arg2 , Arg1 )

			#endif

		ElseIf Arg3 == 'ALLOWAPPEND'

			#ifdef COMPILEBROWSE

			RetVal := _GetBrowseAllowAppend ( Arg2 , Arg1 )	

			#endif

		ElseIf Arg3 == 'ALLOWDELETE'

			#ifdef COMPILEBROWSE

			RetVal := _GetBrowseAllowDelete ( Arg2 , Arg1 )	

			#endif

		ElseIf Arg3 == 'PICTURE'

			RetVal := _GetPicture ( Arg2 , Arg1 )

		ElseIf Arg3 == 'TOOLTIP'

			RetVal := _GetTooltip ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'FONTNAME'

			RetVal := _GetFontName ( Arg2 , Arg1 )

		ElseIf Arg3 == 'FONTSIZE'

			RetVal := _GetFontSize ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'FONTBOLD'

			RetVal := _GetFontBold ( Arg2 , Arg1 )

		ElseIf Arg3 == 'FONTITALIC'

			RetVal := _GetFontItalic ( Arg2 , Arg1 )

		ElseIf Arg3 == 'FONTUNDERLINE'

			RetVal := _GetFontUnderline ( Arg2 , Arg1 )

		ElseIf Arg3 == 'FONTSTRIKEOUT'

			RetVal := _GetFontStrikeout ( Arg2 , Arg1 )

		ElseIf Arg3 == 'CAPTION'

			RetVal := _GetCaption ( Arg2 , Arg1 )

		ElseIf Arg3 == 'DISPLAYVALUE'

			RetVal := GetWindowText ( GetControlHandle ( Arg2 , Arg1 ) ) 

		ElseIf Arg3 == 'ROW'

			RetVal := _GetControlRow ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'COL'

			RetVal := _GetControlCol ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'WIDTH'

			RetVal := _GetControlWidth ( Arg2 , Arg1 )

		ElseIf Arg3 == 'HEIGHT'

			RetVal := _GetControlHeight ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'VISIBLE'

			RetVal := _IsControlVisible ( Arg2 , Arg1 )

		ElseIf Arg3 == 'ENABLED'

			RetVal := _IsControlEnabled ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'CHECKED'

			RetVal := _IsMenuItemChecked ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'ITEMCOUNT'

			RetVal := _GetItemCount ( Arg2 , Arg1 )

		ElseIf Arg3 == 'RANGEMIN'

			RetVal := _GetRangeMin ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'RANGEMAX'

			RetVal := _GetRangeMax ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'LENGTH'

			RetVal := _GetPlayerLength ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'POSITION'

			RetVal := _GetPlayerPosition ( Arg2 , Arg1 )

		ElseIf Arg3 == 'CARETPOS'

			RetVal := _GetCaretPos ( Arg2 , Arg1 )

		ElseIf Arg3 == 'BACKCOLOR'

			RetVal := _GetBackColor ( Arg2 , Arg1 )

		ElseIf Arg3 == 'FONTCOLOR'

			RetVal := _GetFontColor ( Arg2 , Arg1 )

		ElseIf Arg3 == 'FORECOLOR'

			RetVal := _GetFontColor ( Arg2 , Arg1 )

		ElseIf Arg3 == 'ADDRESS'

			RetVal := _GetAddress ( Arg2 , Arg1 )

		ElseIf Arg3 == 'OBJECT'

			RetVal := _GetControlObject ( Arg2 , Arg1 )

		ElseIf Arg3 == 'READONLY'

			IF GetControlType ( Arg2 , Arg1 ) == 'RADIOGROUP'

				RetVal := _GetRadioGroupReadOnly ( Arg2 , Arg1 )

			Else

				RetVal := NIL

			EndIf

		EndIf

	ElseIf Pcount() == 4	// CONTROL WITH ARGUMENT, TOOLBAR BUTTON
				// OR SPLITBOX CHILD WITHOUT ARGUMENT

		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				RetVal := GetProperty ( Arg1 , Arg3 , Arg4 )
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		Else

			Arg3 := Upper (Arg3)

			If     Arg3 == 'ITEM'

				If .Not. _IsControlDefined ( Arg2 , Arg1  )
					MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
				endif

				RetVal := _GetItem (  Arg2 , Arg1 , Arg4 ) 

			ElseIf Arg3 == 'CAPTION'

				If .Not. _IsControlDefined ( Arg2 , Arg1  )
					MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
				endif

				RetVal := _GetMultiCaption ( Arg2 , Arg1 , Arg4 )  

			ElseIf Arg3 == 'HEADER'

				If .Not. _IsControlDefined ( Arg2 , Arg1  )
					MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
				endif

				RetVal := _GetMultiCaption ( Arg2 , Arg1 , Arg4 )  

			ElseIf Arg3 == 'HEADERIMAGES'

				If .Not. _IsControlDefined ( Arg2 , Arg1  )
					MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
				endif

				RetVal := _HMG_GetHeaderImages ( Arg2 , Arg1 , Arg4 )  

			Else

				// If Property Not Matched Look For Contained Control
				// With No Arguments (ToolBar Button)

				If	GetControlType ( Arg2 , Arg1 ) == 'TOOLBAR' 

					If GetControlHandle ( Arg2 , Arg1 ) != GetControlContainerHandle ( Arg3 , Arg1 )
						MsgHMGError('Control Does Not Belong To Container')
					EndIf

					RetVal := GetProperty ( Arg1 , Arg3 , Arg4 )

				EndIf

			EndIf

		EndIf

	ElseIf Pcount() == 5	// TAB CHILD CONTROL (WITHOUT ARGUMENT)
				// OR SPLITBOX CHILD WITH ARGUMENT

		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )
			Else
				If _IsControlDefined ( Arg4 , Arg1 )

					If _IsControlSplitBoxed ( Arg4 , Arg1 )

						RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 )

					Else

						MsgHMGError('Control Does Not Belong To Container')

					EndIf
					
				Else

					MsgHMGError('Control Does Not Belong To Container')

				EndIf

			EndIf

		Else

			If ValType ( Arg3 ) = 'C'

				Arg3 := Upper (Arg3)

				If     Arg3 == 'CELL'
					Return ( _HMG_GETGRIDCELLVALUE ( Arg2 , Arg1 , Arg4 , Arg5 ) )
				Endif

			EndIf

			If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

			RetVal := GetProperty ( Arg1 , Arg4 , Arg5 )

		EndIf

	ElseIf Pcount() == 6	// TAB CHILD CONTROL (WITH 1 ARGUMENT
				// OR SPLITBOX CHILD WITH 2 ARGUMENT 
		
		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		Else

			If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

			RetVal := GetProperty ( Arg1 , Arg4 , Arg5 , Arg6 )

		EndIf

	ElseIf Pcount() == 7	// TAB CHILD CONTROL (WITH 2 ARGUMENT
				// OR SPLITBOX CHILD WITH 3 ARGUMENT

		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				RetVal := GetProperty ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		Else

			If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

			RetVal := GetProperty ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

		EndIf

	EndIf

Return RetVal

*------------------------------------------------------------------------------*
Function GetControlTabPage ( cControlName , cTabName , cParentWindowName )
*------------------------------------------------------------------------------*
Local r , c , z , j , a
Local aPageMap
Local niTab 
Local niControl 
Local xControlHandle
Local nRetVal := 0


	niTab		:= GetControlIndex ( cTabName , cParentWindowName )	
	niControl	:= GetControlIndex ( cControlName , cParentWindowName )	

	xControlHandle	:= _HMG_SYSDATA [ 3 ] [ niControl ]
	aPageMap	:= _HMG_SYSDATA [ 7 ] [ niTab ]

	For r = 1 to len ( aPageMap )

		For c = 1 To Len ( aPageMap [r])

			If	ValType ( aPageMap [r] [c] ) == 'N' ;
				.And. ;
				ValType (xControlHandle) == 'N'

				If aPageMap [r] [c] == xControlHandle

					nRetVal := r 
					Exit

				EndIf

                	ElseIf	ValType ( aPageMap [r] [c] ) == "A" ;
				.And. ;
				ValType ( xControlHandle ) == "A"

				For j := 1 To Len ( xControlHandle )

					a := aScan ( aPageMap [r] [c] , xControlHandle [j] )

					If a <> 0					
						nRetVal := r
						Exit
					EndIf

				Next j

				If nRetVal <> 0
					Exit
				EndIf

                	ElseIf	ValType ( aPageMap [r] [c] ) == "A" ;
				.And. ;
				ValType ( xControlHandle ) == "N"

				a := aScan ( aPageMap [r] [c] , xControlHandle )

				If a <> 0					
					nRetVal := r
					Exit
				EndIf

	                EndIf

		Next c

		If nRetVal <> 0
			Exit
		EndIf

	Next r

Return nRetVal

*------------------------------------------------------------------------------*
Function DoMethod ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 , Arg9 )
*------------------------------------------------------------------------------*
Local i
Local cMacro

	if Pcount() == 2 // Window

		Arg2 := Upper (Arg2)

		For i := 1 To Len ( _HMG_SYSDATA [62] )

			If Arg2 == _HMG_SYSDATA [62] [i] [1]

				cMacro := _HMG_SYSDATA [62] [i] [2]

				&cMacro ( Arg1 , Arg2 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If ValType ( Arg1 ) == 'C'
			If .Not. _IsWindowDefined ( Arg1 )
				MsgHMGError("Window: "+ Arg1 + " is not defined. Program terminated" )
			Endif
		EndIf

		if Arg2 == 'ACTIVATE'

			if ValType ( Arg1 ) == 'A'
				_ActivateWindow ( Arg1 )          	  
			Else
				_ActivateWindow ( { Arg1 } )          	  
			EndIf

		ELseIf Arg2 == 'CENTER'

			_CenterWindow ( Arg1 )                 	  

		ElseIf Arg2 == 'RELEASE'

			_ReleaseWindow ( Arg1 )                 	  

		ElseIf Arg2 == 'MAXIMIZE'

			_MaximizeWindow ( Arg1 )               	  

		ElseIf Arg2 == 'MINIMIZE'

			_MinimizeWindow ( Arg1 )               	  

		ElseIf Arg2 == 'RESTORE'

			_RestoreWindow ( Arg1 )

		ElseIf Arg2 == 'SHOW'

			_ShowWindow ( Arg1 )

		ElseIf Arg2 == 'HIDE'

			_HideWindow ( Arg1 )          

		ElseIf Arg2 == 'SETFOCUS'

			i := GetFormIndex ( Arg1 )

			if i >= 1  .and. i <= Len (_HMG_SYSDATA [ 67  ] )

				If _HMG_SYSDATA [ 68  ] [i] == .T.
					setfocus ( _HMG_SYSDATA [ 67  ] [i] )
				EndIf

			EndIf

		ElseIf Arg2 == 'PRINT'

			PrintWindow ( Arg1 )

		ElseIf Arg2 == 'CAPTURE'

			SaveWindow ( Arg1 )

		EndIf

	ElseIf Pcount() == 3 // CONTROL

		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [62] )

			If Arg3 == _HMG_SYSDATA [62] [i] [1]

				cMacro := _HMG_SYSDATA [62] [i] [2]

				&cMacro ( Arg1 , Arg2 , Arg3 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If .Not. _IsControlDefined ( Arg2 , Arg1  )
			MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
		endif

		If     Arg3 == 'REFRESH'

			_Refresh ( GetControlIndex ( Arg2 , Arg1 ) ) ;;

		ElseIf Arg3 == 'SAVE'

			_SaveData (Arg2 , Arg1)

		ElseIf Arg3 == 'CLEARBUFFER'

			DataGridClearBuffer ( GetControlIndex (Arg2 , Arg1) )

		ElseIf Arg3 == 'DISABLEUPDATE'

			_HMG_SYSDATA [ 40 ] [ GetControlIndex (Arg2 , Arg1) ] [ 33 ] := .F.

		ElseIf Arg3 == 'ENABLEUPDATE'

			_HMG_SYSDATA [ 40 ] [ GetControlIndex (Arg2 , Arg1) ] [ 33 ] := .T.

		ElseIf Arg3 == 'APPEND'

			DataGridAppend( GetControlIndex (Arg2 , Arg1) )

		ElseIf Arg3 == 'DELETE'

			DataGridDelete( GetControlIndex (Arg2 , Arg1) )

		ElseIf Arg3 == 'RECALL'

			DataGridRecall( GetControlIndex (Arg2 , Arg1) )

		ElseIf Arg3 == 'SETFOCUS'

			_SetFocus ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'ACTION'

			Eval ( _GetControlAction ( Arg2 , Arg1 ) )

		ElseIf Arg3 == 'ONCLICK'

			Eval ( _GetControlAction ( Arg2 , Arg1 ) )

		ElseIf Arg3 == 'DELETEALLITEMS'

			_DeleteAllItems ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'RELEASE'

			_ReleaseControl ( Arg2 , Arg1 )

		ElseIf Arg3 == 'SHOW'

			_ShowControl ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'HIDE'

			_HideControl ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'PLAY'

			iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" ,  _PlayAnimateBox ( Arg2 , Arg1 )  , _PlayPlayer ( Arg2 , Arg1 ) ) 

		ElseIf Arg3 == 'STOP'

			iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" ,  _StopAnimateBox ( Arg2 , Arg1 )  , _StopPlayer ( Arg2 , Arg1 ) )

		ElseIf Arg3 == 'CLOSE'

			iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" ,  _CloseAnimateBox ( Arg2 , Arg1 )  , _ClosePlayer ( Arg2 , Arg1 ) ) 

		ElseIf Arg3 == 'PLAYREVERSE'

			_PlayPlayerReverse ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'PAUSE'

			_PausePlayer ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'EJECT'

			_EjectPlayer ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'OPENDIALOG'

			_OpenPlayerDialog ( Arg2 , Arg1 ) 

		ElseIf Arg3 == 'RESUME'

			_ResumePlayer ( Arg2 , Arg1 ) 

		EndIf

	ElseIf Pcount() == 4	// CONTROL WITH 1 ARGUMENT
				// OR SPLITBOX CHILD WITHOUT ARGUMENT


		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [62] )

			If Arg3 == _HMG_SYSDATA [62] [i] [1]

				cMacro := _HMG_SYSDATA [62] [i] [2]
				&cMacro ( Arg1 , Arg2 , Arg3 , Arg4 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If Upper(Arg2) == 'SPLITBOX'
			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				DoMethod( Arg1 , Arg3 , Arg4 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf
		EndIf

		If .Not. _IsControlDefined ( Arg2 , Arg1  )
			MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
		endif

		If     Arg3 == 'DELETEITEM'

			_DeleteItem ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'DELETEPAGE'

			_DeleteTabPage ( Arg2 , Arg1 , Arg4 )

		ElseIf Arg3 == 'REFRESH'

			DataGridRefresh ( GetControlIndex ( Arg2 , Arg1 ) , Arg4 )

		ElseIf Arg3 == 'OPEN'

			iif ( GetControlType ( Arg2 , Arg1 ) == "ANIMATEBOX" ,  _OpenAnimateBox ( Arg2 , Arg1 , Arg4 )  , _OpenPlayer ( Arg2 , Arg1 , Arg4 ) ) 

		ElseIf Arg3 == 'SEEK'

			_SeekAnimateBox ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'ADDITEM'

			_AddItem ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'EXPAND'

			_Expand ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'COLLAPSE'

			_Collapse ( Arg2 , Arg1 , Arg4 ) 

		ElseIf Arg3 == 'DELETECOLUMN'

			_DeleteGridColumn ( Arg2 , Arg1 , Arg4 ) 

		EndIf

	ElseIf Pcount() == 5 .And. ValType (Arg3) == 'C'

		 // CONTROL WITH 2 ARGUMENTS
		//  OR SPLITBOX CHILD WITH 1 ARGUMENT

		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [62] )

			If Arg3 == _HMG_SYSDATA [62] [i] [1]

				cMacro := _HMG_SYSDATA [62] [i] [2]
				&cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If Upper(Arg2) == 'SPLITBOX'
			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				DoMethod( Arg1 , Arg3 , Arg4 , Arg5 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf
		EndIf

		If .Not. _IsControlDefined ( Arg2 , Arg1  )
			MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
		endif

		If     Arg3 == 'ADDITEM'

			_AddItem ( Arg2 , Arg1 , Arg4 , Arg5 ) 

		ElseIf Arg3 == 'ADDPAGE'

			_AddTabPage ( Arg2 , Arg1 , Arg4 , Arg5 ) 

		EndIf

	ElseIf Pcount()=5  .And. ValType (Arg3)=='N' 

		// TAB CHILD WITHOUT ARGUMENTS

		If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
			MsgHMGError('Control Does Not Belong To Container')
		EndIf

		DoMethod ( Arg1 , Arg4 , Arg5 )

	ElseIf Pcount() == 6 .And. ValType (Arg3) == 'C'

		// CONTROL WITH 3 ARGUMENTS
		// OR SPLITBOX CHILD WITH 2 ARGUMENTS

		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [62] )

			If Arg3 == _HMG_SYSDATA [62] [i] [1]

				cMacro := _HMG_SYSDATA [62] [i] [2]
				&cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		EndIf

		If .Not. _IsControlDefined ( Arg2 , Arg1  )
			MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
		endif

		If     Arg3 == 'ADDITEM'

			_AddItem ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 ) 

		ElseIf Arg3 == 'ADDPAGE'

			_AddTabPage ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 ) 

		EndIf

	ElseIf Pcount() == 6 .And. ValType (Arg3) == 'N'
		// TAB CHILD WITH 1 ARGUMENT

		If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
			MsgHMGError('Control Does Not Belong To Container')
		EndIf

		DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 )

	ElseIf Pcount() == 7 .And. Upper(Arg2) == 'CAPTURE'

		SaveWindow ( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )

	ElseIf Pcount() == 7 .And. ValType (Arg3) == 'C'

		// CONTROL WITH 4 ARGUMENTS
		// OR SPLITBOX CHILD WITH 3 ARGUMENTS

		Arg3 := Upper (Arg3)

		For i := 1 To Len ( _HMG_SYSDATA [62] )

			If Arg3 == _HMG_SYSDATA [62] [i] [1]

				cMacro := _HMG_SYSDATA [62] [i] [2]
				&cMacro ( Arg1 , Arg2 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )

				If _HMG_SYSDATA [63] == .T.
					Return NIL
				EndIf				

			Endif

		Next i

		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		EndIf

		If .Not. _IsControlDefined ( Arg2 , Arg1  )
			MsgHMGError ("Control: " + Arg2 + " Of " + Arg1 + " Not defined. Program Terminated" )
		endif

		If     Arg3 == 'ADDCONTROL'

			_AddTabControl ( Arg2 , Arg4 , Arg1 , Arg5 , Arg6 , Arg7 )

		ElseIf     Arg3 == 'ADDCOLUMN'

			_AddGridColumn ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

		ElseIf     Arg3 == 'ADDITEM'

			_AddItem ( Arg2 , Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

		EndIf

	ElseIf Pcount() == 7 .And. ValType (Arg3) == 'N'

		// TAB CHILD WITH 2 ARGUMENTS

		If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
			MsgHMGError('Control Does Not Belong To Container')
		EndIf

		DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 )

	ElseIf Pcount() == 8 

		// TAB CHILD WITH 3 ARGUMENTS
		// OR SPLITBOX CHILD WITH 4 ARGUMENTS

		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		EndIf

		If ValType (Arg3) == 'N'

			If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

			DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 )

		EndIf

	ElseIf Pcount() == 9
		// TAB CHILD WITH 4 ARGUMENTS
		// OR SPLITBOX CHILD WITH 5 ARGUMENTS

		If Upper(Arg2) == 'SPLITBOX'

			If _IsControlSplitBoxed ( Arg3 , Arg1 )
				DoMethod( Arg1 , Arg3 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 , Arg9 )
				Return Nil
			Else
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

		EndIf

		If ValType (Arg3) == 'N'

			If GetControlTabPage ( Arg4 , Arg2 , Arg1 ) <> Arg3
				MsgHMGError('Control Does Not Belong To Container')
			EndIf

			DoMethod ( Arg1 , Arg4 , Arg5 , Arg6 , Arg7 , Arg8 , Arg9 )

		EndIf

	EndIf

Return Nil

*-----------------------------------------------------------------------------*
Function _IsControlSplitBoxed ( cControlName , cWindowName )
*-----------------------------------------------------------------------------*
Local lSplitBoxed := .F.
Local i

	i := GetControlIndex ( cControlName, cWindowName )

	If i > 0

		If	ValType ( _HMG_SYSDATA [18] [i] ) == 'U' ;
			.And. ;
			ValType ( _HMG_SYSDATA [19] [i] ) == 'U' ;

			lSplitBoxed := .T.

		EndIf

	EndIf

Return lSplitBoxed


/*
 * Harbour Project source code:
 * DLL access functions
 *
 * Copyright 2005 Vic McClung
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site http://www.gnu.org/).
 *
 * As a special exception, the Harbour Project gives permission for
 * additional uses of the text contained in its release of Harbour.
 *
 * The exception is that, if you link the Harbour libraries with other
 * files to produce an executable, this does not by itself cause the
 * resulting executable to be covered by the GNU General Public License.
 * Your use of that executable is in no way restricted on account of
 * linking the Harbour library code into it.
 *
 * This exception does not however invalidate any other reasons why
 * the executable file might be covered by the GNU General Public License.
 *
 * This exception applies only to the code released by the Harbour
 * Project under the name Harbour.  If you copy code from other
 * Harbour Project or Free Software Foundation releases into a copy of
 * Harbour, as the General Public License permits, the exception does
 * not apply to the code that you add in this way.  To avoid misleading
 * anyone as to the status of such modified files, you must delete
 * this exception notice from them.
 *
 * If you write modifications of your own for Harbour, it is your choice
 * whether to permit this exception to apply to your modifications.
 * If you do not wish that, delete this exception notice.
 *
 */

#define MAX_PARAMS   8

function CALLDLL32(p1,p2,p3,p4,p5,p6,p7,p8,p9,p10)
local aPass := array(11)
local aParms := HB_aParams()
local nParmCnt := LEN(aParms)
local i

	IF nParmCnt > MAX_PARAMS + 2
		return 0
	ENDIF

	aPass[1] := aParms[1]
	aPass[2] := aParms[2]
	aPass[3] := nParmCnt-2
	FOR i := 3 TO nParmCnt
		aPass[i+1] := IIF(valtype(aParms[i]) == "C", STRPTR(aParms[i]), aParms[i])
	NEXT

return HB_DynaCall1( aPass[1],aPass[2],aPass[3],aPass[4],aPass[5],aPass[6],aPass[7],aPass[8],aPass[9],aPass[10],aPass[11])




*-----------------------------------------------------------------------------*
Function _IsWindowVisibleFromHandle (Handle)
*-----------------------------------------------------------------------------*
Local x
Local lVisible := .f.

	For x := 1 To Len ( _HMG_SYSDATA [67] )

		If _HMG_SYSDATA [67] [x] == Handle
			lVisible := .Not. _HMG_SYSDATA [ 81 ] [x]
			Exit

		EndIf

	Next x

Return lVisible

Function GetFocusedControlType()
Local nHandle
Local cType
Local i

	cType := ''

	nHandle := GetFocus()
	
	For i := 1 To Len( _HMG_SYSDATA [3] )
		
		If ValType ( _HMG_SYSDATA [3] [i] ) == 'N'

			If _HMG_SYSDATA [3] [i] == nHandle 

				cType := _HMG_SYSDATA [1] [i]

			EndIf

		EndIf

	Next i

Return cType


